module Google
  module Ads
    module GoogleAds
      module Factories
        module V7
          module Enums
            # Returns the descriptor for the AdvertisingChannelSubType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AdvertisingChannelSubType enum
            def self.advertising_channel_sub_type
              require "google/ads/google_ads/v7/enums/advertising_channel_sub_type_pb"
              Google::Ads::GoogleAds::V7::Enums::AdvertisingChannelSubTypeEnum::AdvertisingChannelSubType.descriptor
            end

            # Returns the descriptor for the AdvertisingChannelType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AdvertisingChannelType enum
            def self.advertising_channel_type
              require "google/ads/google_ads/v7/enums/advertising_channel_type_pb"
              Google::Ads::GoogleAds::V7::Enums::AdvertisingChannelTypeEnum::AdvertisingChannelType.descriptor
            end

            # Returns the descriptor for the CriterionCategoryChannelAvailabilityMode enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CriterionCategoryChannelAvailabilityMode enum
            def self.criterion_category_channel_availability_mode
              require "google/ads/google_ads/v7/enums/criterion_category_channel_availability_mode_pb"
              Google::Ads::GoogleAds::V7::Enums::CriterionCategoryChannelAvailabilityModeEnum::CriterionCategoryChannelAvailabilityMode.descriptor
            end

            # Returns the descriptor for the CriterionCategoryLocaleAvailabilityMode enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CriterionCategoryLocaleAvailabilityMode enum
            def self.criterion_category_locale_availability_mode
              require "google/ads/google_ads/v7/enums/criterion_category_locale_availability_mode_pb"
              Google::Ads::GoogleAds::V7::Enums::CriterionCategoryLocaleAvailabilityModeEnum::CriterionCategoryLocaleAvailabilityMode.descriptor
            end

            # Returns the descriptor for the PlacementType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the PlacementType enum
            def self.placement_type
              require "google/ads/google_ads/v7/enums/placement_type_pb"
              Google::Ads::GoogleAds::V7::Enums::PlacementTypeEnum::PlacementType.descriptor
            end

            # Returns the descriptor for the PolicyTopicEntryType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the PolicyTopicEntryType enum
            def self.policy_topic_entry_type
              require "google/ads/google_ads/v7/enums/policy_topic_entry_type_pb"
              Google::Ads::GoogleAds::V7::Enums::PolicyTopicEntryTypeEnum::PolicyTopicEntryType.descriptor
            end

            # Returns the descriptor for the PolicyTopicEvidenceDestinationMismatchUrlType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the PolicyTopicEvidenceDestinationMismatchUrlType enum
            def self.policy_topic_evidence_destination_mismatch_url_type
              require "google/ads/google_ads/v7/enums/policy_topic_evidence_destination_mismatch_url_type_pb"
              Google::Ads::GoogleAds::V7::Enums::PolicyTopicEvidenceDestinationMismatchUrlTypeEnum::PolicyTopicEvidenceDestinationMismatchUrlType.descriptor
            end

            # Returns the descriptor for the PolicyTopicEvidenceDestinationNotWorkingDevice enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the PolicyTopicEvidenceDestinationNotWorkingDevice enum
            def self.policy_topic_evidence_destination_not_working_device
              require "google/ads/google_ads/v7/enums/policy_topic_evidence_destination_not_working_device_pb"
              Google::Ads::GoogleAds::V7::Enums::PolicyTopicEvidenceDestinationNotWorkingDeviceEnum::PolicyTopicEvidenceDestinationNotWorkingDevice.descriptor
            end

            # Returns the descriptor for the PolicyTopicEvidenceDestinationNotWorkingDnsErrorType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the PolicyTopicEvidenceDestinationNotWorkingDnsErrorType enum
            def self.policy_topic_evidence_destination_not_working_dns_error_type
              require "google/ads/google_ads/v7/enums/policy_topic_evidence_destination_not_working_dns_error_type_pb"
              Google::Ads::GoogleAds::V7::Enums::PolicyTopicEvidenceDestinationNotWorkingDnsErrorTypeEnum::PolicyTopicEvidenceDestinationNotWorkingDnsErrorType.descriptor
            end

            # Returns the descriptor for the FeedItemQualityApprovalStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FeedItemQualityApprovalStatus enum
            def self.feed_item_quality_approval_status
              require "google/ads/google_ads/v7/enums/feed_item_quality_approval_status_pb"
              Google::Ads::GoogleAds::V7::Enums::FeedItemQualityApprovalStatusEnum::FeedItemQualityApprovalStatus.descriptor
            end

            # Returns the descriptor for the FeedItemQualityDisapprovalReason enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FeedItemQualityDisapprovalReason enum
            def self.feed_item_quality_disapproval_reason
              require "google/ads/google_ads/v7/enums/feed_item_quality_disapproval_reason_pb"
              Google::Ads::GoogleAds::V7::Enums::FeedItemQualityDisapprovalReasonEnum::FeedItemQualityDisapprovalReason.descriptor
            end

            # Returns the descriptor for the FeedItemStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FeedItemStatus enum
            def self.feed_item_status
              require "google/ads/google_ads/v7/enums/feed_item_status_pb"
              Google::Ads::GoogleAds::V7::Enums::FeedItemStatusEnum::FeedItemStatus.descriptor
            end

            # Returns the descriptor for the FeedItemValidationStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FeedItemValidationStatus enum
            def self.feed_item_validation_status
              require "google/ads/google_ads/v7/enums/feed_item_validation_status_pb"
              Google::Ads::GoogleAds::V7::Enums::FeedItemValidationStatusEnum::FeedItemValidationStatus.descriptor
            end

            # Returns the descriptor for the GeoTargetingRestriction enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the GeoTargetingRestriction enum
            def self.geo_targeting_restriction
              require "google/ads/google_ads/v7/enums/geo_targeting_restriction_pb"
              Google::Ads::GoogleAds::V7::Enums::GeoTargetingRestrictionEnum::GeoTargetingRestriction.descriptor
            end

            # Returns the descriptor for the PlaceholderType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the PlaceholderType enum
            def self.placeholder_type
              require "google/ads/google_ads/v7/enums/placeholder_type_pb"
              Google::Ads::GoogleAds::V7::Enums::PlaceholderTypeEnum::PlaceholderType.descriptor
            end

            # Returns the descriptor for the PolicyApprovalStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the PolicyApprovalStatus enum
            def self.policy_approval_status
              require "google/ads/google_ads/v7/enums/policy_approval_status_pb"
              Google::Ads::GoogleAds::V7::Enums::PolicyApprovalStatusEnum::PolicyApprovalStatus.descriptor
            end

            # Returns the descriptor for the PolicyReviewStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the PolicyReviewStatus enum
            def self.policy_review_status
              require "google/ads/google_ads/v7/enums/policy_review_status_pb"
              Google::Ads::GoogleAds::V7::Enums::PolicyReviewStatusEnum::PolicyReviewStatus.descriptor
            end

            # Returns the descriptor for the FeedItemValidationError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FeedItemValidationError enum
            def self.feed_item_validation_error
              require "google/ads/google_ads/v7/errors/feed_item_validation_error_pb"
              Google::Ads::GoogleAds::V7::Errors::FeedItemValidationErrorEnum::FeedItemValidationError.descriptor
            end

            # Returns the descriptor for the MobileDeviceType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the MobileDeviceType enum
            def self.mobile_device_type
              require "google/ads/google_ads/v7/enums/mobile_device_type_pb"
              Google::Ads::GoogleAds::V7::Enums::MobileDeviceTypeEnum::MobileDeviceType.descriptor
            end

            # Returns the descriptor for the CustomerPayPerConversionEligibilityFailureReason enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CustomerPayPerConversionEligibilityFailureReason enum
            def self.customer_pay_per_conversion_eligibility_failure_reason
              require "google/ads/google_ads/v7/enums/customer_pay_per_conversion_eligibility_failure_reason_pb"
              Google::Ads::GoogleAds::V7::Enums::CustomerPayPerConversionEligibilityFailureReasonEnum::CustomerPayPerConversionEligibilityFailureReason.descriptor
            end

            # Returns the descriptor for the ExtensionSettingDevice enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ExtensionSettingDevice enum
            def self.extension_setting_device
              require "google/ads/google_ads/v7/enums/extension_setting_device_pb"
              Google::Ads::GoogleAds::V7::Enums::ExtensionSettingDeviceEnum::ExtensionSettingDevice.descriptor
            end

            # Returns the descriptor for the ExtensionType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ExtensionType enum
            def self.extension_type
              require "google/ads/google_ads/v7/enums/extension_type_pb"
              Google::Ads::GoogleAds::V7::Enums::ExtensionTypeEnum::ExtensionType.descriptor
            end

            # Returns the descriptor for the GeoTargetConstantStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the GeoTargetConstantStatus enum
            def self.geo_target_constant_status
              require "google/ads/google_ads/v7/enums/geo_target_constant_status_pb"
              Google::Ads::GoogleAds::V7::Enums::GeoTargetConstantStatusEnum::GeoTargetConstantStatus.descriptor
            end

            # Returns the descriptor for the CallTrackingDisplayLocation enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CallTrackingDisplayLocation enum
            def self.call_tracking_display_location
              require "google/ads/google_ads/v7/enums/call_tracking_display_location_pb"
              Google::Ads::GoogleAds::V7::Enums::CallTrackingDisplayLocationEnum::CallTrackingDisplayLocation.descriptor
            end

            # Returns the descriptor for the CallType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CallType enum
            def self.call_type
              require "google/ads/google_ads/v7/enums/call_type_pb"
              Google::Ads::GoogleAds::V7::Enums::CallTypeEnum::CallType.descriptor
            end

            # Returns the descriptor for the GoogleVoiceCallStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the GoogleVoiceCallStatus enum
            def self.google_voice_call_status
              require "google/ads/google_ads/v7/enums/google_voice_call_status_pb"
              Google::Ads::GoogleAds::V7::Enums::GoogleVoiceCallStatusEnum::GoogleVoiceCallStatus.descriptor
            end

            # Returns the descriptor for the BudgetDeliveryMethod enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the BudgetDeliveryMethod enum
            def self.budget_delivery_method
              require "google/ads/google_ads/v7/enums/budget_delivery_method_pb"
              Google::Ads::GoogleAds::V7::Enums::BudgetDeliveryMethodEnum::BudgetDeliveryMethod.descriptor
            end

            # Returns the descriptor for the BudgetPeriod enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the BudgetPeriod enum
            def self.budget_period
              require "google/ads/google_ads/v7/enums/budget_period_pb"
              Google::Ads::GoogleAds::V7::Enums::BudgetPeriodEnum::BudgetPeriod.descriptor
            end

            # Returns the descriptor for the BudgetStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the BudgetStatus enum
            def self.budget_status
              require "google/ads/google_ads/v7/enums/budget_status_pb"
              Google::Ads::GoogleAds::V7::Enums::BudgetStatusEnum::BudgetStatus.descriptor
            end

            # Returns the descriptor for the BudgetType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the BudgetType enum
            def self.budget_type
              require "google/ads/google_ads/v7/enums/budget_type_pb"
              Google::Ads::GoogleAds::V7::Enums::BudgetTypeEnum::BudgetType.descriptor
            end

            # Returns the descriptor for the AssetFieldType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AssetFieldType enum
            def self.asset_field_type
              require "google/ads/google_ads/v7/enums/asset_field_type_pb"
              Google::Ads::GoogleAds::V7::Enums::AssetFieldTypeEnum::AssetFieldType.descriptor
            end

            # Returns the descriptor for the AssetLinkStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AssetLinkStatus enum
            def self.asset_link_status
              require "google/ads/google_ads/v7/enums/asset_link_status_pb"
              Google::Ads::GoogleAds::V7::Enums::AssetLinkStatusEnum::AssetLinkStatus.descriptor
            end

            # Returns the descriptor for the MonthOfYear enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the MonthOfYear enum
            def self.month_of_year
              require "google/ads/google_ads/v7/enums/month_of_year_pb"
              Google::Ads::GoogleAds::V7::Enums::MonthOfYearEnum::MonthOfYear.descriptor
            end

            # Returns the descriptor for the InvoiceType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the InvoiceType enum
            def self.invoice_type
              require "google/ads/google_ads/v7/enums/invoice_type_pb"
              Google::Ads::GoogleAds::V7::Enums::InvoiceTypeEnum::InvoiceType.descriptor
            end

            # Returns the descriptor for the MatchingFunctionContextType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the MatchingFunctionContextType enum
            def self.matching_function_context_type
              require "google/ads/google_ads/v7/enums/matching_function_context_type_pb"
              Google::Ads::GoogleAds::V7::Enums::MatchingFunctionContextTypeEnum::MatchingFunctionContextType.descriptor
            end

            # Returns the descriptor for the MatchingFunctionOperator enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the MatchingFunctionOperator enum
            def self.matching_function_operator
              require "google/ads/google_ads/v7/enums/matching_function_operator_pb"
              Google::Ads::GoogleAds::V7::Enums::MatchingFunctionOperatorEnum::MatchingFunctionOperator.descriptor
            end

            # Returns the descriptor for the FeedLinkStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FeedLinkStatus enum
            def self.feed_link_status
              require "google/ads/google_ads/v7/enums/feed_link_status_pb"
              Google::Ads::GoogleAds::V7::Enums::FeedLinkStatusEnum::FeedLinkStatus.descriptor
            end

            # Returns the descriptor for the AdCustomizerPlaceholderField enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AdCustomizerPlaceholderField enum
            def self.ad_customizer_placeholder_field
              require "google/ads/google_ads/v7/enums/ad_customizer_placeholder_field_pb"
              Google::Ads::GoogleAds::V7::Enums::AdCustomizerPlaceholderFieldEnum::AdCustomizerPlaceholderField.descriptor
            end

            # Returns the descriptor for the AffiliateLocationPlaceholderField enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AffiliateLocationPlaceholderField enum
            def self.affiliate_location_placeholder_field
              require "google/ads/google_ads/v7/enums/affiliate_location_placeholder_field_pb"
              Google::Ads::GoogleAds::V7::Enums::AffiliateLocationPlaceholderFieldEnum::AffiliateLocationPlaceholderField.descriptor
            end

            # Returns the descriptor for the AppPlaceholderField enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AppPlaceholderField enum
            def self.app_placeholder_field
              require "google/ads/google_ads/v7/enums/app_placeholder_field_pb"
              Google::Ads::GoogleAds::V7::Enums::AppPlaceholderFieldEnum::AppPlaceholderField.descriptor
            end

            # Returns the descriptor for the CallPlaceholderField enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CallPlaceholderField enum
            def self.call_placeholder_field
              require "google/ads/google_ads/v7/enums/call_placeholder_field_pb"
              Google::Ads::GoogleAds::V7::Enums::CallPlaceholderFieldEnum::CallPlaceholderField.descriptor
            end

            # Returns the descriptor for the CalloutPlaceholderField enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CalloutPlaceholderField enum
            def self.callout_placeholder_field
              require "google/ads/google_ads/v7/enums/callout_placeholder_field_pb"
              Google::Ads::GoogleAds::V7::Enums::CalloutPlaceholderFieldEnum::CalloutPlaceholderField.descriptor
            end

            # Returns the descriptor for the CustomPlaceholderField enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CustomPlaceholderField enum
            def self.custom_placeholder_field
              require "google/ads/google_ads/v7/enums/custom_placeholder_field_pb"
              Google::Ads::GoogleAds::V7::Enums::CustomPlaceholderFieldEnum::CustomPlaceholderField.descriptor
            end

            # Returns the descriptor for the DsaPageFeedCriterionField enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the DsaPageFeedCriterionField enum
            def self.dsa_page_feed_criterion_field
              require "google/ads/google_ads/v7/enums/dsa_page_feed_criterion_field_pb"
              Google::Ads::GoogleAds::V7::Enums::DsaPageFeedCriterionFieldEnum::DsaPageFeedCriterionField.descriptor
            end

            # Returns the descriptor for the EducationPlaceholderField enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the EducationPlaceholderField enum
            def self.education_placeholder_field
              require "google/ads/google_ads/v7/enums/education_placeholder_field_pb"
              Google::Ads::GoogleAds::V7::Enums::EducationPlaceholderFieldEnum::EducationPlaceholderField.descriptor
            end

            # Returns the descriptor for the FeedMappingCriterionType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FeedMappingCriterionType enum
            def self.feed_mapping_criterion_type
              require "google/ads/google_ads/v7/enums/feed_mapping_criterion_type_pb"
              Google::Ads::GoogleAds::V7::Enums::FeedMappingCriterionTypeEnum::FeedMappingCriterionType.descriptor
            end

            # Returns the descriptor for the FeedMappingStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FeedMappingStatus enum
            def self.feed_mapping_status
              require "google/ads/google_ads/v7/enums/feed_mapping_status_pb"
              Google::Ads::GoogleAds::V7::Enums::FeedMappingStatusEnum::FeedMappingStatus.descriptor
            end

            # Returns the descriptor for the FlightPlaceholderField enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FlightPlaceholderField enum
            def self.flight_placeholder_field
              require "google/ads/google_ads/v7/enums/flight_placeholder_field_pb"
              Google::Ads::GoogleAds::V7::Enums::FlightPlaceholderFieldEnum::FlightPlaceholderField.descriptor
            end

            # Returns the descriptor for the HotelPlaceholderField enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the HotelPlaceholderField enum
            def self.hotel_placeholder_field
              require "google/ads/google_ads/v7/enums/hotel_placeholder_field_pb"
              Google::Ads::GoogleAds::V7::Enums::HotelPlaceholderFieldEnum::HotelPlaceholderField.descriptor
            end

            # Returns the descriptor for the ImagePlaceholderField enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ImagePlaceholderField enum
            def self.image_placeholder_field
              require "google/ads/google_ads/v7/enums/image_placeholder_field_pb"
              Google::Ads::GoogleAds::V7::Enums::ImagePlaceholderFieldEnum::ImagePlaceholderField.descriptor
            end

            # Returns the descriptor for the JobPlaceholderField enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the JobPlaceholderField enum
            def self.job_placeholder_field
              require "google/ads/google_ads/v7/enums/job_placeholder_field_pb"
              Google::Ads::GoogleAds::V7::Enums::JobPlaceholderFieldEnum::JobPlaceholderField.descriptor
            end

            # Returns the descriptor for the LocalPlaceholderField enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the LocalPlaceholderField enum
            def self.local_placeholder_field
              require "google/ads/google_ads/v7/enums/local_placeholder_field_pb"
              Google::Ads::GoogleAds::V7::Enums::LocalPlaceholderFieldEnum::LocalPlaceholderField.descriptor
            end

            # Returns the descriptor for the LocationExtensionTargetingCriterionField enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the LocationExtensionTargetingCriterionField enum
            def self.location_extension_targeting_criterion_field
              require "google/ads/google_ads/v7/enums/location_extension_targeting_criterion_field_pb"
              Google::Ads::GoogleAds::V7::Enums::LocationExtensionTargetingCriterionFieldEnum::LocationExtensionTargetingCriterionField.descriptor
            end

            # Returns the descriptor for the LocationPlaceholderField enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the LocationPlaceholderField enum
            def self.location_placeholder_field
              require "google/ads/google_ads/v7/enums/location_placeholder_field_pb"
              Google::Ads::GoogleAds::V7::Enums::LocationPlaceholderFieldEnum::LocationPlaceholderField.descriptor
            end

            # Returns the descriptor for the MessagePlaceholderField enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the MessagePlaceholderField enum
            def self.message_placeholder_field
              require "google/ads/google_ads/v7/enums/message_placeholder_field_pb"
              Google::Ads::GoogleAds::V7::Enums::MessagePlaceholderFieldEnum::MessagePlaceholderField.descriptor
            end

            # Returns the descriptor for the PricePlaceholderField enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the PricePlaceholderField enum
            def self.price_placeholder_field
              require "google/ads/google_ads/v7/enums/price_placeholder_field_pb"
              Google::Ads::GoogleAds::V7::Enums::PricePlaceholderFieldEnum::PricePlaceholderField.descriptor
            end

            # Returns the descriptor for the PromotionPlaceholderField enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the PromotionPlaceholderField enum
            def self.promotion_placeholder_field
              require "google/ads/google_ads/v7/enums/promotion_placeholder_field_pb"
              Google::Ads::GoogleAds::V7::Enums::PromotionPlaceholderFieldEnum::PromotionPlaceholderField.descriptor
            end

            # Returns the descriptor for the RealEstatePlaceholderField enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the RealEstatePlaceholderField enum
            def self.real_estate_placeholder_field
              require "google/ads/google_ads/v7/enums/real_estate_placeholder_field_pb"
              Google::Ads::GoogleAds::V7::Enums::RealEstatePlaceholderFieldEnum::RealEstatePlaceholderField.descriptor
            end

            # Returns the descriptor for the SitelinkPlaceholderField enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the SitelinkPlaceholderField enum
            def self.sitelink_placeholder_field
              require "google/ads/google_ads/v7/enums/sitelink_placeholder_field_pb"
              Google::Ads::GoogleAds::V7::Enums::SitelinkPlaceholderFieldEnum::SitelinkPlaceholderField.descriptor
            end

            # Returns the descriptor for the StructuredSnippetPlaceholderField enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the StructuredSnippetPlaceholderField enum
            def self.structured_snippet_placeholder_field
              require "google/ads/google_ads/v7/enums/structured_snippet_placeholder_field_pb"
              Google::Ads::GoogleAds::V7::Enums::StructuredSnippetPlaceholderFieldEnum::StructuredSnippetPlaceholderField.descriptor
            end

            # Returns the descriptor for the TravelPlaceholderField enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the TravelPlaceholderField enum
            def self.travel_placeholder_field
              require "google/ads/google_ads/v7/enums/travel_placeholder_field_pb"
              Google::Ads::GoogleAds::V7::Enums::TravelPlaceholderFieldEnum::TravelPlaceholderField.descriptor
            end

            # Returns the descriptor for the AffiliateLocationFeedRelationshipType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AffiliateLocationFeedRelationshipType enum
            def self.affiliate_location_feed_relationship_type
              require "google/ads/google_ads/v7/enums/affiliate_location_feed_relationship_type_pb"
              Google::Ads::GoogleAds::V7::Enums::AffiliateLocationFeedRelationshipTypeEnum::AffiliateLocationFeedRelationshipType.descriptor
            end

            # Returns the descriptor for the FeedAttributeType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FeedAttributeType enum
            def self.feed_attribute_type
              require "google/ads/google_ads/v7/enums/feed_attribute_type_pb"
              Google::Ads::GoogleAds::V7::Enums::FeedAttributeTypeEnum::FeedAttributeType.descriptor
            end

            # Returns the descriptor for the FeedOrigin enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FeedOrigin enum
            def self.feed_origin
              require "google/ads/google_ads/v7/enums/feed_origin_pb"
              Google::Ads::GoogleAds::V7::Enums::FeedOriginEnum::FeedOrigin.descriptor
            end

            # Returns the descriptor for the FeedStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FeedStatus enum
            def self.feed_status
              require "google/ads/google_ads/v7/enums/feed_status_pb"
              Google::Ads::GoogleAds::V7::Enums::FeedStatusEnum::FeedStatus.descriptor
            end

            # Returns the descriptor for the Operator enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the Operator enum
            def self.operator
              require "google/ads/google_ads/v7/resources/feed_pb"
              Google::Ads::GoogleAds::V7::Resources::FeedAttributeOperation::Operator.descriptor
            end

            # Returns the descriptor for the SimulationModificationMethod enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the SimulationModificationMethod enum
            def self.simulation_modification_method
              require "google/ads/google_ads/v7/enums/simulation_modification_method_pb"
              Google::Ads::GoogleAds::V7::Enums::SimulationModificationMethodEnum::SimulationModificationMethod.descriptor
            end

            # Returns the descriptor for the SimulationType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the SimulationType enum
            def self.simulation_type
              require "google/ads/google_ads/v7/enums/simulation_type_pb"
              Google::Ads::GoogleAds::V7::Enums::SimulationTypeEnum::SimulationType.descriptor
            end

            # Returns the descriptor for the AgeRangeType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AgeRangeType enum
            def self.age_range_type
              require "google/ads/google_ads/v7/enums/age_range_type_pb"
              Google::Ads::GoogleAds::V7::Enums::AgeRangeTypeEnum::AgeRangeType.descriptor
            end

            # Returns the descriptor for the AppPaymentModelType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AppPaymentModelType enum
            def self.app_payment_model_type
              require "google/ads/google_ads/v7/enums/app_payment_model_type_pb"
              Google::Ads::GoogleAds::V7::Enums::AppPaymentModelTypeEnum::AppPaymentModelType.descriptor
            end

            # Returns the descriptor for the ContentLabelType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ContentLabelType enum
            def self.content_label_type
              require "google/ads/google_ads/v7/enums/content_label_type_pb"
              Google::Ads::GoogleAds::V7::Enums::ContentLabelTypeEnum::ContentLabelType.descriptor
            end

            # Returns the descriptor for the DayOfWeek enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the DayOfWeek enum
            def self.day_of_week
              require "google/ads/google_ads/v7/enums/day_of_week_pb"
              Google::Ads::GoogleAds::V7::Enums::DayOfWeekEnum::DayOfWeek.descriptor
            end

            # Returns the descriptor for the Device enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the Device enum
            def self.device
              require "google/ads/google_ads/v7/enums/device_pb"
              Google::Ads::GoogleAds::V7::Enums::DeviceEnum::Device.descriptor
            end

            # Returns the descriptor for the GenderType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the GenderType enum
            def self.gender_type
              require "google/ads/google_ads/v7/enums/gender_type_pb"
              Google::Ads::GoogleAds::V7::Enums::GenderTypeEnum::GenderType.descriptor
            end

            # Returns the descriptor for the HotelDateSelectionType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the HotelDateSelectionType enum
            def self.hotel_date_selection_type
              require "google/ads/google_ads/v7/enums/hotel_date_selection_type_pb"
              Google::Ads::GoogleAds::V7::Enums::HotelDateSelectionTypeEnum::HotelDateSelectionType.descriptor
            end

            # Returns the descriptor for the IncomeRangeType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the IncomeRangeType enum
            def self.income_range_type
              require "google/ads/google_ads/v7/enums/income_range_type_pb"
              Google::Ads::GoogleAds::V7::Enums::IncomeRangeTypeEnum::IncomeRangeType.descriptor
            end

            # Returns the descriptor for the InteractionType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the InteractionType enum
            def self.interaction_type
              require "google/ads/google_ads/v7/enums/interaction_type_pb"
              Google::Ads::GoogleAds::V7::Enums::InteractionTypeEnum::InteractionType.descriptor
            end

            # Returns the descriptor for the KeywordMatchType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the KeywordMatchType enum
            def self.keyword_match_type
              require "google/ads/google_ads/v7/enums/keyword_match_type_pb"
              Google::Ads::GoogleAds::V7::Enums::KeywordMatchTypeEnum::KeywordMatchType.descriptor
            end

            # Returns the descriptor for the ListingGroupType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ListingGroupType enum
            def self.listing_group_type
              require "google/ads/google_ads/v7/enums/listing_group_type_pb"
              Google::Ads::GoogleAds::V7::Enums::ListingGroupTypeEnum::ListingGroupType.descriptor
            end

            # Returns the descriptor for the LocationGroupRadiusUnits enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the LocationGroupRadiusUnits enum
            def self.location_group_radius_units
              require "google/ads/google_ads/v7/enums/location_group_radius_units_pb"
              Google::Ads::GoogleAds::V7::Enums::LocationGroupRadiusUnitsEnum::LocationGroupRadiusUnits.descriptor
            end

            # Returns the descriptor for the MinuteOfHour enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the MinuteOfHour enum
            def self.minute_of_hour
              require "google/ads/google_ads/v7/enums/minute_of_hour_pb"
              Google::Ads::GoogleAds::V7::Enums::MinuteOfHourEnum::MinuteOfHour.descriptor
            end

            # Returns the descriptor for the ParentalStatusType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ParentalStatusType enum
            def self.parental_status_type
              require "google/ads/google_ads/v7/enums/parental_status_type_pb"
              Google::Ads::GoogleAds::V7::Enums::ParentalStatusTypeEnum::ParentalStatusType.descriptor
            end

            # Returns the descriptor for the PreferredContentType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the PreferredContentType enum
            def self.preferred_content_type
              require "google/ads/google_ads/v7/enums/preferred_content_type_pb"
              Google::Ads::GoogleAds::V7::Enums::PreferredContentTypeEnum::PreferredContentType.descriptor
            end

            # Returns the descriptor for the ProductBiddingCategoryLevel enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ProductBiddingCategoryLevel enum
            def self.product_bidding_category_level
              require "google/ads/google_ads/v7/enums/product_bidding_category_level_pb"
              Google::Ads::GoogleAds::V7::Enums::ProductBiddingCategoryLevelEnum::ProductBiddingCategoryLevel.descriptor
            end

            # Returns the descriptor for the ProductChannel enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ProductChannel enum
            def self.product_channel
              require "google/ads/google_ads/v7/enums/product_channel_pb"
              Google::Ads::GoogleAds::V7::Enums::ProductChannelEnum::ProductChannel.descriptor
            end

            # Returns the descriptor for the ProductChannelExclusivity enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ProductChannelExclusivity enum
            def self.product_channel_exclusivity
              require "google/ads/google_ads/v7/enums/product_channel_exclusivity_pb"
              Google::Ads::GoogleAds::V7::Enums::ProductChannelExclusivityEnum::ProductChannelExclusivity.descriptor
            end

            # Returns the descriptor for the ProductCondition enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ProductCondition enum
            def self.product_condition
              require "google/ads/google_ads/v7/enums/product_condition_pb"
              Google::Ads::GoogleAds::V7::Enums::ProductConditionEnum::ProductCondition.descriptor
            end

            # Returns the descriptor for the ProductCustomAttributeIndex enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ProductCustomAttributeIndex enum
            def self.product_custom_attribute_index
              require "google/ads/google_ads/v7/enums/product_custom_attribute_index_pb"
              Google::Ads::GoogleAds::V7::Enums::ProductCustomAttributeIndexEnum::ProductCustomAttributeIndex.descriptor
            end

            # Returns the descriptor for the ProductTypeLevel enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ProductTypeLevel enum
            def self.product_type_level
              require "google/ads/google_ads/v7/enums/product_type_level_pb"
              Google::Ads::GoogleAds::V7::Enums::ProductTypeLevelEnum::ProductTypeLevel.descriptor
            end

            # Returns the descriptor for the ProximityRadiusUnits enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ProximityRadiusUnits enum
            def self.proximity_radius_units
              require "google/ads/google_ads/v7/enums/proximity_radius_units_pb"
              Google::Ads::GoogleAds::V7::Enums::ProximityRadiusUnitsEnum::ProximityRadiusUnits.descriptor
            end

            # Returns the descriptor for the WebpageConditionOperand enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the WebpageConditionOperand enum
            def self.webpage_condition_operand
              require "google/ads/google_ads/v7/enums/webpage_condition_operand_pb"
              Google::Ads::GoogleAds::V7::Enums::WebpageConditionOperandEnum::WebpageConditionOperand.descriptor
            end

            # Returns the descriptor for the WebpageConditionOperator enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the WebpageConditionOperator enum
            def self.webpage_condition_operator
              require "google/ads/google_ads/v7/enums/webpage_condition_operator_pb"
              Google::Ads::GoogleAds::V7::Enums::WebpageConditionOperatorEnum::WebpageConditionOperator.descriptor
            end

            # Returns the descriptor for the CriterionType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CriterionType enum
            def self.criterion_type
              require "google/ads/google_ads/v7/enums/criterion_type_pb"
              Google::Ads::GoogleAds::V7::Enums::CriterionTypeEnum::CriterionType.descriptor
            end

            # Returns the descriptor for the BillingSetupStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the BillingSetupStatus enum
            def self.billing_setup_status
              require "google/ads/google_ads/v7/enums/billing_setup_status_pb"
              Google::Ads::GoogleAds::V7::Enums::BillingSetupStatusEnum::BillingSetupStatus.descriptor
            end

            # Returns the descriptor for the TimeType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the TimeType enum
            def self.time_type
              require "google/ads/google_ads/v7/enums/time_type_pb"
              Google::Ads::GoogleAds::V7::Enums::TimeTypeEnum::TimeType.descriptor
            end

            # Returns the descriptor for the AssetPerformanceLabel enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AssetPerformanceLabel enum
            def self.asset_performance_label
              require "google/ads/google_ads/v7/enums/asset_performance_label_pb"
              Google::Ads::GoogleAds::V7::Enums::AssetPerformanceLabelEnum::AssetPerformanceLabel.descriptor
            end

            # Returns the descriptor for the ServedAssetFieldType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ServedAssetFieldType enum
            def self.served_asset_field_type
              require "google/ads/google_ads/v7/enums/served_asset_field_type_pb"
              Google::Ads::GoogleAds::V7::Enums::ServedAssetFieldTypeEnum::ServedAssetFieldType.descriptor
            end

            # Returns the descriptor for the CallConversionReportingState enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CallConversionReportingState enum
            def self.call_conversion_reporting_state
              require "google/ads/google_ads/v7/enums/call_conversion_reporting_state_pb"
              Google::Ads::GoogleAds::V7::Enums::CallConversionReportingStateEnum::CallConversionReportingState.descriptor
            end

            # Returns the descriptor for the DisplayAdFormatSetting enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the DisplayAdFormatSetting enum
            def self.display_ad_format_setting
              require "google/ads/google_ads/v7/enums/display_ad_format_setting_pb"
              Google::Ads::GoogleAds::V7::Enums::DisplayAdFormatSettingEnum::DisplayAdFormatSetting.descriptor
            end

            # Returns the descriptor for the DisplayUploadProductType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the DisplayUploadProductType enum
            def self.display_upload_product_type
              require "google/ads/google_ads/v7/enums/display_upload_product_type_pb"
              Google::Ads::GoogleAds::V7::Enums::DisplayUploadProductTypeEnum::DisplayUploadProductType.descriptor
            end

            # Returns the descriptor for the LegacyAppInstallAdAppStore enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the LegacyAppInstallAdAppStore enum
            def self.legacy_app_install_ad_app_store
              require "google/ads/google_ads/v7/enums/legacy_app_install_ad_app_store_pb"
              Google::Ads::GoogleAds::V7::Enums::LegacyAppInstallAdAppStoreEnum::LegacyAppInstallAdAppStore.descriptor
            end

            # Returns the descriptor for the MimeType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the MimeType enum
            def self.mime_type
              require "google/ads/google_ads/v7/enums/mime_type_pb"
              Google::Ads::GoogleAds::V7::Enums::MimeTypeEnum::MimeType.descriptor
            end

            # Returns the descriptor for the AppUrlOperatingSystemType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AppUrlOperatingSystemType enum
            def self.app_url_operating_system_type
              require "google/ads/google_ads/v7/enums/app_url_operating_system_type_pb"
              Google::Ads::GoogleAds::V7::Enums::AppUrlOperatingSystemTypeEnum::AppUrlOperatingSystemType.descriptor
            end

            # Returns the descriptor for the AdType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AdType enum
            def self.ad_type
              require "google/ads/google_ads/v7/enums/ad_type_pb"
              Google::Ads::GoogleAds::V7::Enums::AdTypeEnum::AdType.descriptor
            end

            # Returns the descriptor for the SystemManagedResourceSource enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the SystemManagedResourceSource enum
            def self.system_managed_resource_source
              require "google/ads/google_ads/v7/enums/system_managed_entity_source_pb"
              Google::Ads::GoogleAds::V7::Enums::SystemManagedResourceSourceEnum::SystemManagedResourceSource.descriptor
            end

            # Returns the descriptor for the ManagerLinkStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ManagerLinkStatus enum
            def self.manager_link_status
              require "google/ads/google_ads/v7/enums/manager_link_status_pb"
              Google::Ads::GoogleAds::V7::Enums::ManagerLinkStatusEnum::ManagerLinkStatus.descriptor
            end

            # Returns the descriptor for the TargetImpressionShareLocation enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the TargetImpressionShareLocation enum
            def self.target_impression_share_location
              require "google/ads/google_ads/v7/enums/target_impression_share_location_pb"
              Google::Ads::GoogleAds::V7::Enums::TargetImpressionShareLocationEnum::TargetImpressionShareLocation.descriptor
            end

            # Returns the descriptor for the BiddingStrategyStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the BiddingStrategyStatus enum
            def self.bidding_strategy_status
              require "google/ads/google_ads/v7/enums/bidding_strategy_status_pb"
              Google::Ads::GoogleAds::V7::Enums::BiddingStrategyStatusEnum::BiddingStrategyStatus.descriptor
            end

            # Returns the descriptor for the BiddingStrategyType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the BiddingStrategyType enum
            def self.bidding_strategy_type
              require "google/ads/google_ads/v7/enums/bidding_strategy_type_pb"
              Google::Ads::GoogleAds::V7::Enums::BiddingStrategyTypeEnum::BiddingStrategyType.descriptor
            end

            # Returns the descriptor for the CampaignSharedSetStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CampaignSharedSetStatus enum
            def self.campaign_shared_set_status
              require "google/ads/google_ads/v7/enums/campaign_shared_set_status_pb"
              Google::Ads::GoogleAds::V7::Enums::CampaignSharedSetStatusEnum::CampaignSharedSetStatus.descriptor
            end

            # Returns the descriptor for the CustomerMatchUploadKeyType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CustomerMatchUploadKeyType enum
            def self.customer_match_upload_key_type
              require "google/ads/google_ads/v7/enums/customer_match_upload_key_type_pb"
              Google::Ads::GoogleAds::V7::Enums::CustomerMatchUploadKeyTypeEnum::CustomerMatchUploadKeyType.descriptor
            end

            # Returns the descriptor for the UserListCombinedRuleOperator enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the UserListCombinedRuleOperator enum
            def self.user_list_combined_rule_operator
              require "google/ads/google_ads/v7/enums/user_list_combined_rule_operator_pb"
              Google::Ads::GoogleAds::V7::Enums::UserListCombinedRuleOperatorEnum::UserListCombinedRuleOperator.descriptor
            end

            # Returns the descriptor for the UserListCrmDataSourceType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the UserListCrmDataSourceType enum
            def self.user_list_crm_data_source_type
              require "google/ads/google_ads/v7/enums/user_list_crm_data_source_type_pb"
              Google::Ads::GoogleAds::V7::Enums::UserListCrmDataSourceTypeEnum::UserListCrmDataSourceType.descriptor
            end

            # Returns the descriptor for the UserListDateRuleItemOperator enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the UserListDateRuleItemOperator enum
            def self.user_list_date_rule_item_operator
              require "google/ads/google_ads/v7/enums/user_list_date_rule_item_operator_pb"
              Google::Ads::GoogleAds::V7::Enums::UserListDateRuleItemOperatorEnum::UserListDateRuleItemOperator.descriptor
            end

            # Returns the descriptor for the UserListLogicalRuleOperator enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the UserListLogicalRuleOperator enum
            def self.user_list_logical_rule_operator
              require "google/ads/google_ads/v7/enums/user_list_logical_rule_operator_pb"
              Google::Ads::GoogleAds::V7::Enums::UserListLogicalRuleOperatorEnum::UserListLogicalRuleOperator.descriptor
            end

            # Returns the descriptor for the UserListNumberRuleItemOperator enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the UserListNumberRuleItemOperator enum
            def self.user_list_number_rule_item_operator
              require "google/ads/google_ads/v7/enums/user_list_number_rule_item_operator_pb"
              Google::Ads::GoogleAds::V7::Enums::UserListNumberRuleItemOperatorEnum::UserListNumberRuleItemOperator.descriptor
            end

            # Returns the descriptor for the UserListPrepopulationStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the UserListPrepopulationStatus enum
            def self.user_list_prepopulation_status
              require "google/ads/google_ads/v7/enums/user_list_prepopulation_status_pb"
              Google::Ads::GoogleAds::V7::Enums::UserListPrepopulationStatusEnum::UserListPrepopulationStatus.descriptor
            end

            # Returns the descriptor for the UserListRuleType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the UserListRuleType enum
            def self.user_list_rule_type
              require "google/ads/google_ads/v7/enums/user_list_rule_type_pb"
              Google::Ads::GoogleAds::V7::Enums::UserListRuleTypeEnum::UserListRuleType.descriptor
            end

            # Returns the descriptor for the UserListStringRuleItemOperator enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the UserListStringRuleItemOperator enum
            def self.user_list_string_rule_item_operator
              require "google/ads/google_ads/v7/enums/user_list_string_rule_item_operator_pb"
              Google::Ads::GoogleAds::V7::Enums::UserListStringRuleItemOperatorEnum::UserListStringRuleItemOperator.descriptor
            end

            # Returns the descriptor for the AccessReason enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AccessReason enum
            def self.access_reason
              require "google/ads/google_ads/v7/enums/access_reason_pb"
              Google::Ads::GoogleAds::V7::Enums::AccessReasonEnum::AccessReason.descriptor
            end

            # Returns the descriptor for the UserListAccessStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the UserListAccessStatus enum
            def self.user_list_access_status
              require "google/ads/google_ads/v7/enums/user_list_access_status_pb"
              Google::Ads::GoogleAds::V7::Enums::UserListAccessStatusEnum::UserListAccessStatus.descriptor
            end

            # Returns the descriptor for the UserListClosingReason enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the UserListClosingReason enum
            def self.user_list_closing_reason
              require "google/ads/google_ads/v7/enums/user_list_closing_reason_pb"
              Google::Ads::GoogleAds::V7::Enums::UserListClosingReasonEnum::UserListClosingReason.descriptor
            end

            # Returns the descriptor for the UserListMembershipStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the UserListMembershipStatus enum
            def self.user_list_membership_status
              require "google/ads/google_ads/v7/enums/user_list_membership_status_pb"
              Google::Ads::GoogleAds::V7::Enums::UserListMembershipStatusEnum::UserListMembershipStatus.descriptor
            end

            # Returns the descriptor for the UserListSizeRange enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the UserListSizeRange enum
            def self.user_list_size_range
              require "google/ads/google_ads/v7/enums/user_list_size_range_pb"
              Google::Ads::GoogleAds::V7::Enums::UserListSizeRangeEnum::UserListSizeRange.descriptor
            end

            # Returns the descriptor for the UserListType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the UserListType enum
            def self.user_list_type
              require "google/ads/google_ads/v7/enums/user_list_type_pb"
              Google::Ads::GoogleAds::V7::Enums::UserListTypeEnum::UserListType.descriptor
            end

            # Returns the descriptor for the ChangeClientType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ChangeClientType enum
            def self.change_client_type
              require "google/ads/google_ads/v7/enums/change_client_type_pb"
              Google::Ads::GoogleAds::V7::Enums::ChangeClientTypeEnum::ChangeClientType.descriptor
            end

            # Returns the descriptor for the ChangeEventResourceType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ChangeEventResourceType enum
            def self.change_event_resource_type
              require "google/ads/google_ads/v7/enums/change_event_resource_type_pb"
              Google::Ads::GoogleAds::V7::Enums::ChangeEventResourceTypeEnum::ChangeEventResourceType.descriptor
            end

            # Returns the descriptor for the ResourceChangeOperation enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ResourceChangeOperation enum
            def self.resource_change_operation
              require "google/ads/google_ads/v7/enums/resource_change_operation_pb"
              Google::Ads::GoogleAds::V7::Enums::ResourceChangeOperationEnum::ResourceChangeOperation.descriptor
            end

            # Returns the descriptor for the TargetingDimension enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the TargetingDimension enum
            def self.targeting_dimension
              require "google/ads/google_ads/v7/enums/targeting_dimension_pb"
              Google::Ads::GoogleAds::V7::Enums::TargetingDimensionEnum::TargetingDimension.descriptor
            end

            # Returns the descriptor for the Operator enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the Operator enum
            def self.operator
              require "google/ads/google_ads/v7/common/targeting_setting_pb"
              Google::Ads::GoogleAds::V7::Common::TargetRestrictionOperation::Operator.descriptor
            end

            # Returns the descriptor for the AdGroupAdRotationMode enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AdGroupAdRotationMode enum
            def self.ad_group_ad_rotation_mode
              require "google/ads/google_ads/v7/enums/ad_group_ad_rotation_mode_pb"
              Google::Ads::GoogleAds::V7::Enums::AdGroupAdRotationModeEnum::AdGroupAdRotationMode.descriptor
            end

            # Returns the descriptor for the AdGroupStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AdGroupStatus enum
            def self.ad_group_status
              require "google/ads/google_ads/v7/enums/ad_group_status_pb"
              Google::Ads::GoogleAds::V7::Enums::AdGroupStatusEnum::AdGroupStatus.descriptor
            end

            # Returns the descriptor for the AdGroupType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AdGroupType enum
            def self.ad_group_type
              require "google/ads/google_ads/v7/enums/ad_group_type_pb"
              Google::Ads::GoogleAds::V7::Enums::AdGroupTypeEnum::AdGroupType.descriptor
            end

            # Returns the descriptor for the BiddingSource enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the BiddingSource enum
            def self.bidding_source
              require "google/ads/google_ads/v7/enums/bidding_source_pb"
              Google::Ads::GoogleAds::V7::Enums::BiddingSourceEnum::BiddingSource.descriptor
            end

            # Returns the descriptor for the AdGroupAdStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AdGroupAdStatus enum
            def self.ad_group_ad_status
              require "google/ads/google_ads/v7/enums/ad_group_ad_status_pb"
              Google::Ads::GoogleAds::V7::Enums::AdGroupAdStatusEnum::AdGroupAdStatus.descriptor
            end

            # Returns the descriptor for the AdStrength enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AdStrength enum
            def self.ad_strength
              require "google/ads/google_ads/v7/enums/ad_strength_pb"
              Google::Ads::GoogleAds::V7::Enums::AdStrengthEnum::AdStrength.descriptor
            end

            # Returns the descriptor for the BidModifierSource enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the BidModifierSource enum
            def self.bid_modifier_source
              require "google/ads/google_ads/v7/enums/bid_modifier_source_pb"
              Google::Ads::GoogleAds::V7::Enums::BidModifierSourceEnum::BidModifierSource.descriptor
            end

            # Returns the descriptor for the AdGroupCriterionApprovalStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AdGroupCriterionApprovalStatus enum
            def self.ad_group_criterion_approval_status
              require "google/ads/google_ads/v7/enums/ad_group_criterion_approval_status_pb"
              Google::Ads::GoogleAds::V7::Enums::AdGroupCriterionApprovalStatusEnum::AdGroupCriterionApprovalStatus.descriptor
            end

            # Returns the descriptor for the AdGroupCriterionStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AdGroupCriterionStatus enum
            def self.ad_group_criterion_status
              require "google/ads/google_ads/v7/enums/ad_group_criterion_status_pb"
              Google::Ads::GoogleAds::V7::Enums::AdGroupCriterionStatusEnum::AdGroupCriterionStatus.descriptor
            end

            # Returns the descriptor for the CriterionSystemServingStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CriterionSystemServingStatus enum
            def self.criterion_system_serving_status
              require "google/ads/google_ads/v7/enums/criterion_system_serving_status_pb"
              Google::Ads::GoogleAds::V7::Enums::CriterionSystemServingStatusEnum::CriterionSystemServingStatus.descriptor
            end

            # Returns the descriptor for the QualityScoreBucket enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the QualityScoreBucket enum
            def self.quality_score_bucket
              require "google/ads/google_ads/v7/enums/quality_score_bucket_pb"
              Google::Ads::GoogleAds::V7::Enums::QualityScoreBucketEnum::QualityScoreBucket.descriptor
            end

            # Returns the descriptor for the FrequencyCapEventType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FrequencyCapEventType enum
            def self.frequency_cap_event_type
              require "google/ads/google_ads/v7/enums/frequency_cap_event_type_pb"
              Google::Ads::GoogleAds::V7::Enums::FrequencyCapEventTypeEnum::FrequencyCapEventType.descriptor
            end

            # Returns the descriptor for the FrequencyCapLevel enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FrequencyCapLevel enum
            def self.frequency_cap_level
              require "google/ads/google_ads/v7/enums/frequency_cap_level_pb"
              Google::Ads::GoogleAds::V7::Enums::FrequencyCapLevelEnum::FrequencyCapLevel.descriptor
            end

            # Returns the descriptor for the FrequencyCapTimeUnit enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FrequencyCapTimeUnit enum
            def self.frequency_cap_time_unit
              require "google/ads/google_ads/v7/enums/frequency_cap_time_unit_pb"
              Google::Ads::GoogleAds::V7::Enums::FrequencyCapTimeUnitEnum::FrequencyCapTimeUnit.descriptor
            end

            # Returns the descriptor for the AdServingOptimizationStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AdServingOptimizationStatus enum
            def self.ad_serving_optimization_status
              require "google/ads/google_ads/v7/enums/ad_serving_optimization_status_pb"
              Google::Ads::GoogleAds::V7::Enums::AdServingOptimizationStatusEnum::AdServingOptimizationStatus.descriptor
            end

            # Returns the descriptor for the AppCampaignAppStore enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AppCampaignAppStore enum
            def self.app_campaign_app_store
              require "google/ads/google_ads/v7/enums/app_campaign_app_store_pb"
              Google::Ads::GoogleAds::V7::Enums::AppCampaignAppStoreEnum::AppCampaignAppStore.descriptor
            end

            # Returns the descriptor for the AppCampaignBiddingStrategyGoalType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AppCampaignBiddingStrategyGoalType enum
            def self.app_campaign_bidding_strategy_goal_type
              require "google/ads/google_ads/v7/enums/app_campaign_bidding_strategy_goal_type_pb"
              Google::Ads::GoogleAds::V7::Enums::AppCampaignBiddingStrategyGoalTypeEnum::AppCampaignBiddingStrategyGoalType.descriptor
            end

            # Returns the descriptor for the BrandSafetySuitability enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the BrandSafetySuitability enum
            def self.brand_safety_suitability
              require "google/ads/google_ads/v7/enums/brand_safety_suitability_pb"
              Google::Ads::GoogleAds::V7::Enums::BrandSafetySuitabilityEnum::BrandSafetySuitability.descriptor
            end

            # Returns the descriptor for the CampaignExperimentType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CampaignExperimentType enum
            def self.campaign_experiment_type
              require "google/ads/google_ads/v7/enums/campaign_experiment_type_pb"
              Google::Ads::GoogleAds::V7::Enums::CampaignExperimentTypeEnum::CampaignExperimentType.descriptor
            end

            # Returns the descriptor for the CampaignServingStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CampaignServingStatus enum
            def self.campaign_serving_status
              require "google/ads/google_ads/v7/enums/campaign_serving_status_pb"
              Google::Ads::GoogleAds::V7::Enums::CampaignServingStatusEnum::CampaignServingStatus.descriptor
            end

            # Returns the descriptor for the CampaignStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CampaignStatus enum
            def self.campaign_status
              require "google/ads/google_ads/v7/enums/campaign_status_pb"
              Google::Ads::GoogleAds::V7::Enums::CampaignStatusEnum::CampaignStatus.descriptor
            end

            # Returns the descriptor for the LocationSourceType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the LocationSourceType enum
            def self.location_source_type
              require "google/ads/google_ads/v7/enums/location_source_type_pb"
              Google::Ads::GoogleAds::V7::Enums::LocationSourceTypeEnum::LocationSourceType.descriptor
            end

            # Returns the descriptor for the NegativeGeoTargetType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the NegativeGeoTargetType enum
            def self.negative_geo_target_type
              require "google/ads/google_ads/v7/enums/negative_geo_target_type_pb"
              Google::Ads::GoogleAds::V7::Enums::NegativeGeoTargetTypeEnum::NegativeGeoTargetType.descriptor
            end

            # Returns the descriptor for the OptimizationGoalType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the OptimizationGoalType enum
            def self.optimization_goal_type
              require "google/ads/google_ads/v7/enums/optimization_goal_type_pb"
              Google::Ads::GoogleAds::V7::Enums::OptimizationGoalTypeEnum::OptimizationGoalType.descriptor
            end

            # Returns the descriptor for the PaymentMode enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the PaymentMode enum
            def self.payment_mode
              require "google/ads/google_ads/v7/enums/payment_mode_pb"
              Google::Ads::GoogleAds::V7::Enums::PaymentModeEnum::PaymentMode.descriptor
            end

            # Returns the descriptor for the PositiveGeoTargetType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the PositiveGeoTargetType enum
            def self.positive_geo_target_type
              require "google/ads/google_ads/v7/enums/positive_geo_target_type_pb"
              Google::Ads::GoogleAds::V7::Enums::PositiveGeoTargetTypeEnum::PositiveGeoTargetType.descriptor
            end

            # Returns the descriptor for the VanityPharmaDisplayUrlMode enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the VanityPharmaDisplayUrlMode enum
            def self.vanity_pharma_display_url_mode
              require "google/ads/google_ads/v7/enums/vanity_pharma_display_url_mode_pb"
              Google::Ads::GoogleAds::V7::Enums::VanityPharmaDisplayUrlModeEnum::VanityPharmaDisplayUrlMode.descriptor
            end

            # Returns the descriptor for the VanityPharmaText enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the VanityPharmaText enum
            def self.vanity_pharma_text
              require "google/ads/google_ads/v7/enums/vanity_pharma_text_pb"
              Google::Ads::GoogleAds::V7::Enums::VanityPharmaTextEnum::VanityPharmaText.descriptor
            end

            # Returns the descriptor for the CampaignCriterionStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CampaignCriterionStatus enum
            def self.campaign_criterion_status
              require "google/ads/google_ads/v7/enums/campaign_criterion_status_pb"
              Google::Ads::GoogleAds::V7::Enums::CampaignCriterionStatusEnum::CampaignCriterionStatus.descriptor
            end

            # Returns the descriptor for the CustomAudienceMemberType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CustomAudienceMemberType enum
            def self.custom_audience_member_type
              require "google/ads/google_ads/v7/enums/custom_audience_member_type_pb"
              Google::Ads::GoogleAds::V7::Enums::CustomAudienceMemberTypeEnum::CustomAudienceMemberType.descriptor
            end

            # Returns the descriptor for the CustomAudienceStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CustomAudienceStatus enum
            def self.custom_audience_status
              require "google/ads/google_ads/v7/enums/custom_audience_status_pb"
              Google::Ads::GoogleAds::V7::Enums::CustomAudienceStatusEnum::CustomAudienceStatus.descriptor
            end

            # Returns the descriptor for the CustomAudienceType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CustomAudienceType enum
            def self.custom_audience_type
              require "google/ads/google_ads/v7/enums/custom_audience_type_pb"
              Google::Ads::GoogleAds::V7::Enums::CustomAudienceTypeEnum::CustomAudienceType.descriptor
            end

            # Returns the descriptor for the ProductBiddingCategoryStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ProductBiddingCategoryStatus enum
            def self.product_bidding_category_status
              require "google/ads/google_ads/v7/enums/product_bidding_category_status_pb"
              Google::Ads::GoogleAds::V7::Enums::ProductBiddingCategoryStatusEnum::ProductBiddingCategoryStatus.descriptor
            end

            # Returns the descriptor for the MerchantCenterLinkStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the MerchantCenterLinkStatus enum
            def self.merchant_center_link_status
              require "google/ads/google_ads/v7/enums/merchant_center_link_status_pb"
              Google::Ads::GoogleAds::V7::Enums::MerchantCenterLinkStatusEnum::MerchantCenterLinkStatus.descriptor
            end

            # Returns the descriptor for the FeedItemTargetDevice enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FeedItemTargetDevice enum
            def self.feed_item_target_device
              require "google/ads/google_ads/v7/enums/feed_item_target_device_pb"
              Google::Ads::GoogleAds::V7::Enums::FeedItemTargetDeviceEnum::FeedItemTargetDevice.descriptor
            end

            # Returns the descriptor for the FeedItemTargetStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FeedItemTargetStatus enum
            def self.feed_item_target_status
              require "google/ads/google_ads/v7/enums/feed_item_target_status_pb"
              Google::Ads::GoogleAds::V7::Enums::FeedItemTargetStatusEnum::FeedItemTargetStatus.descriptor
            end

            # Returns the descriptor for the FeedItemTargetType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FeedItemTargetType enum
            def self.feed_item_target_type
              require "google/ads/google_ads/v7/enums/feed_item_target_type_pb"
              Google::Ads::GoogleAds::V7::Enums::FeedItemTargetTypeEnum::FeedItemTargetType.descriptor
            end

            # Returns the descriptor for the AppStore enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AppStore enum
            def self.app_store
              require "google/ads/google_ads/v7/enums/app_store_pb"
              Google::Ads::GoogleAds::V7::Enums::AppStoreEnum::AppStore.descriptor
            end

            # Returns the descriptor for the PriceExtensionPriceQualifier enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the PriceExtensionPriceQualifier enum
            def self.price_extension_price_qualifier
              require "google/ads/google_ads/v7/enums/price_extension_price_qualifier_pb"
              Google::Ads::GoogleAds::V7::Enums::PriceExtensionPriceQualifierEnum::PriceExtensionPriceQualifier.descriptor
            end

            # Returns the descriptor for the PriceExtensionPriceUnit enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the PriceExtensionPriceUnit enum
            def self.price_extension_price_unit
              require "google/ads/google_ads/v7/enums/price_extension_price_unit_pb"
              Google::Ads::GoogleAds::V7::Enums::PriceExtensionPriceUnitEnum::PriceExtensionPriceUnit.descriptor
            end

            # Returns the descriptor for the PriceExtensionType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the PriceExtensionType enum
            def self.price_extension_type
              require "google/ads/google_ads/v7/enums/price_extension_type_pb"
              Google::Ads::GoogleAds::V7::Enums::PriceExtensionTypeEnum::PriceExtensionType.descriptor
            end

            # Returns the descriptor for the PromotionExtensionDiscountModifier enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the PromotionExtensionDiscountModifier enum
            def self.promotion_extension_discount_modifier
              require "google/ads/google_ads/v7/enums/promotion_extension_discount_modifier_pb"
              Google::Ads::GoogleAds::V7::Enums::PromotionExtensionDiscountModifierEnum::PromotionExtensionDiscountModifier.descriptor
            end

            # Returns the descriptor for the PromotionExtensionOccasion enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the PromotionExtensionOccasion enum
            def self.promotion_extension_occasion
              require "google/ads/google_ads/v7/enums/promotion_extension_occasion_pb"
              Google::Ads::GoogleAds::V7::Enums::PromotionExtensionOccasionEnum::PromotionExtensionOccasion.descriptor
            end

            # Returns the descriptor for the UserIdentifierSource enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the UserIdentifierSource enum
            def self.user_identifier_source
              require "google/ads/google_ads/v7/enums/user_identifier_source_pb"
              Google::Ads::GoogleAds::V7::Enums::UserIdentifierSourceEnum::UserIdentifierSource.descriptor
            end

            # Returns the descriptor for the OfflineUserDataJobFailureReason enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the OfflineUserDataJobFailureReason enum
            def self.offline_user_data_job_failure_reason
              require "google/ads/google_ads/v7/enums/offline_user_data_job_failure_reason_pb"
              Google::Ads::GoogleAds::V7::Enums::OfflineUserDataJobFailureReasonEnum::OfflineUserDataJobFailureReason.descriptor
            end

            # Returns the descriptor for the OfflineUserDataJobStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the OfflineUserDataJobStatus enum
            def self.offline_user_data_job_status
              require "google/ads/google_ads/v7/enums/offline_user_data_job_status_pb"
              Google::Ads::GoogleAds::V7::Enums::OfflineUserDataJobStatusEnum::OfflineUserDataJobStatus.descriptor
            end

            # Returns the descriptor for the OfflineUserDataJobType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the OfflineUserDataJobType enum
            def self.offline_user_data_job_type
              require "google/ads/google_ads/v7/enums/offline_user_data_job_type_pb"
              Google::Ads::GoogleAds::V7::Enums::OfflineUserDataJobTypeEnum::OfflineUserDataJobType.descriptor
            end

            # Returns the descriptor for the LeadFormCallToActionType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the LeadFormCallToActionType enum
            def self.lead_form_call_to_action_type
              require "google/ads/google_ads/v7/enums/lead_form_call_to_action_type_pb"
              Google::Ads::GoogleAds::V7::Enums::LeadFormCallToActionTypeEnum::LeadFormCallToActionType.descriptor
            end

            # Returns the descriptor for the LeadFormDesiredIntent enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the LeadFormDesiredIntent enum
            def self.lead_form_desired_intent
              require "google/ads/google_ads/v7/enums/lead_form_desired_intent_pb"
              Google::Ads::GoogleAds::V7::Enums::LeadFormDesiredIntentEnum::LeadFormDesiredIntent.descriptor
            end

            # Returns the descriptor for the LeadFormFieldUserInputType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the LeadFormFieldUserInputType enum
            def self.lead_form_field_user_input_type
              require "google/ads/google_ads/v7/enums/lead_form_field_user_input_type_pb"
              Google::Ads::GoogleAds::V7::Enums::LeadFormFieldUserInputTypeEnum::LeadFormFieldUserInputType.descriptor
            end

            # Returns the descriptor for the LeadFormPostSubmitCallToActionType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the LeadFormPostSubmitCallToActionType enum
            def self.lead_form_post_submit_call_to_action_type
              require "google/ads/google_ads/v7/enums/lead_form_post_submit_call_to_action_type_pb"
              Google::Ads::GoogleAds::V7::Enums::LeadFormPostSubmitCallToActionTypeEnum::LeadFormPostSubmitCallToActionType.descriptor
            end

            # Returns the descriptor for the AssetType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AssetType enum
            def self.asset_type
              require "google/ads/google_ads/v7/enums/asset_type_pb"
              Google::Ads::GoogleAds::V7::Enums::AssetTypeEnum::AssetType.descriptor
            end

            # Returns the descriptor for the CampaignDraftStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CampaignDraftStatus enum
            def self.campaign_draft_status
              require "google/ads/google_ads/v7/enums/campaign_draft_status_pb"
              Google::Ads::GoogleAds::V7::Enums::CampaignDraftStatusEnum::CampaignDraftStatus.descriptor
            end

            # Returns the descriptor for the AccountLinkStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AccountLinkStatus enum
            def self.account_link_status
              require "google/ads/google_ads/v7/enums/account_link_status_pb"
              Google::Ads::GoogleAds::V7::Enums::AccountLinkStatusEnum::AccountLinkStatus.descriptor
            end

            # Returns the descriptor for the LinkedAccountType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the LinkedAccountType enum
            def self.linked_account_type
              require "google/ads/google_ads/v7/enums/linked_account_type_pb"
              Google::Ads::GoogleAds::V7::Enums::LinkedAccountTypeEnum::LinkedAccountType.descriptor
            end

            # Returns the descriptor for the MobileAppVendor enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the MobileAppVendor enum
            def self.mobile_app_vendor
              require "google/ads/google_ads/v7/enums/mobile_app_vendor_pb"
              Google::Ads::GoogleAds::V7::Enums::MobileAppVendorEnum::MobileAppVendor.descriptor
            end

            # Returns the descriptor for the MediaType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the MediaType enum
            def self.media_type
              require "google/ads/google_ads/v7/enums/media_type_pb"
              Google::Ads::GoogleAds::V7::Enums::MediaTypeEnum::MediaType.descriptor
            end

            # Returns the descriptor for the DistanceBucket enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the DistanceBucket enum
            def self.distance_bucket
              require "google/ads/google_ads/v7/enums/distance_bucket_pb"
              Google::Ads::GoogleAds::V7::Enums::DistanceBucketEnum::DistanceBucket.descriptor
            end

            # Returns the descriptor for the CampaignExperimentStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CampaignExperimentStatus enum
            def self.campaign_experiment_status
              require "google/ads/google_ads/v7/enums/campaign_experiment_status_pb"
              Google::Ads::GoogleAds::V7::Enums::CampaignExperimentStatusEnum::CampaignExperimentStatus.descriptor
            end

            # Returns the descriptor for the CampaignExperimentTrafficSplitType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CampaignExperimentTrafficSplitType enum
            def self.campaign_experiment_traffic_split_type
              require "google/ads/google_ads/v7/enums/campaign_experiment_traffic_split_type_pb"
              Google::Ads::GoogleAds::V7::Enums::CampaignExperimentTrafficSplitTypeEnum::CampaignExperimentTrafficSplitType.descriptor
            end

            # Returns the descriptor for the FeedItemSetStringFilterType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FeedItemSetStringFilterType enum
            def self.feed_item_set_string_filter_type
              require "google/ads/google_ads/v7/enums/feed_item_set_string_filter_type_pb"
              Google::Ads::GoogleAds::V7::Enums::FeedItemSetStringFilterTypeEnum::FeedItemSetStringFilterType.descriptor
            end

            # Returns the descriptor for the FeedItemSetStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FeedItemSetStatus enum
            def self.feed_item_set_status
              require "google/ads/google_ads/v7/enums/feed_item_set_status_pb"
              Google::Ads::GoogleAds::V7::Enums::FeedItemSetStatusEnum::FeedItemSetStatus.descriptor
            end

            # Returns the descriptor for the KeywordPlanNetwork enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the KeywordPlanNetwork enum
            def self.keyword_plan_network
              require "google/ads/google_ads/v7/enums/keyword_plan_network_pb"
              Google::Ads::GoogleAds::V7::Enums::KeywordPlanNetworkEnum::KeywordPlanNetwork.descriptor
            end

            # Returns the descriptor for the UserInterestTaxonomyType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the UserInterestTaxonomyType enum
            def self.user_interest_taxonomy_type
              require "google/ads/google_ads/v7/enums/user_interest_taxonomy_type_pb"
              Google::Ads::GoogleAds::V7::Enums::UserInterestTaxonomyTypeEnum::UserInterestTaxonomyType.descriptor
            end

            # Returns the descriptor for the GeoTargetingType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the GeoTargetingType enum
            def self.geo_targeting_type
              require "google/ads/google_ads/v7/enums/geo_targeting_type_pb"
              Google::Ads::GoogleAds::V7::Enums::GeoTargetingTypeEnum::GeoTargetingType.descriptor
            end

            # Returns the descriptor for the RecommendationType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the RecommendationType enum
            def self.recommendation_type
              require "google/ads/google_ads/v7/enums/recommendation_type_pb"
              Google::Ads::GoogleAds::V7::Enums::RecommendationTypeEnum::RecommendationType.descriptor
            end

            # Returns the descriptor for the TargetCpaOptInRecommendationGoal enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the TargetCpaOptInRecommendationGoal enum
            def self.target_cpa_opt_in_recommendation_goal
              require "google/ads/google_ads/v7/enums/target_cpa_opt_in_recommendation_goal_pb"
              Google::Ads::GoogleAds::V7::Enums::TargetCpaOptInRecommendationGoalEnum::TargetCpaOptInRecommendationGoal.descriptor
            end

            # Returns the descriptor for the SharedSetStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the SharedSetStatus enum
            def self.shared_set_status
              require "google/ads/google_ads/v7/enums/shared_set_status_pb"
              Google::Ads::GoogleAds::V7::Enums::SharedSetStatusEnum::SharedSetStatus.descriptor
            end

            # Returns the descriptor for the SharedSetType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the SharedSetType enum
            def self.shared_set_type
              require "google/ads/google_ads/v7/enums/shared_set_type_pb"
              Google::Ads::GoogleAds::V7::Enums::SharedSetTypeEnum::SharedSetType.descriptor
            end

            # Returns the descriptor for the TrackingCodePageFormat enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the TrackingCodePageFormat enum
            def self.tracking_code_page_format
              require "google/ads/google_ads/v7/enums/tracking_code_page_format_pb"
              Google::Ads::GoogleAds::V7::Enums::TrackingCodePageFormatEnum::TrackingCodePageFormat.descriptor
            end

            # Returns the descriptor for the TrackingCodeType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the TrackingCodeType enum
            def self.tracking_code_type
              require "google/ads/google_ads/v7/enums/tracking_code_type_pb"
              Google::Ads::GoogleAds::V7::Enums::TrackingCodeTypeEnum::TrackingCodeType.descriptor
            end

            # Returns the descriptor for the LabelStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the LabelStatus enum
            def self.label_status
              require "google/ads/google_ads/v7/enums/label_status_pb"
              Google::Ads::GoogleAds::V7::Enums::LabelStatusEnum::LabelStatus.descriptor
            end

            # Returns the descriptor for the CombinedAudienceStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CombinedAudienceStatus enum
            def self.combined_audience_status
              require "google/ads/google_ads/v7/enums/combined_audience_status_pb"
              Google::Ads::GoogleAds::V7::Enums::CombinedAudienceStatusEnum::CombinedAudienceStatus.descriptor
            end

            # Returns the descriptor for the ConversionCustomVariableStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ConversionCustomVariableStatus enum
            def self.conversion_custom_variable_status
              require "google/ads/google_ads/v7/enums/conversion_custom_variable_status_pb"
              Google::Ads::GoogleAds::V7::Enums::ConversionCustomVariableStatusEnum::ConversionCustomVariableStatus.descriptor
            end

            # Returns the descriptor for the BatchJobStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the BatchJobStatus enum
            def self.batch_job_status
              require "google/ads/google_ads/v7/enums/batch_job_status_pb"
              Google::Ads::GoogleAds::V7::Enums::BatchJobStatusEnum::BatchJobStatus.descriptor
            end

            # Returns the descriptor for the CustomInterestMemberType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CustomInterestMemberType enum
            def self.custom_interest_member_type
              require "google/ads/google_ads/v7/enums/custom_interest_member_type_pb"
              Google::Ads::GoogleAds::V7::Enums::CustomInterestMemberTypeEnum::CustomInterestMemberType.descriptor
            end

            # Returns the descriptor for the CustomInterestStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CustomInterestStatus enum
            def self.custom_interest_status
              require "google/ads/google_ads/v7/enums/custom_interest_status_pb"
              Google::Ads::GoogleAds::V7::Enums::CustomInterestStatusEnum::CustomInterestStatus.descriptor
            end

            # Returns the descriptor for the CustomInterestType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CustomInterestType enum
            def self.custom_interest_type
              require "google/ads/google_ads/v7/enums/custom_interest_type_pb"
              Google::Ads::GoogleAds::V7::Enums::CustomInterestTypeEnum::CustomInterestType.descriptor
            end

            # Returns the descriptor for the ChangeStatusOperation enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ChangeStatusOperation enum
            def self.change_status_operation
              require "google/ads/google_ads/v7/enums/change_status_operation_pb"
              Google::Ads::GoogleAds::V7::Enums::ChangeStatusOperationEnum::ChangeStatusOperation.descriptor
            end

            # Returns the descriptor for the ChangeStatusResourceType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ChangeStatusResourceType enum
            def self.change_status_resource_type
              require "google/ads/google_ads/v7/enums/change_status_resource_type_pb"
              Google::Ads::GoogleAds::V7::Enums::ChangeStatusResourceTypeEnum::ChangeStatusResourceType.descriptor
            end

            # Returns the descriptor for the SearchTermTargetingStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the SearchTermTargetingStatus enum
            def self.search_term_targeting_status
              require "google/ads/google_ads/v7/enums/search_term_targeting_status_pb"
              Google::Ads::GoogleAds::V7::Enums::SearchTermTargetingStatusEnum::SearchTermTargetingStatus.descriptor
            end

            # Returns the descriptor for the AccessInvitationStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AccessInvitationStatus enum
            def self.access_invitation_status
              require "google/ads/google_ads/v7/enums/access_invitation_status_pb"
              Google::Ads::GoogleAds::V7::Enums::AccessInvitationStatusEnum::AccessInvitationStatus.descriptor
            end

            # Returns the descriptor for the AccessRole enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AccessRole enum
            def self.access_role
              require "google/ads/google_ads/v7/enums/access_role_pb"
              Google::Ads::GoogleAds::V7::Enums::AccessRoleEnum::AccessRole.descriptor
            end

            # Returns the descriptor for the GoogleAdsFieldCategory enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the GoogleAdsFieldCategory enum
            def self.google_ads_field_category
              require "google/ads/google_ads/v7/enums/google_ads_field_category_pb"
              Google::Ads::GoogleAds::V7::Enums::GoogleAdsFieldCategoryEnum::GoogleAdsFieldCategory.descriptor
            end

            # Returns the descriptor for the GoogleAdsFieldDataType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the GoogleAdsFieldDataType enum
            def self.google_ads_field_data_type
              require "google/ads/google_ads/v7/enums/google_ads_field_data_type_pb"
              Google::Ads::GoogleAds::V7::Enums::GoogleAdsFieldDataTypeEnum::GoogleAdsFieldDataType.descriptor
            end

            # Returns the descriptor for the AccountBudgetProposalType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AccountBudgetProposalType enum
            def self.account_budget_proposal_type
              require "google/ads/google_ads/v7/enums/account_budget_proposal_type_pb"
              Google::Ads::GoogleAds::V7::Enums::AccountBudgetProposalTypeEnum::AccountBudgetProposalType.descriptor
            end

            # Returns the descriptor for the AccountBudgetStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AccountBudgetStatus enum
            def self.account_budget_status
              require "google/ads/google_ads/v7/enums/account_budget_status_pb"
              Google::Ads::GoogleAds::V7::Enums::AccountBudgetStatusEnum::AccountBudgetStatus.descriptor
            end

            # Returns the descriptor for the SpendingLimitType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the SpendingLimitType enum
            def self.spending_limit_type
              require "google/ads/google_ads/v7/enums/spending_limit_type_pb"
              Google::Ads::GoogleAds::V7::Enums::SpendingLimitTypeEnum::SpendingLimitType.descriptor
            end

            # Returns the descriptor for the OperatingSystemVersionOperatorType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the OperatingSystemVersionOperatorType enum
            def self.operating_system_version_operator_type
              require "google/ads/google_ads/v7/enums/operating_system_version_operator_type_pb"
              Google::Ads::GoogleAds::V7::Enums::OperatingSystemVersionOperatorTypeEnum::OperatingSystemVersionOperatorType.descriptor
            end

            # Returns the descriptor for the AttributionModel enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AttributionModel enum
            def self.attribution_model
              require "google/ads/google_ads/v7/enums/attribution_model_pb"
              Google::Ads::GoogleAds::V7::Enums::AttributionModelEnum::AttributionModel.descriptor
            end

            # Returns the descriptor for the ConversionActionCategory enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ConversionActionCategory enum
            def self.conversion_action_category
              require "google/ads/google_ads/v7/enums/conversion_action_category_pb"
              Google::Ads::GoogleAds::V7::Enums::ConversionActionCategoryEnum::ConversionActionCategory.descriptor
            end

            # Returns the descriptor for the ConversionActionCountingType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ConversionActionCountingType enum
            def self.conversion_action_counting_type
              require "google/ads/google_ads/v7/enums/conversion_action_counting_type_pb"
              Google::Ads::GoogleAds::V7::Enums::ConversionActionCountingTypeEnum::ConversionActionCountingType.descriptor
            end

            # Returns the descriptor for the ConversionActionStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ConversionActionStatus enum
            def self.conversion_action_status
              require "google/ads/google_ads/v7/enums/conversion_action_status_pb"
              Google::Ads::GoogleAds::V7::Enums::ConversionActionStatusEnum::ConversionActionStatus.descriptor
            end

            # Returns the descriptor for the ConversionActionType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ConversionActionType enum
            def self.conversion_action_type
              require "google/ads/google_ads/v7/enums/conversion_action_type_pb"
              Google::Ads::GoogleAds::V7::Enums::ConversionActionTypeEnum::ConversionActionType.descriptor
            end

            # Returns the descriptor for the DataDrivenModelStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the DataDrivenModelStatus enum
            def self.data_driven_model_status
              require "google/ads/google_ads/v7/enums/data_driven_model_status_pb"
              Google::Ads::GoogleAds::V7::Enums::DataDrivenModelStatusEnum::DataDrivenModelStatus.descriptor
            end

            # Returns the descriptor for the AccountBudgetProposalStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AccountBudgetProposalStatus enum
            def self.account_budget_proposal_status
              require "google/ads/google_ads/v7/enums/account_budget_proposal_status_pb"
              Google::Ads::GoogleAds::V7::Enums::AccountBudgetProposalStatusEnum::AccountBudgetProposalStatus.descriptor
            end

            # Returns the descriptor for the KeywordPlanForecastInterval enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the KeywordPlanForecastInterval enum
            def self.keyword_plan_forecast_interval
              require "google/ads/google_ads/v7/enums/keyword_plan_forecast_interval_pb"
              Google::Ads::GoogleAds::V7::Enums::KeywordPlanForecastIntervalEnum::KeywordPlanForecastInterval.descriptor
            end

            # Returns the descriptor for the ResponseContentType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ResponseContentType enum
            def self.response_content_type
              require "google/ads/google_ads/v7/enums/response_content_type_pb"
              Google::Ads::GoogleAds::V7::Enums::ResponseContentTypeEnum::ResponseContentType.descriptor
            end

            # Returns the descriptor for the InteractionEventType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the InteractionEventType enum
            def self.interaction_event_type
              require "google/ads/google_ads/v7/enums/interaction_event_type_pb"
              Google::Ads::GoogleAds::V7::Enums::InteractionEventTypeEnum::InteractionEventType.descriptor
            end

            # Returns the descriptor for the AdDestinationType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AdDestinationType enum
            def self.ad_destination_type
              require "google/ads/google_ads/v7/enums/ad_destination_type_pb"
              Google::Ads::GoogleAds::V7::Enums::AdDestinationTypeEnum::AdDestinationType.descriptor
            end

            # Returns the descriptor for the AdNetworkType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AdNetworkType enum
            def self.ad_network_type
              require "google/ads/google_ads/v7/enums/ad_network_type_pb"
              Google::Ads::GoogleAds::V7::Enums::AdNetworkTypeEnum::AdNetworkType.descriptor
            end

            # Returns the descriptor for the BudgetCampaignAssociationStatus enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the BudgetCampaignAssociationStatus enum
            def self.budget_campaign_association_status
              require "google/ads/google_ads/v7/enums/budget_campaign_association_status_pb"
              Google::Ads::GoogleAds::V7::Enums::BudgetCampaignAssociationStatusEnum::BudgetCampaignAssociationStatus.descriptor
            end

            # Returns the descriptor for the ClickType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ClickType enum
            def self.click_type
              require "google/ads/google_ads/v7/enums/click_type_pb"
              Google::Ads::GoogleAds::V7::Enums::ClickTypeEnum::ClickType.descriptor
            end

            # Returns the descriptor for the ConversionAttributionEventType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ConversionAttributionEventType enum
            def self.conversion_attribution_event_type
              require "google/ads/google_ads/v7/enums/conversion_attribution_event_type_pb"
              Google::Ads::GoogleAds::V7::Enums::ConversionAttributionEventTypeEnum::ConversionAttributionEventType.descriptor
            end

            # Returns the descriptor for the ConversionLagBucket enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ConversionLagBucket enum
            def self.conversion_lag_bucket
              require "google/ads/google_ads/v7/enums/conversion_lag_bucket_pb"
              Google::Ads::GoogleAds::V7::Enums::ConversionLagBucketEnum::ConversionLagBucket.descriptor
            end

            # Returns the descriptor for the ConversionOrAdjustmentLagBucket enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ConversionOrAdjustmentLagBucket enum
            def self.conversion_or_adjustment_lag_bucket
              require "google/ads/google_ads/v7/enums/conversion_or_adjustment_lag_bucket_pb"
              Google::Ads::GoogleAds::V7::Enums::ConversionOrAdjustmentLagBucketEnum::ConversionOrAdjustmentLagBucket.descriptor
            end

            # Returns the descriptor for the ExternalConversionSource enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ExternalConversionSource enum
            def self.external_conversion_source
              require "google/ads/google_ads/v7/enums/external_conversion_source_pb"
              Google::Ads::GoogleAds::V7::Enums::ExternalConversionSourceEnum::ExternalConversionSource.descriptor
            end

            # Returns the descriptor for the HotelPriceBucket enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the HotelPriceBucket enum
            def self.hotel_price_bucket
              require "google/ads/google_ads/v7/enums/hotel_price_bucket_pb"
              Google::Ads::GoogleAds::V7::Enums::HotelPriceBucketEnum::HotelPriceBucket.descriptor
            end

            # Returns the descriptor for the HotelRateType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the HotelRateType enum
            def self.hotel_rate_type
              require "google/ads/google_ads/v7/enums/hotel_rate_type_pb"
              Google::Ads::GoogleAds::V7::Enums::HotelRateTypeEnum::HotelRateType.descriptor
            end

            # Returns the descriptor for the SearchEngineResultsPageType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the SearchEngineResultsPageType enum
            def self.search_engine_results_page_type
              require "google/ads/google_ads/v7/enums/search_engine_results_page_type_pb"
              Google::Ads::GoogleAds::V7::Enums::SearchEngineResultsPageTypeEnum::SearchEngineResultsPageType.descriptor
            end

            # Returns the descriptor for the SearchTermMatchType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the SearchTermMatchType enum
            def self.search_term_match_type
              require "google/ads/google_ads/v7/enums/search_term_match_type_pb"
              Google::Ads::GoogleAds::V7::Enums::SearchTermMatchTypeEnum::SearchTermMatchType.descriptor
            end

            # Returns the descriptor for the Slot enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the Slot enum
            def self.slot
              require "google/ads/google_ads/v7/enums/slot_pb"
              Google::Ads::GoogleAds::V7::Enums::SlotEnum::Slot.descriptor
            end

            # Returns the descriptor for the SummaryRowSetting enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the SummaryRowSetting enum
            def self.summary_row_setting
              require "google/ads/google_ads/v7/enums/summary_row_setting_pb"
              Google::Ads::GoogleAds::V7::Enums::SummaryRowSettingEnum::SummaryRowSetting.descriptor
            end

            # Returns the descriptor for the KeywordPlanAggregateMetricType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the KeywordPlanAggregateMetricType enum
            def self.keyword_plan_aggregate_metric_type
              require "google/ads/google_ads/v7/enums/keyword_plan_aggregate_metric_type_pb"
              Google::Ads::GoogleAds::V7::Enums::KeywordPlanAggregateMetricTypeEnum::KeywordPlanAggregateMetricType.descriptor
            end

            # Returns the descriptor for the KeywordPlanCompetitionLevel enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the KeywordPlanCompetitionLevel enum
            def self.keyword_plan_competition_level
              require "google/ads/google_ads/v7/enums/keyword_plan_competition_level_pb"
              Google::Ads::GoogleAds::V7::Enums::KeywordPlanCompetitionLevelEnum::KeywordPlanCompetitionLevel.descriptor
            end

            # Returns the descriptor for the KeywordPlanConceptGroupType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the KeywordPlanConceptGroupType enum
            def self.keyword_plan_concept_group_type
              require "google/ads/google_ads/v7/enums/keyword_plan_concept_group_type_pb"
              Google::Ads::GoogleAds::V7::Enums::KeywordPlanConceptGroupTypeEnum::KeywordPlanConceptGroupType.descriptor
            end

            # Returns the descriptor for the ReachPlanAdLength enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ReachPlanAdLength enum
            def self.reach_plan_ad_length
              require "google/ads/google_ads/v7/enums/reach_plan_ad_length_pb"
              Google::Ads::GoogleAds::V7::Enums::ReachPlanAdLengthEnum::ReachPlanAdLength.descriptor
            end

            # Returns the descriptor for the ReachPlanAgeRange enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ReachPlanAgeRange enum
            def self.reach_plan_age_range
              require "google/ads/google_ads/v7/enums/reach_plan_age_range_pb"
              Google::Ads::GoogleAds::V7::Enums::ReachPlanAgeRangeEnum::ReachPlanAgeRange.descriptor
            end

            # Returns the descriptor for the ReachPlanNetwork enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ReachPlanNetwork enum
            def self.reach_plan_network
              require "google/ads/google_ads/v7/enums/reach_plan_network_pb"
              Google::Ads::GoogleAds::V7::Enums::ReachPlanNetworkEnum::ReachPlanNetwork.descriptor
            end

            # Returns the descriptor for the KeywordPlanKeywordAnnotation enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the KeywordPlanKeywordAnnotation enum
            def self.keyword_plan_keyword_annotation
              require "google/ads/google_ads/v7/enums/keyword_plan_keyword_annotation_pb"
              Google::Ads::GoogleAds::V7::Enums::KeywordPlanKeywordAnnotationEnum::KeywordPlanKeywordAnnotation.descriptor
            end

            # Returns the descriptor for the ConversionAdjustmentType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ConversionAdjustmentType enum
            def self.conversion_adjustment_type
              require "google/ads/google_ads/v7/enums/conversion_adjustment_type_pb"
              Google::Ads::GoogleAds::V7::Enums::ConversionAdjustmentTypeEnum::ConversionAdjustmentType.descriptor
            end

            # Returns the descriptor for the ResourceLimitType enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ResourceLimitType enum
            def self.resource_limit_type
              require "google/ads/google_ads/v7/enums/resource_limit_type_pb"
              Google::Ads::GoogleAds::V7::Enums::ResourceLimitTypeEnum::ResourceLimitType.descriptor
            end

            # Returns the descriptor for the KeywordPlanCampaignError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the KeywordPlanCampaignError enum
            def self.keyword_plan_campaign_error
              require "google/ads/google_ads/v7/errors/keyword_plan_campaign_error_pb"
              Google::Ads::GoogleAds::V7::Errors::KeywordPlanCampaignErrorEnum::KeywordPlanCampaignError.descriptor
            end

            # Returns the descriptor for the UserDataError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the UserDataError enum
            def self.user_data_error
              require "google/ads/google_ads/v7/errors/user_data_error_pb"
              Google::Ads::GoogleAds::V7::Errors::UserDataErrorEnum::UserDataError.descriptor
            end

            # Returns the descriptor for the KeywordPlanAdGroupError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the KeywordPlanAdGroupError enum
            def self.keyword_plan_ad_group_error
              require "google/ads/google_ads/v7/errors/keyword_plan_ad_group_error_pb"
              Google::Ads::GoogleAds::V7::Errors::KeywordPlanAdGroupErrorEnum::KeywordPlanAdGroupError.descriptor
            end

            # Returns the descriptor for the CustomerClientLinkError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CustomerClientLinkError enum
            def self.customer_client_link_error
              require "google/ads/google_ads/v7/errors/customer_client_link_error_pb"
              Google::Ads::GoogleAds::V7::Errors::CustomerClientLinkErrorEnum::CustomerClientLinkError.descriptor
            end

            # Returns the descriptor for the AdError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AdError enum
            def self.ad_error
              require "google/ads/google_ads/v7/errors/ad_error_pb"
              Google::Ads::GoogleAds::V7::Errors::AdErrorEnum::AdError.descriptor
            end

            # Returns the descriptor for the CustomerManagerLinkError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CustomerManagerLinkError enum
            def self.customer_manager_link_error
              require "google/ads/google_ads/v7/errors/customer_manager_link_error_pb"
              Google::Ads::GoogleAds::V7::Errors::CustomerManagerLinkErrorEnum::CustomerManagerLinkError.descriptor
            end

            # Returns the descriptor for the CustomAudienceError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CustomAudienceError enum
            def self.custom_audience_error
              require "google/ads/google_ads/v7/errors/custom_audience_error_pb"
              Google::Ads::GoogleAds::V7::Errors::CustomAudienceErrorEnum::CustomAudienceError.descriptor
            end

            # Returns the descriptor for the InvoiceError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the InvoiceError enum
            def self.invoice_error
              require "google/ads/google_ads/v7/errors/invoice_error_pb"
              Google::Ads::GoogleAds::V7::Errors::InvoiceErrorEnum::InvoiceError.descriptor
            end

            # Returns the descriptor for the AccountBudgetProposalError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AccountBudgetProposalError enum
            def self.account_budget_proposal_error
              require "google/ads/google_ads/v7/errors/account_budget_proposal_error_pb"
              Google::Ads::GoogleAds::V7::Errors::AccountBudgetProposalErrorEnum::AccountBudgetProposalError.descriptor
            end

            # Returns the descriptor for the CustomerError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CustomerError enum
            def self.customer_error
              require "google/ads/google_ads/v7/errors/customer_error_pb"
              Google::Ads::GoogleAds::V7::Errors::CustomerErrorEnum::CustomerError.descriptor
            end

            # Returns the descriptor for the BatchJobError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the BatchJobError enum
            def self.batch_job_error
              require "google/ads/google_ads/v7/errors/batch_job_error_pb"
              Google::Ads::GoogleAds::V7::Errors::BatchJobErrorEnum::BatchJobError.descriptor
            end

            # Returns the descriptor for the RequestError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the RequestError enum
            def self.request_error
              require "google/ads/google_ads/v7/errors/request_error_pb"
              Google::Ads::GoogleAds::V7::Errors::RequestErrorEnum::RequestError.descriptor
            end

            # Returns the descriptor for the KeywordPlanCampaignKeywordError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the KeywordPlanCampaignKeywordError enum
            def self.keyword_plan_campaign_keyword_error
              require "google/ads/google_ads/v7/errors/keyword_plan_campaign_keyword_error_pb"
              Google::Ads::GoogleAds::V7::Errors::KeywordPlanCampaignKeywordErrorEnum::KeywordPlanCampaignKeywordError.descriptor
            end

            # Returns the descriptor for the SharedSetError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the SharedSetError enum
            def self.shared_set_error
              require "google/ads/google_ads/v7/errors/shared_set_error_pb"
              Google::Ads::GoogleAds::V7::Errors::SharedSetErrorEnum::SharedSetError.descriptor
            end

            # Returns the descriptor for the AssetLinkError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AssetLinkError enum
            def self.asset_link_error
              require "google/ads/google_ads/v7/errors/asset_link_error_pb"
              Google::Ads::GoogleAds::V7::Errors::AssetLinkErrorEnum::AssetLinkError.descriptor
            end

            # Returns the descriptor for the NotEmptyError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the NotEmptyError enum
            def self.not_empty_error
              require "google/ads/google_ads/v7/errors/not_empty_error_pb"
              Google::Ads::GoogleAds::V7::Errors::NotEmptyErrorEnum::NotEmptyError.descriptor
            end

            # Returns the descriptor for the ImageError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ImageError enum
            def self.image_error
              require "google/ads/google_ads/v7/errors/image_error_pb"
              Google::Ads::GoogleAds::V7::Errors::ImageErrorEnum::ImageError.descriptor
            end

            # Returns the descriptor for the SettingError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the SettingError enum
            def self.setting_error
              require "google/ads/google_ads/v7/errors/setting_error_pb"
              Google::Ads::GoogleAds::V7::Errors::SettingErrorEnum::SettingError.descriptor
            end

            # Returns the descriptor for the FeedItemTargetError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FeedItemTargetError enum
            def self.feed_item_target_error
              require "google/ads/google_ads/v7/errors/feed_item_target_error_pb"
              Google::Ads::GoogleAds::V7::Errors::FeedItemTargetErrorEnum::FeedItemTargetError.descriptor
            end

            # Returns the descriptor for the KeywordPlanAdGroupKeywordError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the KeywordPlanAdGroupKeywordError enum
            def self.keyword_plan_ad_group_keyword_error
              require "google/ads/google_ads/v7/errors/keyword_plan_ad_group_keyword_error_pb"
              Google::Ads::GoogleAds::V7::Errors::KeywordPlanAdGroupKeywordErrorEnum::KeywordPlanAdGroupKeywordError.descriptor
            end

            # Returns the descriptor for the LanguageCodeError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the LanguageCodeError enum
            def self.language_code_error
              require "google/ads/google_ads/v7/errors/language_code_error_pb"
              Google::Ads::GoogleAds::V7::Errors::LanguageCodeErrorEnum::LanguageCodeError.descriptor
            end

            # Returns the descriptor for the FieldMaskError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FieldMaskError enum
            def self.field_mask_error
              require "google/ads/google_ads/v7/errors/field_mask_error_pb"
              Google::Ads::GoogleAds::V7::Errors::FieldMaskErrorEnum::FieldMaskError.descriptor
            end

            # Returns the descriptor for the DistinctError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the DistinctError enum
            def self.distinct_error
              require "google/ads/google_ads/v7/errors/distinct_error_pb"
              Google::Ads::GoogleAds::V7::Errors::DistinctErrorEnum::DistinctError.descriptor
            end

            # Returns the descriptor for the ConversionActionError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ConversionActionError enum
            def self.conversion_action_error
              require "google/ads/google_ads/v7/errors/conversion_action_error_pb"
              Google::Ads::GoogleAds::V7::Errors::ConversionActionErrorEnum::ConversionActionError.descriptor
            end

            # Returns the descriptor for the FeedItemSetLinkError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FeedItemSetLinkError enum
            def self.feed_item_set_link_error
              require "google/ads/google_ads/v7/errors/feed_item_set_link_error_pb"
              Google::Ads::GoogleAds::V7::Errors::FeedItemSetLinkErrorEnum::FeedItemSetLinkError.descriptor
            end

            # Returns the descriptor for the AccessInvitationError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AccessInvitationError enum
            def self.access_invitation_error
              require "google/ads/google_ads/v7/errors/access_invitation_error_pb"
              Google::Ads::GoogleAds::V7::Errors::AccessInvitationErrorEnum::AccessInvitationError.descriptor
            end

            # Returns the descriptor for the AccountLinkError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AccountLinkError enum
            def self.account_link_error
              require "google/ads/google_ads/v7/errors/account_link_error_pb"
              Google::Ads::GoogleAds::V7::Errors::AccountLinkErrorEnum::AccountLinkError.descriptor
            end

            # Returns the descriptor for the AdCustomizerError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AdCustomizerError enum
            def self.ad_customizer_error
              require "google/ads/google_ads/v7/errors/ad_customizer_error_pb"
              Google::Ads::GoogleAds::V7::Errors::AdCustomizerErrorEnum::AdCustomizerError.descriptor
            end

            # Returns the descriptor for the AdGroupAdError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AdGroupAdError enum
            def self.ad_group_ad_error
              require "google/ads/google_ads/v7/errors/ad_group_ad_error_pb"
              Google::Ads::GoogleAds::V7::Errors::AdGroupAdErrorEnum::AdGroupAdError.descriptor
            end

            # Returns the descriptor for the AdGroupBidModifierError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AdGroupBidModifierError enum
            def self.ad_group_bid_modifier_error
              require "google/ads/google_ads/v7/errors/ad_group_bid_modifier_error_pb"
              Google::Ads::GoogleAds::V7::Errors::AdGroupBidModifierErrorEnum::AdGroupBidModifierError.descriptor
            end

            # Returns the descriptor for the AdGroupCriterionError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AdGroupCriterionError enum
            def self.ad_group_criterion_error
              require "google/ads/google_ads/v7/errors/ad_group_criterion_error_pb"
              Google::Ads::GoogleAds::V7::Errors::AdGroupCriterionErrorEnum::AdGroupCriterionError.descriptor
            end

            # Returns the descriptor for the AdGroupError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AdGroupError enum
            def self.ad_group_error
              require "google/ads/google_ads/v7/errors/ad_group_error_pb"
              Google::Ads::GoogleAds::V7::Errors::AdGroupErrorEnum::AdGroupError.descriptor
            end

            # Returns the descriptor for the AdGroupFeedError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AdGroupFeedError enum
            def self.ad_group_feed_error
              require "google/ads/google_ads/v7/errors/ad_group_feed_error_pb"
              Google::Ads::GoogleAds::V7::Errors::AdGroupFeedErrorEnum::AdGroupFeedError.descriptor
            end

            # Returns the descriptor for the AdParameterError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AdParameterError enum
            def self.ad_parameter_error
              require "google/ads/google_ads/v7/errors/ad_parameter_error_pb"
              Google::Ads::GoogleAds::V7::Errors::AdParameterErrorEnum::AdParameterError.descriptor
            end

            # Returns the descriptor for the AdSharingError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AdSharingError enum
            def self.ad_sharing_error
              require "google/ads/google_ads/v7/errors/ad_sharing_error_pb"
              Google::Ads::GoogleAds::V7::Errors::AdSharingErrorEnum::AdSharingError.descriptor
            end

            # Returns the descriptor for the AdxError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AdxError enum
            def self.adx_error
              require "google/ads/google_ads/v7/errors/adx_error_pb"
              Google::Ads::GoogleAds::V7::Errors::AdxErrorEnum::AdxError.descriptor
            end

            # Returns the descriptor for the AssetError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AssetError enum
            def self.asset_error
              require "google/ads/google_ads/v7/errors/asset_error_pb"
              Google::Ads::GoogleAds::V7::Errors::AssetErrorEnum::AssetError.descriptor
            end

            # Returns the descriptor for the AuthenticationError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AuthenticationError enum
            def self.authentication_error
              require "google/ads/google_ads/v7/errors/authentication_error_pb"
              Google::Ads::GoogleAds::V7::Errors::AuthenticationErrorEnum::AuthenticationError.descriptor
            end

            # Returns the descriptor for the AuthorizationError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the AuthorizationError enum
            def self.authorization_error
              require "google/ads/google_ads/v7/errors/authorization_error_pb"
              Google::Ads::GoogleAds::V7::Errors::AuthorizationErrorEnum::AuthorizationError.descriptor
            end

            # Returns the descriptor for the BiddingError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the BiddingError enum
            def self.bidding_error
              require "google/ads/google_ads/v7/errors/bidding_error_pb"
              Google::Ads::GoogleAds::V7::Errors::BiddingErrorEnum::BiddingError.descriptor
            end

            # Returns the descriptor for the BiddingStrategyError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the BiddingStrategyError enum
            def self.bidding_strategy_error
              require "google/ads/google_ads/v7/errors/bidding_strategy_error_pb"
              Google::Ads::GoogleAds::V7::Errors::BiddingStrategyErrorEnum::BiddingStrategyError.descriptor
            end

            # Returns the descriptor for the BillingSetupError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the BillingSetupError enum
            def self.billing_setup_error
              require "google/ads/google_ads/v7/errors/billing_setup_error_pb"
              Google::Ads::GoogleAds::V7::Errors::BillingSetupErrorEnum::BillingSetupError.descriptor
            end

            # Returns the descriptor for the CampaignBudgetError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CampaignBudgetError enum
            def self.campaign_budget_error
              require "google/ads/google_ads/v7/errors/campaign_budget_error_pb"
              Google::Ads::GoogleAds::V7::Errors::CampaignBudgetErrorEnum::CampaignBudgetError.descriptor
            end

            # Returns the descriptor for the CampaignCriterionError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CampaignCriterionError enum
            def self.campaign_criterion_error
              require "google/ads/google_ads/v7/errors/campaign_criterion_error_pb"
              Google::Ads::GoogleAds::V7::Errors::CampaignCriterionErrorEnum::CampaignCriterionError.descriptor
            end

            # Returns the descriptor for the CampaignDraftError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CampaignDraftError enum
            def self.campaign_draft_error
              require "google/ads/google_ads/v7/errors/campaign_draft_error_pb"
              Google::Ads::GoogleAds::V7::Errors::CampaignDraftErrorEnum::CampaignDraftError.descriptor
            end

            # Returns the descriptor for the CampaignError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CampaignError enum
            def self.campaign_error
              require "google/ads/google_ads/v7/errors/campaign_error_pb"
              Google::Ads::GoogleAds::V7::Errors::CampaignErrorEnum::CampaignError.descriptor
            end

            # Returns the descriptor for the CampaignExperimentError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CampaignExperimentError enum
            def self.campaign_experiment_error
              require "google/ads/google_ads/v7/errors/campaign_experiment_error_pb"
              Google::Ads::GoogleAds::V7::Errors::CampaignExperimentErrorEnum::CampaignExperimentError.descriptor
            end

            # Returns the descriptor for the CampaignFeedError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CampaignFeedError enum
            def self.campaign_feed_error
              require "google/ads/google_ads/v7/errors/campaign_feed_error_pb"
              Google::Ads::GoogleAds::V7::Errors::CampaignFeedErrorEnum::CampaignFeedError.descriptor
            end

            # Returns the descriptor for the CampaignSharedSetError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CampaignSharedSetError enum
            def self.campaign_shared_set_error
              require "google/ads/google_ads/v7/errors/campaign_shared_set_error_pb"
              Google::Ads::GoogleAds::V7::Errors::CampaignSharedSetErrorEnum::CampaignSharedSetError.descriptor
            end

            # Returns the descriptor for the ChangeEventError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ChangeEventError enum
            def self.change_event_error
              require "google/ads/google_ads/v7/errors/change_event_error_pb"
              Google::Ads::GoogleAds::V7::Errors::ChangeEventErrorEnum::ChangeEventError.descriptor
            end

            # Returns the descriptor for the ChangeStatusError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ChangeStatusError enum
            def self.change_status_error
              require "google/ads/google_ads/v7/errors/change_status_error_pb"
              Google::Ads::GoogleAds::V7::Errors::ChangeStatusErrorEnum::ChangeStatusError.descriptor
            end

            # Returns the descriptor for the CollectionSizeError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CollectionSizeError enum
            def self.collection_size_error
              require "google/ads/google_ads/v7/errors/collection_size_error_pb"
              Google::Ads::GoogleAds::V7::Errors::CollectionSizeErrorEnum::CollectionSizeError.descriptor
            end

            # Returns the descriptor for the ContextError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ContextError enum
            def self.context_error
              require "google/ads/google_ads/v7/errors/context_error_pb"
              Google::Ads::GoogleAds::V7::Errors::ContextErrorEnum::ContextError.descriptor
            end

            # Returns the descriptor for the ConversionAdjustmentUploadError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ConversionAdjustmentUploadError enum
            def self.conversion_adjustment_upload_error
              require "google/ads/google_ads/v7/errors/conversion_adjustment_upload_error_pb"
              Google::Ads::GoogleAds::V7::Errors::ConversionAdjustmentUploadErrorEnum::ConversionAdjustmentUploadError.descriptor
            end

            # Returns the descriptor for the ConversionCustomVariableError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ConversionCustomVariableError enum
            def self.conversion_custom_variable_error
              require "google/ads/google_ads/v7/errors/conversion_custom_variable_error_pb"
              Google::Ads::GoogleAds::V7::Errors::ConversionCustomVariableErrorEnum::ConversionCustomVariableError.descriptor
            end

            # Returns the descriptor for the ConversionUploadError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ConversionUploadError enum
            def self.conversion_upload_error
              require "google/ads/google_ads/v7/errors/conversion_upload_error_pb"
              Google::Ads::GoogleAds::V7::Errors::ConversionUploadErrorEnum::ConversionUploadError.descriptor
            end

            # Returns the descriptor for the CountryCodeError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CountryCodeError enum
            def self.country_code_error
              require "google/ads/google_ads/v7/errors/country_code_error_pb"
              Google::Ads::GoogleAds::V7::Errors::CountryCodeErrorEnum::CountryCodeError.descriptor
            end

            # Returns the descriptor for the CriterionError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CriterionError enum
            def self.criterion_error
              require "google/ads/google_ads/v7/errors/criterion_error_pb"
              Google::Ads::GoogleAds::V7::Errors::CriterionErrorEnum::CriterionError.descriptor
            end

            # Returns the descriptor for the CurrencyCodeError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CurrencyCodeError enum
            def self.currency_code_error
              require "google/ads/google_ads/v7/errors/currency_code_error_pb"
              Google::Ads::GoogleAds::V7::Errors::CurrencyCodeErrorEnum::CurrencyCodeError.descriptor
            end

            # Returns the descriptor for the CustomInterestError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CustomInterestError enum
            def self.custom_interest_error
              require "google/ads/google_ads/v7/errors/custom_interest_error_pb"
              Google::Ads::GoogleAds::V7::Errors::CustomInterestErrorEnum::CustomInterestError.descriptor
            end

            # Returns the descriptor for the CustomerFeedError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CustomerFeedError enum
            def self.customer_feed_error
              require "google/ads/google_ads/v7/errors/customer_feed_error_pb"
              Google::Ads::GoogleAds::V7::Errors::CustomerFeedErrorEnum::CustomerFeedError.descriptor
            end

            # Returns the descriptor for the CustomerUserAccessError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the CustomerUserAccessError enum
            def self.customer_user_access_error
              require "google/ads/google_ads/v7/errors/customer_user_access_error_pb"
              Google::Ads::GoogleAds::V7::Errors::CustomerUserAccessErrorEnum::CustomerUserAccessError.descriptor
            end

            # Returns the descriptor for the DatabaseError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the DatabaseError enum
            def self.database_error
              require "google/ads/google_ads/v7/errors/database_error_pb"
              Google::Ads::GoogleAds::V7::Errors::DatabaseErrorEnum::DatabaseError.descriptor
            end

            # Returns the descriptor for the DateError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the DateError enum
            def self.date_error
              require "google/ads/google_ads/v7/errors/date_error_pb"
              Google::Ads::GoogleAds::V7::Errors::DateErrorEnum::DateError.descriptor
            end

            # Returns the descriptor for the DateRangeError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the DateRangeError enum
            def self.date_range_error
              require "google/ads/google_ads/v7/errors/date_range_error_pb"
              Google::Ads::GoogleAds::V7::Errors::DateRangeErrorEnum::DateRangeError.descriptor
            end

            # Returns the descriptor for the EnumError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the EnumError enum
            def self.enum_error
              require "google/ads/google_ads/v7/errors/enum_error_pb"
              Google::Ads::GoogleAds::V7::Errors::EnumErrorEnum::EnumError.descriptor
            end

            # Returns the descriptor for the ExtensionFeedItemError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ExtensionFeedItemError enum
            def self.extension_feed_item_error
              require "google/ads/google_ads/v7/errors/extension_feed_item_error_pb"
              Google::Ads::GoogleAds::V7::Errors::ExtensionFeedItemErrorEnum::ExtensionFeedItemError.descriptor
            end

            # Returns the descriptor for the ExtensionSettingError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ExtensionSettingError enum
            def self.extension_setting_error
              require "google/ads/google_ads/v7/errors/extension_setting_error_pb"
              Google::Ads::GoogleAds::V7::Errors::ExtensionSettingErrorEnum::ExtensionSettingError.descriptor
            end

            # Returns the descriptor for the FeedAttributeReferenceError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FeedAttributeReferenceError enum
            def self.feed_attribute_reference_error
              require "google/ads/google_ads/v7/errors/feed_attribute_reference_error_pb"
              Google::Ads::GoogleAds::V7::Errors::FeedAttributeReferenceErrorEnum::FeedAttributeReferenceError.descriptor
            end

            # Returns the descriptor for the FeedError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FeedError enum
            def self.feed_error
              require "google/ads/google_ads/v7/errors/feed_error_pb"
              Google::Ads::GoogleAds::V7::Errors::FeedErrorEnum::FeedError.descriptor
            end

            # Returns the descriptor for the FeedItemError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FeedItemError enum
            def self.feed_item_error
              require "google/ads/google_ads/v7/errors/feed_item_error_pb"
              Google::Ads::GoogleAds::V7::Errors::FeedItemErrorEnum::FeedItemError.descriptor
            end

            # Returns the descriptor for the FeedItemSetError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FeedItemSetError enum
            def self.feed_item_set_error
              require "google/ads/google_ads/v7/errors/feed_item_set_error_pb"
              Google::Ads::GoogleAds::V7::Errors::FeedItemSetErrorEnum::FeedItemSetError.descriptor
            end

            # Returns the descriptor for the FeedMappingError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FeedMappingError enum
            def self.feed_mapping_error
              require "google/ads/google_ads/v7/errors/feed_mapping_error_pb"
              Google::Ads::GoogleAds::V7::Errors::FeedMappingErrorEnum::FeedMappingError.descriptor
            end

            # Returns the descriptor for the FieldError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FieldError enum
            def self.field_error
              require "google/ads/google_ads/v7/errors/field_error_pb"
              Google::Ads::GoogleAds::V7::Errors::FieldErrorEnum::FieldError.descriptor
            end

            # Returns the descriptor for the FunctionError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FunctionError enum
            def self.function_error
              require "google/ads/google_ads/v7/errors/function_error_pb"
              Google::Ads::GoogleAds::V7::Errors::FunctionErrorEnum::FunctionError.descriptor
            end

            # Returns the descriptor for the FunctionParsingError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the FunctionParsingError enum
            def self.function_parsing_error
              require "google/ads/google_ads/v7/errors/function_parsing_error_pb"
              Google::Ads::GoogleAds::V7::Errors::FunctionParsingErrorEnum::FunctionParsingError.descriptor
            end

            # Returns the descriptor for the GeoTargetConstantSuggestionError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the GeoTargetConstantSuggestionError enum
            def self.geo_target_constant_suggestion_error
              require "google/ads/google_ads/v7/errors/geo_target_constant_suggestion_error_pb"
              Google::Ads::GoogleAds::V7::Errors::GeoTargetConstantSuggestionErrorEnum::GeoTargetConstantSuggestionError.descriptor
            end

            # Returns the descriptor for the HeaderError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the HeaderError enum
            def self.header_error
              require "google/ads/google_ads/v7/errors/header_error_pb"
              Google::Ads::GoogleAds::V7::Errors::HeaderErrorEnum::HeaderError.descriptor
            end

            # Returns the descriptor for the IdError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the IdError enum
            def self.id_error
              require "google/ads/google_ads/v7/errors/id_error_pb"
              Google::Ads::GoogleAds::V7::Errors::IdErrorEnum::IdError.descriptor
            end

            # Returns the descriptor for the InternalError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the InternalError enum
            def self.internal_error
              require "google/ads/google_ads/v7/errors/internal_error_pb"
              Google::Ads::GoogleAds::V7::Errors::InternalErrorEnum::InternalError.descriptor
            end

            # Returns the descriptor for the KeywordPlanError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the KeywordPlanError enum
            def self.keyword_plan_error
              require "google/ads/google_ads/v7/errors/keyword_plan_error_pb"
              Google::Ads::GoogleAds::V7::Errors::KeywordPlanErrorEnum::KeywordPlanError.descriptor
            end

            # Returns the descriptor for the KeywordPlanIdeaError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the KeywordPlanIdeaError enum
            def self.keyword_plan_idea_error
              require "google/ads/google_ads/v7/errors/keyword_plan_idea_error_pb"
              Google::Ads::GoogleAds::V7::Errors::KeywordPlanIdeaErrorEnum::KeywordPlanIdeaError.descriptor
            end

            # Returns the descriptor for the LabelError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the LabelError enum
            def self.label_error
              require "google/ads/google_ads/v7/errors/label_error_pb"
              Google::Ads::GoogleAds::V7::Errors::LabelErrorEnum::LabelError.descriptor
            end

            # Returns the descriptor for the ListOperationError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ListOperationError enum
            def self.list_operation_error
              require "google/ads/google_ads/v7/errors/list_operation_error_pb"
              Google::Ads::GoogleAds::V7::Errors::ListOperationErrorEnum::ListOperationError.descriptor
            end

            # Returns the descriptor for the ManagerLinkError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ManagerLinkError enum
            def self.manager_link_error
              require "google/ads/google_ads/v7/errors/manager_link_error_pb"
              Google::Ads::GoogleAds::V7::Errors::ManagerLinkErrorEnum::ManagerLinkError.descriptor
            end

            # Returns the descriptor for the MediaBundleError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the MediaBundleError enum
            def self.media_bundle_error
              require "google/ads/google_ads/v7/errors/media_bundle_error_pb"
              Google::Ads::GoogleAds::V7::Errors::MediaBundleErrorEnum::MediaBundleError.descriptor
            end

            # Returns the descriptor for the MediaFileError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the MediaFileError enum
            def self.media_file_error
              require "google/ads/google_ads/v7/errors/media_file_error_pb"
              Google::Ads::GoogleAds::V7::Errors::MediaFileErrorEnum::MediaFileError.descriptor
            end

            # Returns the descriptor for the MediaUploadError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the MediaUploadError enum
            def self.media_upload_error
              require "google/ads/google_ads/v7/errors/media_upload_error_pb"
              Google::Ads::GoogleAds::V7::Errors::MediaUploadErrorEnum::MediaUploadError.descriptor
            end

            # Returns the descriptor for the MultiplierError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the MultiplierError enum
            def self.multiplier_error
              require "google/ads/google_ads/v7/errors/multiplier_error_pb"
              Google::Ads::GoogleAds::V7::Errors::MultiplierErrorEnum::MultiplierError.descriptor
            end

            # Returns the descriptor for the MutateError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the MutateError enum
            def self.mutate_error
              require "google/ads/google_ads/v7/errors/mutate_error_pb"
              Google::Ads::GoogleAds::V7::Errors::MutateErrorEnum::MutateError.descriptor
            end

            # Returns the descriptor for the NewResourceCreationError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the NewResourceCreationError enum
            def self.new_resource_creation_error
              require "google/ads/google_ads/v7/errors/new_resource_creation_error_pb"
              Google::Ads::GoogleAds::V7::Errors::NewResourceCreationErrorEnum::NewResourceCreationError.descriptor
            end

            # Returns the descriptor for the NotAllowlistedError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the NotAllowlistedError enum
            def self.not_allowlisted_error
              require "google/ads/google_ads/v7/errors/not_allowlisted_error_pb"
              Google::Ads::GoogleAds::V7::Errors::NotAllowlistedErrorEnum::NotAllowlistedError.descriptor
            end

            # Returns the descriptor for the NullError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the NullError enum
            def self.null_error
              require "google/ads/google_ads/v7/errors/null_error_pb"
              Google::Ads::GoogleAds::V7::Errors::NullErrorEnum::NullError.descriptor
            end

            # Returns the descriptor for the OfflineUserDataJobError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the OfflineUserDataJobError enum
            def self.offline_user_data_job_error
              require "google/ads/google_ads/v7/errors/offline_user_data_job_error_pb"
              Google::Ads::GoogleAds::V7::Errors::OfflineUserDataJobErrorEnum::OfflineUserDataJobError.descriptor
            end

            # Returns the descriptor for the OperationAccessDeniedError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the OperationAccessDeniedError enum
            def self.operation_access_denied_error
              require "google/ads/google_ads/v7/errors/operation_access_denied_error_pb"
              Google::Ads::GoogleAds::V7::Errors::OperationAccessDeniedErrorEnum::OperationAccessDeniedError.descriptor
            end

            # Returns the descriptor for the OperatorError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the OperatorError enum
            def self.operator_error
              require "google/ads/google_ads/v7/errors/operator_error_pb"
              Google::Ads::GoogleAds::V7::Errors::OperatorErrorEnum::OperatorError.descriptor
            end

            # Returns the descriptor for the PartialFailureError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the PartialFailureError enum
            def self.partial_failure_error
              require "google/ads/google_ads/v7/errors/partial_failure_error_pb"
              Google::Ads::GoogleAds::V7::Errors::PartialFailureErrorEnum::PartialFailureError.descriptor
            end

            # Returns the descriptor for the PaymentsAccountError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the PaymentsAccountError enum
            def self.payments_account_error
              require "google/ads/google_ads/v7/errors/payments_account_error_pb"
              Google::Ads::GoogleAds::V7::Errors::PaymentsAccountErrorEnum::PaymentsAccountError.descriptor
            end

            # Returns the descriptor for the PolicyFindingError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the PolicyFindingError enum
            def self.policy_finding_error
              require "google/ads/google_ads/v7/errors/policy_finding_error_pb"
              Google::Ads::GoogleAds::V7::Errors::PolicyFindingErrorEnum::PolicyFindingError.descriptor
            end

            # Returns the descriptor for the PolicyValidationParameterError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the PolicyValidationParameterError enum
            def self.policy_validation_parameter_error
              require "google/ads/google_ads/v7/errors/policy_validation_parameter_error_pb"
              Google::Ads::GoogleAds::V7::Errors::PolicyValidationParameterErrorEnum::PolicyValidationParameterError.descriptor
            end

            # Returns the descriptor for the PolicyViolationError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the PolicyViolationError enum
            def self.policy_violation_error
              require "google/ads/google_ads/v7/errors/policy_violation_error_pb"
              Google::Ads::GoogleAds::V7::Errors::PolicyViolationErrorEnum::PolicyViolationError.descriptor
            end

            # Returns the descriptor for the QueryError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the QueryError enum
            def self.query_error
              require "google/ads/google_ads/v7/errors/query_error_pb"
              Google::Ads::GoogleAds::V7::Errors::QueryErrorEnum::QueryError.descriptor
            end

            # Returns the descriptor for the QuotaError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the QuotaError enum
            def self.quota_error
              require "google/ads/google_ads/v7/errors/quota_error_pb"
              Google::Ads::GoogleAds::V7::Errors::QuotaErrorEnum::QuotaError.descriptor
            end

            # Returns the descriptor for the RangeError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the RangeError enum
            def self.range_error
              require "google/ads/google_ads/v7/errors/range_error_pb"
              Google::Ads::GoogleAds::V7::Errors::RangeErrorEnum::RangeError.descriptor
            end

            # Returns the descriptor for the ReachPlanError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ReachPlanError enum
            def self.reach_plan_error
              require "google/ads/google_ads/v7/errors/reach_plan_error_pb"
              Google::Ads::GoogleAds::V7::Errors::ReachPlanErrorEnum::ReachPlanError.descriptor
            end

            # Returns the descriptor for the RecommendationError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the RecommendationError enum
            def self.recommendation_error
              require "google/ads/google_ads/v7/errors/recommendation_error_pb"
              Google::Ads::GoogleAds::V7::Errors::RecommendationErrorEnum::RecommendationError.descriptor
            end

            # Returns the descriptor for the RegionCodeError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the RegionCodeError enum
            def self.region_code_error
              require "google/ads/google_ads/v7/errors/region_code_error_pb"
              Google::Ads::GoogleAds::V7::Errors::RegionCodeErrorEnum::RegionCodeError.descriptor
            end

            # Returns the descriptor for the ResourceAccessDeniedError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ResourceAccessDeniedError enum
            def self.resource_access_denied_error
              require "google/ads/google_ads/v7/errors/resource_access_denied_error_pb"
              Google::Ads::GoogleAds::V7::Errors::ResourceAccessDeniedErrorEnum::ResourceAccessDeniedError.descriptor
            end

            # Returns the descriptor for the ResourceCountLimitExceededError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ResourceCountLimitExceededError enum
            def self.resource_count_limit_exceeded_error
              require "google/ads/google_ads/v7/errors/resource_count_limit_exceeded_error_pb"
              Google::Ads::GoogleAds::V7::Errors::ResourceCountLimitExceededErrorEnum::ResourceCountLimitExceededError.descriptor
            end

            # Returns the descriptor for the SharedCriterionError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the SharedCriterionError enum
            def self.shared_criterion_error
              require "google/ads/google_ads/v7/errors/shared_criterion_error_pb"
              Google::Ads::GoogleAds::V7::Errors::SharedCriterionErrorEnum::SharedCriterionError.descriptor
            end

            # Returns the descriptor for the SizeLimitError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the SizeLimitError enum
            def self.size_limit_error
              require "google/ads/google_ads/v7/errors/size_limit_error_pb"
              Google::Ads::GoogleAds::V7::Errors::SizeLimitErrorEnum::SizeLimitError.descriptor
            end

            # Returns the descriptor for the StringFormatError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the StringFormatError enum
            def self.string_format_error
              require "google/ads/google_ads/v7/errors/string_format_error_pb"
              Google::Ads::GoogleAds::V7::Errors::StringFormatErrorEnum::StringFormatError.descriptor
            end

            # Returns the descriptor for the StringLengthError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the StringLengthError enum
            def self.string_length_error
              require "google/ads/google_ads/v7/errors/string_length_error_pb"
              Google::Ads::GoogleAds::V7::Errors::StringLengthErrorEnum::StringLengthError.descriptor
            end

            # Returns the descriptor for the ThirdPartyAppAnalyticsLinkError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the ThirdPartyAppAnalyticsLinkError enum
            def self.third_party_app_analytics_link_error
              require "google/ads/google_ads/v7/errors/third_party_app_analytics_link_error_pb"
              Google::Ads::GoogleAds::V7::Errors::ThirdPartyAppAnalyticsLinkErrorEnum::ThirdPartyAppAnalyticsLinkError.descriptor
            end

            # Returns the descriptor for the TimeZoneError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the TimeZoneError enum
            def self.time_zone_error
              require "google/ads/google_ads/v7/errors/time_zone_error_pb"
              Google::Ads::GoogleAds::V7::Errors::TimeZoneErrorEnum::TimeZoneError.descriptor
            end

            # Returns the descriptor for the UrlFieldError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the UrlFieldError enum
            def self.url_field_error
              require "google/ads/google_ads/v7/errors/url_field_error_pb"
              Google::Ads::GoogleAds::V7::Errors::UrlFieldErrorEnum::UrlFieldError.descriptor
            end

            # Returns the descriptor for the UserListError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the UserListError enum
            def self.user_list_error
              require "google/ads/google_ads/v7/errors/user_list_error_pb"
              Google::Ads::GoogleAds::V7::Errors::UserListErrorEnum::UserListError.descriptor
            end

            # Returns the descriptor for the YoutubeVideoRegistrationError enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the YoutubeVideoRegistrationError enum
            def self.youtube_video_registration_error
              require "google/ads/google_ads/v7/errors/youtube_video_registration_error_pb"
              Google::Ads::GoogleAds::V7::Errors::YoutubeVideoRegistrationErrorEnum::YoutubeVideoRegistrationError.descriptor
            end

            # Returns the descriptor for the QuotaRateScope enum
            #
            # @return [Google::Protobuf::EnumDescriptor] for the QuotaRateScope enum
            def self.quota_rate_scope
              require "google/ads/google_ads/v7/errors/errors_pb"
              Google::Ads::GoogleAds::V7::Errors::QuotaErrorDetails::QuotaRateScope.descriptor
            end
          end
        end
      end
    end
  end
end
