# Generated by the protocol buffer compiler.  DO NOT EDIT!
# Source: google/ads/googleads/v8/services/keyword_plan_service.proto for package 'Google.Ads.GoogleAds.V8.Services'
# Original file comments:
# Copyright 2021 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

require 'grpc'
require 'google/ads/google_ads/v8/services/keyword_plan_service_pb'

module Google
  module Ads
    module GoogleAds
      module V8
        module Services
          module KeywordPlanService
            # Proto file describing the keyword plan service.
            #
            # Service to manage keyword plans.
            class Service

              include GRPC::GenericService

              self.marshal_class_method = :encode
              self.unmarshal_class_method = :decode
              self.service_name = 'google.ads.googleads.v8.services.KeywordPlanService'

              # Returns the requested plan in full detail.
              #
              # List of thrown errors:
              #   [AuthenticationError]()
              #   [AuthorizationError]()
              #   [HeaderError]()
              #   [InternalError]()
              #   [QuotaError]()
              #   [RequestError]()
              rpc :GetKeywordPlan, ::Google::Ads::GoogleAds::V8::Services::GetKeywordPlanRequest, ::Google::Ads::GoogleAds::V8::Resources::KeywordPlan
              # Creates, updates, or removes keyword plans. Operation statuses are
              # returned.
              #
              # List of thrown errors:
              #   [AuthenticationError]()
              #   [AuthorizationError]()
              #   [DatabaseError]()
              #   [FieldError]()
              #   [HeaderError]()
              #   [InternalError]()
              #   [KeywordPlanError]()
              #   [MutateError]()
              #   [NewResourceCreationError]()
              #   [QuotaError]()
              #   [RequestError]()
              #   [ResourceCountLimitExceededError]()
              #   [StringLengthError]()
              rpc :MutateKeywordPlans, ::Google::Ads::GoogleAds::V8::Services::MutateKeywordPlansRequest, ::Google::Ads::GoogleAds::V8::Services::MutateKeywordPlansResponse
              # Returns the requested Keyword Plan forecast curve.
              # Only the bidding strategy is considered for generating forecast curve.
              # The bidding strategy value specified in the plan is ignored.
              #
              # To generate a forecast at a value specified in the plan, use
              # KeywordPlanService.GenerateForecastMetrics.
              #
              # List of thrown errors:
              #   [AuthenticationError]()
              #   [AuthorizationError]()
              #   [HeaderError]()
              #   [InternalError]()
              #   [KeywordPlanError]()
              #   [QuotaError]()
              #   [RequestError]()
              rpc :GenerateForecastCurve, ::Google::Ads::GoogleAds::V8::Services::GenerateForecastCurveRequest, ::Google::Ads::GoogleAds::V8::Services::GenerateForecastCurveResponse
              # Returns a forecast in the form of a time series for the Keyword Plan over
              # the next 52 weeks.
              # (1) Forecasts closer to the current date are generally more accurate than
              # further out.
              #
              # (2) The forecast reflects seasonal trends using current and
              # prior traffic patterns. The forecast period of the plan is ignored.
              #
              # List of thrown errors:
              #   [AuthenticationError]()
              #   [AuthorizationError]()
              #   [HeaderError]()
              #   [InternalError]()
              #   [KeywordPlanError]()
              #   [QuotaError]()
              #   [RequestError]()
              rpc :GenerateForecastTimeSeries, ::Google::Ads::GoogleAds::V8::Services::GenerateForecastTimeSeriesRequest, ::Google::Ads::GoogleAds::V8::Services::GenerateForecastTimeSeriesResponse
              # Returns the requested Keyword Plan forecasts.
              #
              # List of thrown errors:
              #   [AuthenticationError]()
              #   [AuthorizationError]()
              #   [HeaderError]()
              #   [InternalError]()
              #   [KeywordPlanError]()
              #   [QuotaError]()
              #   [RequestError]()
              rpc :GenerateForecastMetrics, ::Google::Ads::GoogleAds::V8::Services::GenerateForecastMetricsRequest, ::Google::Ads::GoogleAds::V8::Services::GenerateForecastMetricsResponse
              # Returns the requested Keyword Plan historical metrics.
              #
              # List of thrown errors:
              #   [AuthenticationError]()
              #   [AuthorizationError]()
              #   [HeaderError]()
              #   [InternalError]()
              #   [KeywordPlanError]()
              #   [QuotaError]()
              #   [RequestError]()
              rpc :GenerateHistoricalMetrics, ::Google::Ads::GoogleAds::V8::Services::GenerateHistoricalMetricsRequest, ::Google::Ads::GoogleAds::V8::Services::GenerateHistoricalMetricsResponse
            end

            Stub = Service.rpc_stub_class
          end
        end
      end
    end
  end
end
