# frozen_string_literal: true

# Copyright 2021 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Auto-generated by gapic-generator-ruby. DO NOT EDIT!


module Google
  module Ads
    module GoogleAds
      module V8
        module Services
          module KeywordThemeConstantService
            # Path helper methods for the KeywordThemeConstantService API.
            module Paths
              ##
              # Create a fully-qualified KeywordThemeConstant resource string.
              #
              # The resource will be in the following format:
              #
              # `keywordThemeConstants/{express_category_id}~{express_sub_category_id}`
              #
              # @param express_category_id [String]
              # @param express_sub_category_id [String]
              #
              # @return [::String]
              def keyword_theme_constant_path express_category_id:, express_sub_category_id:
                raise ::ArgumentError, "express_category_id cannot contain /" if express_category_id.to_s.include? "/"

                "keywordThemeConstants/#{express_category_id}~#{express_sub_category_id}"
              end

              extend self
            end
          end
        end
      end
    end
  end
end
