module Google
  module Ads
    module GoogleAds
      module Factories
        module V8
          module Resources
            # Returns a new instance of criterion_category_availability, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::CriterionCategoryAvailability] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::CriterionCategoryAvailability] the created resource
            def self.criterion_category_availability
              require "google/ads/google_ads/v8/common/criterion_category_availability_pb"
              res = Google::Ads::GoogleAds::V8::Common::CriterionCategoryAvailability.new
              yield res if block_given?
              res
            end

            # Returns a new instance of criterion_category_channel_availability, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::CriterionCategoryChannelAvailability] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::CriterionCategoryChannelAvailability] the created resource
            def self.criterion_category_channel_availability
              require "google/ads/google_ads/v8/common/criterion_category_availability_pb"
              res = Google::Ads::GoogleAds::V8::Common::CriterionCategoryChannelAvailability.new
              yield res if block_given?
              res
            end

            # Returns a new instance of criterion_category_locale_availability, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::CriterionCategoryLocaleAvailability] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::CriterionCategoryLocaleAvailability] the created resource
            def self.criterion_category_locale_availability
              require "google/ads/google_ads/v8/common/criterion_category_availability_pb"
              res = Google::Ads::GoogleAds::V8::Common::CriterionCategoryLocaleAvailability.new
              yield res if block_given?
              res
            end

            # Returns a new instance of life_event, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::LifeEvent] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::LifeEvent] the created resource
            def self.life_event
              require "google/ads/google_ads/v8/resources/life_event_pb"
              res = Google::Ads::GoogleAds::V8::Resources::LifeEvent.new
              yield res if block_given?
              res
            end

            # Returns a new instance of topic_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::TopicView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::TopicView] the created resource
            def self.topic_view
              require "google/ads/google_ads/v8/resources/topic_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::TopicView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of campaign_label, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CampaignLabel] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CampaignLabel] the created resource
            def self.campaign_label
              require "google/ads/google_ads/v8/resources/campaign_label_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CampaignLabel.new
              yield res if block_given?
              res
            end

            # Returns a new instance of detail_placement_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::DetailPlacementView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::DetailPlacementView] the created resource
            def self.detail_placement_view
              require "google/ads/google_ads/v8/resources/detail_placement_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::DetailPlacementView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of custom_parameter, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::CustomParameter] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::CustomParameter] the created resource
            def self.custom_parameter
              require "google/ads/google_ads/v8/common/custom_parameter_pb"
              res = Google::Ads::GoogleAds::V8::Common::CustomParameter.new
              yield res if block_given?
              res
            end

            # Returns a new instance of money, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::Money] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::Money] the created resource
            def self.money
              require "google/ads/google_ads/v8/common/feed_common_pb"
              res = Google::Ads::GoogleAds::V8::Common::Money.new
              yield res if block_given?
              res
            end

            # Returns a new instance of policy_violation_key, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::PolicyViolationKey] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::PolicyViolationKey] the created resource
            def self.policy_violation_key
              require "google/ads/google_ads/v8/common/policy_pb"
              res = Google::Ads::GoogleAds::V8::Common::PolicyViolationKey.new
              yield res if block_given?
              res
            end

            # Returns a new instance of policy_validation_parameter, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::PolicyValidationParameter] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::PolicyValidationParameter] the created resource
            def self.policy_validation_parameter
              require "google/ads/google_ads/v8/common/policy_pb"
              res = Google::Ads::GoogleAds::V8::Common::PolicyValidationParameter.new
              yield res if block_given?
              res
            end

            # Returns a new instance of policy_topic_entry, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::PolicyTopicEntry] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::PolicyTopicEntry] the created resource
            def self.policy_topic_entry
              require "google/ads/google_ads/v8/common/policy_pb"
              res = Google::Ads::GoogleAds::V8::Common::PolicyTopicEntry.new
              yield res if block_given?
              res
            end

            # Returns a new instance of policy_topic_evidence, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::PolicyTopicEvidence] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::PolicyTopicEvidence] the created resource
            def self.policy_topic_evidence
              require "google/ads/google_ads/v8/common/policy_pb"
              res = Google::Ads::GoogleAds::V8::Common::PolicyTopicEvidence.new
              yield res if block_given?
              res
            end

            # Returns a new instance of text_list, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::PolicyTopicEvidence::TextList] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::PolicyTopicEvidence::TextList] the created resource
            def self.text_list
              require "google/ads/google_ads/v8/common/policy_pb"
              res = Google::Ads::GoogleAds::V8::Common::PolicyTopicEvidence::TextList.new
              yield res if block_given?
              res
            end

            # Returns a new instance of website_list, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::PolicyTopicEvidence::WebsiteList] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::PolicyTopicEvidence::WebsiteList] the created resource
            def self.website_list
              require "google/ads/google_ads/v8/common/policy_pb"
              res = Google::Ads::GoogleAds::V8::Common::PolicyTopicEvidence::WebsiteList.new
              yield res if block_given?
              res
            end

            # Returns a new instance of destination_text_list, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::PolicyTopicEvidence::DestinationTextList] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::PolicyTopicEvidence::DestinationTextList] the created resource
            def self.destination_text_list
              require "google/ads/google_ads/v8/common/policy_pb"
              res = Google::Ads::GoogleAds::V8::Common::PolicyTopicEvidence::DestinationTextList.new
              yield res if block_given?
              res
            end

            # Returns a new instance of destination_mismatch, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::PolicyTopicEvidence::DestinationMismatch] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::PolicyTopicEvidence::DestinationMismatch] the created resource
            def self.destination_mismatch
              require "google/ads/google_ads/v8/common/policy_pb"
              res = Google::Ads::GoogleAds::V8::Common::PolicyTopicEvidence::DestinationMismatch.new
              yield res if block_given?
              res
            end

            # Returns a new instance of destination_not_working, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::PolicyTopicEvidence::DestinationNotWorking] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::PolicyTopicEvidence::DestinationNotWorking] the created resource
            def self.destination_not_working
              require "google/ads/google_ads/v8/common/policy_pb"
              res = Google::Ads::GoogleAds::V8::Common::PolicyTopicEvidence::DestinationNotWorking.new
              yield res if block_given?
              res
            end

            # Returns a new instance of policy_topic_constraint, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::PolicyTopicConstraint] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::PolicyTopicConstraint] the created resource
            def self.policy_topic_constraint
              require "google/ads/google_ads/v8/common/policy_pb"
              res = Google::Ads::GoogleAds::V8::Common::PolicyTopicConstraint.new
              yield res if block_given?
              res
            end

            # Returns a new instance of country_constraint_list, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::PolicyTopicConstraint::CountryConstraintList] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::PolicyTopicConstraint::CountryConstraintList] the created resource
            def self.country_constraint_list
              require "google/ads/google_ads/v8/common/policy_pb"
              res = Google::Ads::GoogleAds::V8::Common::PolicyTopicConstraint::CountryConstraintList.new
              yield res if block_given?
              res
            end

            # Returns a new instance of reseller_constraint, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::PolicyTopicConstraint::ResellerConstraint] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::PolicyTopicConstraint::ResellerConstraint] the created resource
            def self.reseller_constraint
              require "google/ads/google_ads/v8/common/policy_pb"
              res = Google::Ads::GoogleAds::V8::Common::PolicyTopicConstraint::ResellerConstraint.new
              yield res if block_given?
              res
            end

            # Returns a new instance of country_constraint, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::PolicyTopicConstraint::CountryConstraint] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::PolicyTopicConstraint::CountryConstraint] the created resource
            def self.country_constraint
              require "google/ads/google_ads/v8/common/policy_pb"
              res = Google::Ads::GoogleAds::V8::Common::PolicyTopicConstraint::CountryConstraint.new
              yield res if block_given?
              res
            end

            # Returns a new instance of feed_item, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::FeedItem] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::FeedItem] the created resource
            def self.feed_item
              require "google/ads/google_ads/v8/resources/feed_item_pb"
              res = Google::Ads::GoogleAds::V8::Resources::FeedItem.new
              yield res if block_given?
              res
            end

            # Returns a new instance of feed_item_attribute_value, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::FeedItemAttributeValue] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::FeedItemAttributeValue] the created resource
            def self.feed_item_attribute_value
              require "google/ads/google_ads/v8/resources/feed_item_pb"
              res = Google::Ads::GoogleAds::V8::Resources::FeedItemAttributeValue.new
              yield res if block_given?
              res
            end

            # Returns a new instance of feed_item_placeholder_policy_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::FeedItemPlaceholderPolicyInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::FeedItemPlaceholderPolicyInfo] the created resource
            def self.feed_item_placeholder_policy_info
              require "google/ads/google_ads/v8/resources/feed_item_pb"
              res = Google::Ads::GoogleAds::V8::Resources::FeedItemPlaceholderPolicyInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of feed_item_validation_error, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::FeedItemValidationError] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::FeedItemValidationError] the created resource
            def self.feed_item_validation_error
              require "google/ads/google_ads/v8/resources/feed_item_pb"
              res = Google::Ads::GoogleAds::V8::Resources::FeedItemValidationError.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mobile_device_constant, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::MobileDeviceConstant] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::MobileDeviceConstant] the created resource
            def self.mobile_device_constant
              require "google/ads/google_ads/v8/resources/mobile_device_constant_pb"
              res = Google::Ads::GoogleAds::V8::Resources::MobileDeviceConstant.new
              yield res if block_given?
              res
            end

            # Returns a new instance of ad_group_audience_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AdGroupAudienceView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AdGroupAudienceView] the created resource
            def self.ad_group_audience_view
              require "google/ads/google_ads/v8/resources/ad_group_audience_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AdGroupAudienceView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of customer, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Customer] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Customer] the created resource
            def self.customer
              require "google/ads/google_ads/v8/resources/customer_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Customer.new
              yield res if block_given?
              res
            end

            # Returns a new instance of call_reporting_setting, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CallReportingSetting] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CallReportingSetting] the created resource
            def self.call_reporting_setting
              require "google/ads/google_ads/v8/resources/customer_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CallReportingSetting.new
              yield res if block_given?
              res
            end

            # Returns a new instance of conversion_tracking_setting, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::ConversionTrackingSetting] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::ConversionTrackingSetting] the created resource
            def self.conversion_tracking_setting
              require "google/ads/google_ads/v8/resources/customer_pb"
              res = Google::Ads::GoogleAds::V8::Resources::ConversionTrackingSetting.new
              yield res if block_given?
              res
            end

            # Returns a new instance of remarketing_setting, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::RemarketingSetting] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::RemarketingSetting] the created resource
            def self.remarketing_setting
              require "google/ads/google_ads/v8/resources/customer_pb"
              res = Google::Ads::GoogleAds::V8::Resources::RemarketingSetting.new
              yield res if block_given?
              res
            end

            # Returns a new instance of domain_category, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::DomainCategory] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::DomainCategory] the created resource
            def self.domain_category
              require "google/ads/google_ads/v8/resources/domain_category_pb"
              res = Google::Ads::GoogleAds::V8::Resources::DomainCategory.new
              yield res if block_given?
              res
            end

            # Returns a new instance of campaign_extension_setting, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CampaignExtensionSetting] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CampaignExtensionSetting] the created resource
            def self.campaign_extension_setting
              require "google/ads/google_ads/v8/resources/campaign_extension_setting_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CampaignExtensionSetting.new
              yield res if block_given?
              res
            end

            # Returns a new instance of geo_target_constant, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::GeoTargetConstant] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::GeoTargetConstant] the created resource
            def self.geo_target_constant
              require "google/ads/google_ads/v8/resources/geo_target_constant_pb"
              res = Google::Ads::GoogleAds::V8::Resources::GeoTargetConstant.new
              yield res if block_given?
              res
            end

            # Returns a new instance of ad_parameter, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AdParameter] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AdParameter] the created resource
            def self.ad_parameter
              require "google/ads/google_ads/v8/resources/ad_parameter_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AdParameter.new
              yield res if block_given?
              res
            end

            # Returns a new instance of call_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CallView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CallView] the created resource
            def self.call_view
              require "google/ads/google_ads/v8/resources/call_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CallView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of currency_constant, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CurrencyConstant] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CurrencyConstant] the created resource
            def self.currency_constant
              require "google/ads/google_ads/v8/resources/currency_constant_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CurrencyConstant.new
              yield res if block_given?
              res
            end

            # Returns a new instance of campaign_budget, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CampaignBudget] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CampaignBudget] the created resource
            def self.campaign_budget
              require "google/ads/google_ads/v8/resources/campaign_budget_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CampaignBudget.new
              yield res if block_given?
              res
            end

            # Returns a new instance of campaign_audience_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CampaignAudienceView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CampaignAudienceView] the created resource
            def self.campaign_audience_view
              require "google/ads/google_ads/v8/resources/campaign_audience_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CampaignAudienceView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of customer_asset, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CustomerAsset] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CustomerAsset] the created resource
            def self.customer_asset
              require "google/ads/google_ads/v8/resources/customer_asset_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CustomerAsset.new
              yield res if block_given?
              res
            end

            # Returns a new instance of smart_campaign_setting, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::SmartCampaignSetting] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::SmartCampaignSetting] the created resource
            def self.smart_campaign_setting
              require "google/ads/google_ads/v8/resources/smart_campaign_setting_pb"
              res = Google::Ads::GoogleAds::V8::Resources::SmartCampaignSetting.new
              yield res if block_given?
              res
            end

            # Returns a new instance of phone_number, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::SmartCampaignSetting::PhoneNumber] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::SmartCampaignSetting::PhoneNumber] the created resource
            def self.phone_number
              require "google/ads/google_ads/v8/resources/smart_campaign_setting_pb"
              res = Google::Ads::GoogleAds::V8::Resources::SmartCampaignSetting::PhoneNumber.new
              yield res if block_given?
              res
            end

            # Returns a new instance of hotel_performance_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::HotelPerformanceView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::HotelPerformanceView] the created resource
            def self.hotel_performance_view
              require "google/ads/google_ads/v8/resources/hotel_performance_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::HotelPerformanceView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of income_range_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::IncomeRangeView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::IncomeRangeView] the created resource
            def self.income_range_view
              require "google/ads/google_ads/v8/resources/income_range_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::IncomeRangeView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of date_range, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::DateRange] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::DateRange] the created resource
            def self.date_range
              require "google/ads/google_ads/v8/common/dates_pb"
              res = Google::Ads::GoogleAds::V8::Common::DateRange.new
              yield res if block_given?
              res
            end

            # Returns a new instance of year_month_range, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::YearMonthRange] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::YearMonthRange] the created resource
            def self.year_month_range
              require "google/ads/google_ads/v8/common/dates_pb"
              res = Google::Ads::GoogleAds::V8::Common::YearMonthRange.new
              yield res if block_given?
              res
            end

            # Returns a new instance of year_month, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::YearMonth] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::YearMonth] the created resource
            def self.year_month
              require "google/ads/google_ads/v8/common/dates_pb"
              res = Google::Ads::GoogleAds::V8::Common::YearMonth.new
              yield res if block_given?
              res
            end

            # Returns a new instance of invoice, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Invoice] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Invoice] the created resource
            def self.invoice
              require "google/ads/google_ads/v8/resources/invoice_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Invoice.new
              yield res if block_given?
              res
            end

            # Returns a new instance of account_budget_summary, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Invoice::AccountBudgetSummary] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Invoice::AccountBudgetSummary] the created resource
            def self.account_budget_summary
              require "google/ads/google_ads/v8/resources/invoice_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Invoice::AccountBudgetSummary.new
              yield res if block_given?
              res
            end

            # Returns a new instance of matching_function, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::MatchingFunction] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::MatchingFunction] the created resource
            def self.matching_function
              require "google/ads/google_ads/v8/common/matching_function_pb"
              res = Google::Ads::GoogleAds::V8::Common::MatchingFunction.new
              yield res if block_given?
              res
            end

            # Returns a new instance of operand, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::Operand] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::Operand] the created resource
            def self.operand
              require "google/ads/google_ads/v8/common/matching_function_pb"
              res = Google::Ads::GoogleAds::V8::Common::Operand.new
              yield res if block_given?
              res
            end

            # Returns a new instance of constant_operand, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::Operand::ConstantOperand] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::Operand::ConstantOperand] the created resource
            def self.constant_operand
              require "google/ads/google_ads/v8/common/matching_function_pb"
              res = Google::Ads::GoogleAds::V8::Common::Operand::ConstantOperand.new
              yield res if block_given?
              res
            end

            # Returns a new instance of feed_attribute_operand, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::Operand::FeedAttributeOperand] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::Operand::FeedAttributeOperand] the created resource
            def self.feed_attribute_operand
              require "google/ads/google_ads/v8/common/matching_function_pb"
              res = Google::Ads::GoogleAds::V8::Common::Operand::FeedAttributeOperand.new
              yield res if block_given?
              res
            end

            # Returns a new instance of function_operand, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::Operand::FunctionOperand] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::Operand::FunctionOperand] the created resource
            def self.function_operand
              require "google/ads/google_ads/v8/common/matching_function_pb"
              res = Google::Ads::GoogleAds::V8::Common::Operand::FunctionOperand.new
              yield res if block_given?
              res
            end

            # Returns a new instance of request_context_operand, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::Operand::RequestContextOperand] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::Operand::RequestContextOperand] the created resource
            def self.request_context_operand
              require "google/ads/google_ads/v8/common/matching_function_pb"
              res = Google::Ads::GoogleAds::V8::Common::Operand::RequestContextOperand.new
              yield res if block_given?
              res
            end

            # Returns a new instance of customer_feed, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CustomerFeed] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CustomerFeed] the created resource
            def self.customer_feed
              require "google/ads/google_ads/v8/resources/customer_feed_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CustomerFeed.new
              yield res if block_given?
              res
            end

            # Returns a new instance of campaign_feed, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CampaignFeed] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CampaignFeed] the created resource
            def self.campaign_feed
              require "google/ads/google_ads/v8/resources/campaign_feed_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CampaignFeed.new
              yield res if block_given?
              res
            end

            # Returns a new instance of customer_extension_setting, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CustomerExtensionSetting] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CustomerExtensionSetting] the created resource
            def self.customer_extension_setting
              require "google/ads/google_ads/v8/resources/customer_extension_setting_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CustomerExtensionSetting.new
              yield res if block_given?
              res
            end

            # Returns a new instance of feed_mapping, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::FeedMapping] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::FeedMapping] the created resource
            def self.feed_mapping
              require "google/ads/google_ads/v8/resources/feed_mapping_pb"
              res = Google::Ads::GoogleAds::V8::Resources::FeedMapping.new
              yield res if block_given?
              res
            end

            # Returns a new instance of attribute_field_mapping, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AttributeFieldMapping] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AttributeFieldMapping] the created resource
            def self.attribute_field_mapping
              require "google/ads/google_ads/v8/resources/feed_mapping_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AttributeFieldMapping.new
              yield res if block_given?
              res
            end

            # Returns a new instance of feed, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Feed] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Feed] the created resource
            def self.feed
              require "google/ads/google_ads/v8/resources/feed_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Feed.new
              yield res if block_given?
              res
            end

            # Returns a new instance of places_location_feed_data, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Feed::PlacesLocationFeedData] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Feed::PlacesLocationFeedData] the created resource
            def self.places_location_feed_data
              require "google/ads/google_ads/v8/resources/feed_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Feed::PlacesLocationFeedData.new
              yield res if block_given?
              res
            end

            # Returns a new instance of o_auth_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Feed::PlacesLocationFeedData::OAuthInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Feed::PlacesLocationFeedData::OAuthInfo] the created resource
            def self.o_auth_info
              require "google/ads/google_ads/v8/resources/feed_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Feed::PlacesLocationFeedData::OAuthInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of affiliate_location_feed_data, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Feed::AffiliateLocationFeedData] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Feed::AffiliateLocationFeedData] the created resource
            def self.affiliate_location_feed_data
              require "google/ads/google_ads/v8/resources/feed_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Feed::AffiliateLocationFeedData.new
              yield res if block_given?
              res
            end

            # Returns a new instance of feed_attribute, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::FeedAttribute] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::FeedAttribute] the created resource
            def self.feed_attribute
              require "google/ads/google_ads/v8/resources/feed_pb"
              res = Google::Ads::GoogleAds::V8::Resources::FeedAttribute.new
              yield res if block_given?
              res
            end

            # Returns a new instance of bid_modifier_simulation_point_list, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::BidModifierSimulationPointList] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::BidModifierSimulationPointList] the created resource
            def self.bid_modifier_simulation_point_list
              require "google/ads/google_ads/v8/common/simulation_pb"
              res = Google::Ads::GoogleAds::V8::Common::BidModifierSimulationPointList.new
              yield res if block_given?
              res
            end

            # Returns a new instance of cpc_bid_simulation_point_list, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::CpcBidSimulationPointList] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::CpcBidSimulationPointList] the created resource
            def self.cpc_bid_simulation_point_list
              require "google/ads/google_ads/v8/common/simulation_pb"
              res = Google::Ads::GoogleAds::V8::Common::CpcBidSimulationPointList.new
              yield res if block_given?
              res
            end

            # Returns a new instance of cpv_bid_simulation_point_list, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::CpvBidSimulationPointList] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::CpvBidSimulationPointList] the created resource
            def self.cpv_bid_simulation_point_list
              require "google/ads/google_ads/v8/common/simulation_pb"
              res = Google::Ads::GoogleAds::V8::Common::CpvBidSimulationPointList.new
              yield res if block_given?
              res
            end

            # Returns a new instance of target_cpa_simulation_point_list, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::TargetCpaSimulationPointList] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::TargetCpaSimulationPointList] the created resource
            def self.target_cpa_simulation_point_list
              require "google/ads/google_ads/v8/common/simulation_pb"
              res = Google::Ads::GoogleAds::V8::Common::TargetCpaSimulationPointList.new
              yield res if block_given?
              res
            end

            # Returns a new instance of target_roas_simulation_point_list, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::TargetRoasSimulationPointList] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::TargetRoasSimulationPointList] the created resource
            def self.target_roas_simulation_point_list
              require "google/ads/google_ads/v8/common/simulation_pb"
              res = Google::Ads::GoogleAds::V8::Common::TargetRoasSimulationPointList.new
              yield res if block_given?
              res
            end

            # Returns a new instance of percent_cpc_bid_simulation_point_list, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::PercentCpcBidSimulationPointList] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::PercentCpcBidSimulationPointList] the created resource
            def self.percent_cpc_bid_simulation_point_list
              require "google/ads/google_ads/v8/common/simulation_pb"
              res = Google::Ads::GoogleAds::V8::Common::PercentCpcBidSimulationPointList.new
              yield res if block_given?
              res
            end

            # Returns a new instance of budget_simulation_point_list, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::BudgetSimulationPointList] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::BudgetSimulationPointList] the created resource
            def self.budget_simulation_point_list
              require "google/ads/google_ads/v8/common/simulation_pb"
              res = Google::Ads::GoogleAds::V8::Common::BudgetSimulationPointList.new
              yield res if block_given?
              res
            end

            # Returns a new instance of target_impression_share_simulation_point_list, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::TargetImpressionShareSimulationPointList] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::TargetImpressionShareSimulationPointList] the created resource
            def self.target_impression_share_simulation_point_list
              require "google/ads/google_ads/v8/common/simulation_pb"
              res = Google::Ads::GoogleAds::V8::Common::TargetImpressionShareSimulationPointList.new
              yield res if block_given?
              res
            end

            # Returns a new instance of bid_modifier_simulation_point, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::BidModifierSimulationPoint] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::BidModifierSimulationPoint] the created resource
            def self.bid_modifier_simulation_point
              require "google/ads/google_ads/v8/common/simulation_pb"
              res = Google::Ads::GoogleAds::V8::Common::BidModifierSimulationPoint.new
              yield res if block_given?
              res
            end

            # Returns a new instance of cpc_bid_simulation_point, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::CpcBidSimulationPoint] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::CpcBidSimulationPoint] the created resource
            def self.cpc_bid_simulation_point
              require "google/ads/google_ads/v8/common/simulation_pb"
              res = Google::Ads::GoogleAds::V8::Common::CpcBidSimulationPoint.new
              yield res if block_given?
              res
            end

            # Returns a new instance of cpv_bid_simulation_point, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::CpvBidSimulationPoint] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::CpvBidSimulationPoint] the created resource
            def self.cpv_bid_simulation_point
              require "google/ads/google_ads/v8/common/simulation_pb"
              res = Google::Ads::GoogleAds::V8::Common::CpvBidSimulationPoint.new
              yield res if block_given?
              res
            end

            # Returns a new instance of target_cpa_simulation_point, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::TargetCpaSimulationPoint] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::TargetCpaSimulationPoint] the created resource
            def self.target_cpa_simulation_point
              require "google/ads/google_ads/v8/common/simulation_pb"
              res = Google::Ads::GoogleAds::V8::Common::TargetCpaSimulationPoint.new
              yield res if block_given?
              res
            end

            # Returns a new instance of target_roas_simulation_point, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::TargetRoasSimulationPoint] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::TargetRoasSimulationPoint] the created resource
            def self.target_roas_simulation_point
              require "google/ads/google_ads/v8/common/simulation_pb"
              res = Google::Ads::GoogleAds::V8::Common::TargetRoasSimulationPoint.new
              yield res if block_given?
              res
            end

            # Returns a new instance of percent_cpc_bid_simulation_point, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::PercentCpcBidSimulationPoint] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::PercentCpcBidSimulationPoint] the created resource
            def self.percent_cpc_bid_simulation_point
              require "google/ads/google_ads/v8/common/simulation_pb"
              res = Google::Ads::GoogleAds::V8::Common::PercentCpcBidSimulationPoint.new
              yield res if block_given?
              res
            end

            # Returns a new instance of budget_simulation_point, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::BudgetSimulationPoint] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::BudgetSimulationPoint] the created resource
            def self.budget_simulation_point
              require "google/ads/google_ads/v8/common/simulation_pb"
              res = Google::Ads::GoogleAds::V8::Common::BudgetSimulationPoint.new
              yield res if block_given?
              res
            end

            # Returns a new instance of target_impression_share_simulation_point, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::TargetImpressionShareSimulationPoint] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::TargetImpressionShareSimulationPoint] the created resource
            def self.target_impression_share_simulation_point
              require "google/ads/google_ads/v8/common/simulation_pb"
              res = Google::Ads::GoogleAds::V8::Common::TargetImpressionShareSimulationPoint.new
              yield res if block_given?
              res
            end

            # Returns a new instance of ad_group_simulation, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AdGroupSimulation] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AdGroupSimulation] the created resource
            def self.ad_group_simulation
              require "google/ads/google_ads/v8/resources/ad_group_simulation_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AdGroupSimulation.new
              yield res if block_given?
              res
            end

            # Returns a new instance of bidding_data_exclusion, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::BiddingDataExclusion] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::BiddingDataExclusion] the created resource
            def self.bidding_data_exclusion
              require "google/ads/google_ads/v8/resources/bidding_data_exclusion_pb"
              res = Google::Ads::GoogleAds::V8::Resources::BiddingDataExclusion.new
              yield res if block_given?
              res
            end

            # Returns a new instance of product_group_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::ProductGroupView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::ProductGroupView] the created resource
            def self.product_group_view
              require "google/ads/google_ads/v8/resources/product_group_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::ProductGroupView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of ad_group_feed, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AdGroupFeed] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AdGroupFeed] the created resource
            def self.ad_group_feed
              require "google/ads/google_ads/v8/resources/ad_group_feed_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AdGroupFeed.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::KeywordInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::KeywordInfo] the created resource
            def self.keyword_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::KeywordInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of placement_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::PlacementInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::PlacementInfo] the created resource
            def self.placement_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::PlacementInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mobile_app_category_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::MobileAppCategoryInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::MobileAppCategoryInfo] the created resource
            def self.mobile_app_category_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::MobileAppCategoryInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mobile_application_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::MobileApplicationInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::MobileApplicationInfo] the created resource
            def self.mobile_application_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::MobileApplicationInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of location_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::LocationInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::LocationInfo] the created resource
            def self.location_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::LocationInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of device_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::DeviceInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::DeviceInfo] the created resource
            def self.device_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::DeviceInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of preferred_content_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::PreferredContentInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::PreferredContentInfo] the created resource
            def self.preferred_content_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::PreferredContentInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of listing_group_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ListingGroupInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ListingGroupInfo] the created resource
            def self.listing_group_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::ListingGroupInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of listing_scope_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ListingScopeInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ListingScopeInfo] the created resource
            def self.listing_scope_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::ListingScopeInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of listing_dimension_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ListingDimensionInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ListingDimensionInfo] the created resource
            def self.listing_dimension_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::ListingDimensionInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of hotel_id_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::HotelIdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::HotelIdInfo] the created resource
            def self.hotel_id_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::HotelIdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of hotel_class_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::HotelClassInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::HotelClassInfo] the created resource
            def self.hotel_class_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::HotelClassInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of hotel_country_region_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::HotelCountryRegionInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::HotelCountryRegionInfo] the created resource
            def self.hotel_country_region_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::HotelCountryRegionInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of hotel_state_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::HotelStateInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::HotelStateInfo] the created resource
            def self.hotel_state_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::HotelStateInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of hotel_city_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::HotelCityInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::HotelCityInfo] the created resource
            def self.hotel_city_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::HotelCityInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of product_bidding_category_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ProductBiddingCategoryInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ProductBiddingCategoryInfo] the created resource
            def self.product_bidding_category_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::ProductBiddingCategoryInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of product_brand_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ProductBrandInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ProductBrandInfo] the created resource
            def self.product_brand_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::ProductBrandInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of product_channel_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ProductChannelInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ProductChannelInfo] the created resource
            def self.product_channel_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::ProductChannelInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of product_channel_exclusivity_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ProductChannelExclusivityInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ProductChannelExclusivityInfo] the created resource
            def self.product_channel_exclusivity_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::ProductChannelExclusivityInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of product_condition_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ProductConditionInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ProductConditionInfo] the created resource
            def self.product_condition_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::ProductConditionInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of product_custom_attribute_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ProductCustomAttributeInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ProductCustomAttributeInfo] the created resource
            def self.product_custom_attribute_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::ProductCustomAttributeInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of product_item_id_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ProductItemIdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ProductItemIdInfo] the created resource
            def self.product_item_id_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::ProductItemIdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of product_type_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ProductTypeInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ProductTypeInfo] the created resource
            def self.product_type_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::ProductTypeInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of unknown_listing_dimension_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::UnknownListingDimensionInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::UnknownListingDimensionInfo] the created resource
            def self.unknown_listing_dimension_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::UnknownListingDimensionInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of hotel_date_selection_type_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::HotelDateSelectionTypeInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::HotelDateSelectionTypeInfo] the created resource
            def self.hotel_date_selection_type_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::HotelDateSelectionTypeInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of hotel_advance_booking_window_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::HotelAdvanceBookingWindowInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::HotelAdvanceBookingWindowInfo] the created resource
            def self.hotel_advance_booking_window_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::HotelAdvanceBookingWindowInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of hotel_length_of_stay_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::HotelLengthOfStayInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::HotelLengthOfStayInfo] the created resource
            def self.hotel_length_of_stay_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::HotelLengthOfStayInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of hotel_check_in_date_range_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::HotelCheckInDateRangeInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::HotelCheckInDateRangeInfo] the created resource
            def self.hotel_check_in_date_range_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::HotelCheckInDateRangeInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of hotel_check_in_day_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::HotelCheckInDayInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::HotelCheckInDayInfo] the created resource
            def self.hotel_check_in_day_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::HotelCheckInDayInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of interaction_type_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::InteractionTypeInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::InteractionTypeInfo] the created resource
            def self.interaction_type_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::InteractionTypeInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of ad_schedule_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::AdScheduleInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::AdScheduleInfo] the created resource
            def self.ad_schedule_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::AdScheduleInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of age_range_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::AgeRangeInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::AgeRangeInfo] the created resource
            def self.age_range_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::AgeRangeInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of gender_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::GenderInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::GenderInfo] the created resource
            def self.gender_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::GenderInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of income_range_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::IncomeRangeInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::IncomeRangeInfo] the created resource
            def self.income_range_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::IncomeRangeInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of parental_status_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ParentalStatusInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ParentalStatusInfo] the created resource
            def self.parental_status_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::ParentalStatusInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of you_tube_video_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::YouTubeVideoInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::YouTubeVideoInfo] the created resource
            def self.you_tube_video_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::YouTubeVideoInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of you_tube_channel_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::YouTubeChannelInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::YouTubeChannelInfo] the created resource
            def self.you_tube_channel_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::YouTubeChannelInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of user_list_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::UserListInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::UserListInfo] the created resource
            def self.user_list_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::UserListInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of proximity_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ProximityInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ProximityInfo] the created resource
            def self.proximity_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::ProximityInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of geo_point_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::GeoPointInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::GeoPointInfo] the created resource
            def self.geo_point_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::GeoPointInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of address_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::AddressInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::AddressInfo] the created resource
            def self.address_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::AddressInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of topic_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::TopicInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::TopicInfo] the created resource
            def self.topic_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::TopicInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of language_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::LanguageInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::LanguageInfo] the created resource
            def self.language_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::LanguageInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of ip_block_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::IpBlockInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::IpBlockInfo] the created resource
            def self.ip_block_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::IpBlockInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of content_label_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ContentLabelInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ContentLabelInfo] the created resource
            def self.content_label_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::ContentLabelInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of carrier_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::CarrierInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::CarrierInfo] the created resource
            def self.carrier_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::CarrierInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of user_interest_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::UserInterestInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::UserInterestInfo] the created resource
            def self.user_interest_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::UserInterestInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of webpage_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::WebpageInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::WebpageInfo] the created resource
            def self.webpage_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::WebpageInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of webpage_condition_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::WebpageConditionInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::WebpageConditionInfo] the created resource
            def self.webpage_condition_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::WebpageConditionInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of webpage_sample_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::WebpageSampleInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::WebpageSampleInfo] the created resource
            def self.webpage_sample_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::WebpageSampleInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of operating_system_version_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::OperatingSystemVersionInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::OperatingSystemVersionInfo] the created resource
            def self.operating_system_version_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::OperatingSystemVersionInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of app_payment_model_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::AppPaymentModelInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::AppPaymentModelInfo] the created resource
            def self.app_payment_model_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::AppPaymentModelInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mobile_device_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::MobileDeviceInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::MobileDeviceInfo] the created resource
            def self.mobile_device_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::MobileDeviceInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of custom_affinity_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::CustomAffinityInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::CustomAffinityInfo] the created resource
            def self.custom_affinity_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::CustomAffinityInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of custom_intent_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::CustomIntentInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::CustomIntentInfo] the created resource
            def self.custom_intent_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::CustomIntentInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of location_group_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::LocationGroupInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::LocationGroupInfo] the created resource
            def self.location_group_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::LocationGroupInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of custom_audience_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::CustomAudienceInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::CustomAudienceInfo] the created resource
            def self.custom_audience_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::CustomAudienceInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of combined_audience_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::CombinedAudienceInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::CombinedAudienceInfo] the created resource
            def self.combined_audience_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::CombinedAudienceInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_theme_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::KeywordThemeInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::KeywordThemeInfo] the created resource
            def self.keyword_theme_info
              require "google/ads/google_ads/v8/common/criteria_pb"
              res = Google::Ads::GoogleAds::V8::Common::KeywordThemeInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of campaign_bid_modifier, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CampaignBidModifier] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CampaignBidModifier] the created resource
            def self.campaign_bid_modifier
              require "google/ads/google_ads/v8/resources/campaign_bid_modifier_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CampaignBidModifier.new
              yield res if block_given?
              res
            end

            # Returns a new instance of customer_client, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CustomerClient] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CustomerClient] the created resource
            def self.customer_client
              require "google/ads/google_ads/v8/resources/customer_client_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CustomerClient.new
              yield res if block_given?
              res
            end

            # Returns a new instance of shared_criterion, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::SharedCriterion] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::SharedCriterion] the created resource
            def self.shared_criterion
              require "google/ads/google_ads/v8/resources/shared_criterion_pb"
              res = Google::Ads::GoogleAds::V8::Resources::SharedCriterion.new
              yield res if block_given?
              res
            end

            # Returns a new instance of billing_setup, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::BillingSetup] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::BillingSetup] the created resource
            def self.billing_setup
              require "google/ads/google_ads/v8/resources/billing_setup_pb"
              res = Google::Ads::GoogleAds::V8::Resources::BillingSetup.new
              yield res if block_given?
              res
            end

            # Returns a new instance of payments_account_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::BillingSetup::PaymentsAccountInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::BillingSetup::PaymentsAccountInfo] the created resource
            def self.payments_account_info
              require "google/ads/google_ads/v8/resources/billing_setup_pb"
              res = Google::Ads::GoogleAds::V8::Resources::BillingSetup::PaymentsAccountInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of ad_group_label, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AdGroupLabel] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AdGroupLabel] the created resource
            def self.ad_group_label
              require "google/ads/google_ads/v8/resources/ad_group_label_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AdGroupLabel.new
              yield res if block_given?
              res
            end

            # Returns a new instance of ad_asset_policy_summary, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::AdAssetPolicySummary] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::AdAssetPolicySummary] the created resource
            def self.ad_asset_policy_summary
              require "google/ads/google_ads/v8/common/asset_policy_pb"
              res = Google::Ads::GoogleAds::V8::Common::AdAssetPolicySummary.new
              yield res if block_given?
              res
            end

            # Returns a new instance of ad_text_asset, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::AdTextAsset] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::AdTextAsset] the created resource
            def self.ad_text_asset
              require "google/ads/google_ads/v8/common/ad_asset_pb"
              res = Google::Ads::GoogleAds::V8::Common::AdTextAsset.new
              yield res if block_given?
              res
            end

            # Returns a new instance of ad_image_asset, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::AdImageAsset] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::AdImageAsset] the created resource
            def self.ad_image_asset
              require "google/ads/google_ads/v8/common/ad_asset_pb"
              res = Google::Ads::GoogleAds::V8::Common::AdImageAsset.new
              yield res if block_given?
              res
            end

            # Returns a new instance of ad_video_asset, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::AdVideoAsset] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::AdVideoAsset] the created resource
            def self.ad_video_asset
              require "google/ads/google_ads/v8/common/ad_asset_pb"
              res = Google::Ads::GoogleAds::V8::Common::AdVideoAsset.new
              yield res if block_given?
              res
            end

            # Returns a new instance of ad_media_bundle_asset, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::AdMediaBundleAsset] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::AdMediaBundleAsset] the created resource
            def self.ad_media_bundle_asset
              require "google/ads/google_ads/v8/common/ad_asset_pb"
              res = Google::Ads::GoogleAds::V8::Common::AdMediaBundleAsset.new
              yield res if block_given?
              res
            end

            # Returns a new instance of text_ad_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::TextAdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::TextAdInfo] the created resource
            def self.text_ad_info
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::TextAdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of expanded_text_ad_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ExpandedTextAdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ExpandedTextAdInfo] the created resource
            def self.expanded_text_ad_info
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::ExpandedTextAdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of expanded_dynamic_search_ad_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ExpandedDynamicSearchAdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ExpandedDynamicSearchAdInfo] the created resource
            def self.expanded_dynamic_search_ad_info
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::ExpandedDynamicSearchAdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of hotel_ad_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::HotelAdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::HotelAdInfo] the created resource
            def self.hotel_ad_info
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::HotelAdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of shopping_smart_ad_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ShoppingSmartAdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ShoppingSmartAdInfo] the created resource
            def self.shopping_smart_ad_info
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::ShoppingSmartAdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of shopping_product_ad_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ShoppingProductAdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ShoppingProductAdInfo] the created resource
            def self.shopping_product_ad_info
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::ShoppingProductAdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of shopping_comparison_listing_ad_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ShoppingComparisonListingAdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ShoppingComparisonListingAdInfo] the created resource
            def self.shopping_comparison_listing_ad_info
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::ShoppingComparisonListingAdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of gmail_ad_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::GmailAdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::GmailAdInfo] the created resource
            def self.gmail_ad_info
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::GmailAdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of gmail_teaser, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::GmailTeaser] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::GmailTeaser] the created resource
            def self.gmail_teaser
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::GmailTeaser.new
              yield res if block_given?
              res
            end

            # Returns a new instance of display_call_to_action, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::DisplayCallToAction] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::DisplayCallToAction] the created resource
            def self.display_call_to_action
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::DisplayCallToAction.new
              yield res if block_given?
              res
            end

            # Returns a new instance of product_image, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ProductImage] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ProductImage] the created resource
            def self.product_image
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::ProductImage.new
              yield res if block_given?
              res
            end

            # Returns a new instance of product_video, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ProductVideo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ProductVideo] the created resource
            def self.product_video
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::ProductVideo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of image_ad_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ImageAdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ImageAdInfo] the created resource
            def self.image_ad_info
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::ImageAdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of video_bumper_in_stream_ad_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::VideoBumperInStreamAdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::VideoBumperInStreamAdInfo] the created resource
            def self.video_bumper_in_stream_ad_info
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::VideoBumperInStreamAdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of video_non_skippable_in_stream_ad_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::VideoNonSkippableInStreamAdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::VideoNonSkippableInStreamAdInfo] the created resource
            def self.video_non_skippable_in_stream_ad_info
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::VideoNonSkippableInStreamAdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of video_true_view_in_stream_ad_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::VideoTrueViewInStreamAdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::VideoTrueViewInStreamAdInfo] the created resource
            def self.video_true_view_in_stream_ad_info
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::VideoTrueViewInStreamAdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of video_outstream_ad_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::VideoOutstreamAdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::VideoOutstreamAdInfo] the created resource
            def self.video_outstream_ad_info
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::VideoOutstreamAdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of video_true_view_discovery_ad_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::VideoTrueViewDiscoveryAdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::VideoTrueViewDiscoveryAdInfo] the created resource
            def self.video_true_view_discovery_ad_info
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::VideoTrueViewDiscoveryAdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of video_ad_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::VideoAdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::VideoAdInfo] the created resource
            def self.video_ad_info
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::VideoAdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of video_responsive_ad_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::VideoResponsiveAdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::VideoResponsiveAdInfo] the created resource
            def self.video_responsive_ad_info
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::VideoResponsiveAdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of responsive_search_ad_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ResponsiveSearchAdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ResponsiveSearchAdInfo] the created resource
            def self.responsive_search_ad_info
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::ResponsiveSearchAdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of legacy_responsive_display_ad_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::LegacyResponsiveDisplayAdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::LegacyResponsiveDisplayAdInfo] the created resource
            def self.legacy_responsive_display_ad_info
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::LegacyResponsiveDisplayAdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of app_ad_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::AppAdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::AppAdInfo] the created resource
            def self.app_ad_info
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::AppAdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of app_engagement_ad_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::AppEngagementAdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::AppEngagementAdInfo] the created resource
            def self.app_engagement_ad_info
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::AppEngagementAdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of legacy_app_install_ad_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::LegacyAppInstallAdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::LegacyAppInstallAdInfo] the created resource
            def self.legacy_app_install_ad_info
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::LegacyAppInstallAdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of responsive_display_ad_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ResponsiveDisplayAdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ResponsiveDisplayAdInfo] the created resource
            def self.responsive_display_ad_info
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::ResponsiveDisplayAdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of local_ad_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::LocalAdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::LocalAdInfo] the created resource
            def self.local_ad_info
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::LocalAdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of display_upload_ad_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::DisplayUploadAdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::DisplayUploadAdInfo] the created resource
            def self.display_upload_ad_info
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::DisplayUploadAdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of responsive_display_ad_control_spec, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ResponsiveDisplayAdControlSpec] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ResponsiveDisplayAdControlSpec] the created resource
            def self.responsive_display_ad_control_spec
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::ResponsiveDisplayAdControlSpec.new
              yield res if block_given?
              res
            end

            # Returns a new instance of smart_campaign_ad_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::SmartCampaignAdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::SmartCampaignAdInfo] the created resource
            def self.smart_campaign_ad_info
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::SmartCampaignAdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of call_ad_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::CallAdInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::CallAdInfo] the created resource
            def self.call_ad_info
              require "google/ads/google_ads/v8/common/ad_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::CallAdInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of final_app_url, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::FinalAppUrl] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::FinalAppUrl] the created resource
            def self.final_app_url
              require "google/ads/google_ads/v8/common/final_app_url_pb"
              res = Google::Ads::GoogleAds::V8::Common::FinalAppUrl.new
              yield res if block_given?
              res
            end

            # Returns a new instance of url_collection, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::UrlCollection] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::UrlCollection] the created resource
            def self.url_collection
              require "google/ads/google_ads/v8/common/url_collection_pb"
              res = Google::Ads::GoogleAds::V8::Common::UrlCollection.new
              yield res if block_given?
              res
            end

            # Returns a new instance of ad, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Ad] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Ad] the created resource
            def self.ad
              require "google/ads/google_ads/v8/resources/ad_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Ad.new
              yield res if block_given?
              res
            end

            # Returns a new instance of webpage_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::WebpageView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::WebpageView] the created resource
            def self.webpage_view
              require "google/ads/google_ads/v8/resources/webpage_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::WebpageView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of customer_manager_link, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CustomerManagerLink] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CustomerManagerLink] the created resource
            def self.customer_manager_link
              require "google/ads/google_ads/v8/resources/customer_manager_link_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CustomerManagerLink.new
              yield res if block_given?
              res
            end

            # Returns a new instance of carrier_constant, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CarrierConstant] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CarrierConstant] the created resource
            def self.carrier_constant
              require "google/ads/google_ads/v8/resources/carrier_constant_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CarrierConstant.new
              yield res if block_given?
              res
            end

            # Returns a new instance of commission, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::Commission] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::Commission] the created resource
            def self.commission
              require "google/ads/google_ads/v8/common/bidding_pb"
              res = Google::Ads::GoogleAds::V8::Common::Commission.new
              yield res if block_given?
              res
            end

            # Returns a new instance of enhanced_cpc, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::EnhancedCpc] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::EnhancedCpc] the created resource
            def self.enhanced_cpc
              require "google/ads/google_ads/v8/common/bidding_pb"
              res = Google::Ads::GoogleAds::V8::Common::EnhancedCpc.new
              yield res if block_given?
              res
            end

            # Returns a new instance of manual_cpc, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ManualCpc] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ManualCpc] the created resource
            def self.manual_cpc
              require "google/ads/google_ads/v8/common/bidding_pb"
              res = Google::Ads::GoogleAds::V8::Common::ManualCpc.new
              yield res if block_given?
              res
            end

            # Returns a new instance of manual_cpm, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ManualCpm] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ManualCpm] the created resource
            def self.manual_cpm
              require "google/ads/google_ads/v8/common/bidding_pb"
              res = Google::Ads::GoogleAds::V8::Common::ManualCpm.new
              yield res if block_given?
              res
            end

            # Returns a new instance of manual_cpv, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ManualCpv] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ManualCpv] the created resource
            def self.manual_cpv
              require "google/ads/google_ads/v8/common/bidding_pb"
              res = Google::Ads::GoogleAds::V8::Common::ManualCpv.new
              yield res if block_given?
              res
            end

            # Returns a new instance of maximize_conversions, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::MaximizeConversions] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::MaximizeConversions] the created resource
            def self.maximize_conversions
              require "google/ads/google_ads/v8/common/bidding_pb"
              res = Google::Ads::GoogleAds::V8::Common::MaximizeConversions.new
              yield res if block_given?
              res
            end

            # Returns a new instance of maximize_conversion_value, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::MaximizeConversionValue] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::MaximizeConversionValue] the created resource
            def self.maximize_conversion_value
              require "google/ads/google_ads/v8/common/bidding_pb"
              res = Google::Ads::GoogleAds::V8::Common::MaximizeConversionValue.new
              yield res if block_given?
              res
            end

            # Returns a new instance of target_cpa, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::TargetCpa] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::TargetCpa] the created resource
            def self.target_cpa
              require "google/ads/google_ads/v8/common/bidding_pb"
              res = Google::Ads::GoogleAds::V8::Common::TargetCpa.new
              yield res if block_given?
              res
            end

            # Returns a new instance of target_cpm, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::TargetCpm] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::TargetCpm] the created resource
            def self.target_cpm
              require "google/ads/google_ads/v8/common/bidding_pb"
              res = Google::Ads::GoogleAds::V8::Common::TargetCpm.new
              yield res if block_given?
              res
            end

            # Returns a new instance of target_impression_share, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::TargetImpressionShare] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::TargetImpressionShare] the created resource
            def self.target_impression_share
              require "google/ads/google_ads/v8/common/bidding_pb"
              res = Google::Ads::GoogleAds::V8::Common::TargetImpressionShare.new
              yield res if block_given?
              res
            end

            # Returns a new instance of target_roas, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::TargetRoas] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::TargetRoas] the created resource
            def self.target_roas
              require "google/ads/google_ads/v8/common/bidding_pb"
              res = Google::Ads::GoogleAds::V8::Common::TargetRoas.new
              yield res if block_given?
              res
            end

            # Returns a new instance of target_spend, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::TargetSpend] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::TargetSpend] the created resource
            def self.target_spend
              require "google/ads/google_ads/v8/common/bidding_pb"
              res = Google::Ads::GoogleAds::V8::Common::TargetSpend.new
              yield res if block_given?
              res
            end

            # Returns a new instance of percent_cpc, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::PercentCpc] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::PercentCpc] the created resource
            def self.percent_cpc
              require "google/ads/google_ads/v8/common/bidding_pb"
              res = Google::Ads::GoogleAds::V8::Common::PercentCpc.new
              yield res if block_given?
              res
            end

            # Returns a new instance of bidding_strategy, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::BiddingStrategy] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::BiddingStrategy] the created resource
            def self.bidding_strategy
              require "google/ads/google_ads/v8/resources/bidding_strategy_pb"
              res = Google::Ads::GoogleAds::V8::Resources::BiddingStrategy.new
              yield res if block_given?
              res
            end

            # Returns a new instance of age_range_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AgeRangeView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AgeRangeView] the created resource
            def self.age_range_view
              require "google/ads/google_ads/v8/resources/age_range_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AgeRangeView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of click_location, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ClickLocation] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ClickLocation] the created resource
            def self.click_location
              require "google/ads/google_ads/v8/common/click_location_pb"
              res = Google::Ads::GoogleAds::V8::Common::ClickLocation.new
              yield res if block_given?
              res
            end

            # Returns a new instance of click_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::ClickView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::ClickView] the created resource
            def self.click_view
              require "google/ads/google_ads/v8/resources/click_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::ClickView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of managed_placement_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::ManagedPlacementView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::ManagedPlacementView] the created resource
            def self.managed_placement_view
              require "google/ads/google_ads/v8/resources/managed_placement_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::ManagedPlacementView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of payments_account, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::PaymentsAccount] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::PaymentsAccount] the created resource
            def self.payments_account
              require "google/ads/google_ads/v8/resources/payments_account_pb"
              res = Google::Ads::GoogleAds::V8::Resources::PaymentsAccount.new
              yield res if block_given?
              res
            end

            # Returns a new instance of campaign_shared_set, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CampaignSharedSet] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CampaignSharedSet] the created resource
            def self.campaign_shared_set
              require "google/ads/google_ads/v8/resources/campaign_shared_set_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CampaignSharedSet.new
              yield res if block_given?
              res
            end

            # Returns a new instance of bidding_seasonality_adjustment, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::BiddingSeasonalityAdjustment] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::BiddingSeasonalityAdjustment] the created resource
            def self.bidding_seasonality_adjustment
              require "google/ads/google_ads/v8/resources/bidding_seasonality_adjustment_pb"
              res = Google::Ads::GoogleAds::V8::Resources::BiddingSeasonalityAdjustment.new
              yield res if block_given?
              res
            end

            # Returns a new instance of similar_user_list_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::SimilarUserListInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::SimilarUserListInfo] the created resource
            def self.similar_user_list_info
              require "google/ads/google_ads/v8/common/user_lists_pb"
              res = Google::Ads::GoogleAds::V8::Common::SimilarUserListInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of crm_based_user_list_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::CrmBasedUserListInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::CrmBasedUserListInfo] the created resource
            def self.crm_based_user_list_info
              require "google/ads/google_ads/v8/common/user_lists_pb"
              res = Google::Ads::GoogleAds::V8::Common::CrmBasedUserListInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of user_list_rule_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::UserListRuleInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::UserListRuleInfo] the created resource
            def self.user_list_rule_info
              require "google/ads/google_ads/v8/common/user_lists_pb"
              res = Google::Ads::GoogleAds::V8::Common::UserListRuleInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of user_list_rule_item_group_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::UserListRuleItemGroupInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::UserListRuleItemGroupInfo] the created resource
            def self.user_list_rule_item_group_info
              require "google/ads/google_ads/v8/common/user_lists_pb"
              res = Google::Ads::GoogleAds::V8::Common::UserListRuleItemGroupInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of user_list_rule_item_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::UserListRuleItemInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::UserListRuleItemInfo] the created resource
            def self.user_list_rule_item_info
              require "google/ads/google_ads/v8/common/user_lists_pb"
              res = Google::Ads::GoogleAds::V8::Common::UserListRuleItemInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of user_list_date_rule_item_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::UserListDateRuleItemInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::UserListDateRuleItemInfo] the created resource
            def self.user_list_date_rule_item_info
              require "google/ads/google_ads/v8/common/user_lists_pb"
              res = Google::Ads::GoogleAds::V8::Common::UserListDateRuleItemInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of user_list_number_rule_item_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::UserListNumberRuleItemInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::UserListNumberRuleItemInfo] the created resource
            def self.user_list_number_rule_item_info
              require "google/ads/google_ads/v8/common/user_lists_pb"
              res = Google::Ads::GoogleAds::V8::Common::UserListNumberRuleItemInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of user_list_string_rule_item_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::UserListStringRuleItemInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::UserListStringRuleItemInfo] the created resource
            def self.user_list_string_rule_item_info
              require "google/ads/google_ads/v8/common/user_lists_pb"
              res = Google::Ads::GoogleAds::V8::Common::UserListStringRuleItemInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of combined_rule_user_list_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::CombinedRuleUserListInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::CombinedRuleUserListInfo] the created resource
            def self.combined_rule_user_list_info
              require "google/ads/google_ads/v8/common/user_lists_pb"
              res = Google::Ads::GoogleAds::V8::Common::CombinedRuleUserListInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of date_specific_rule_user_list_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::DateSpecificRuleUserListInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::DateSpecificRuleUserListInfo] the created resource
            def self.date_specific_rule_user_list_info
              require "google/ads/google_ads/v8/common/user_lists_pb"
              res = Google::Ads::GoogleAds::V8::Common::DateSpecificRuleUserListInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of expression_rule_user_list_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ExpressionRuleUserListInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ExpressionRuleUserListInfo] the created resource
            def self.expression_rule_user_list_info
              require "google/ads/google_ads/v8/common/user_lists_pb"
              res = Google::Ads::GoogleAds::V8::Common::ExpressionRuleUserListInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of rule_based_user_list_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::RuleBasedUserListInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::RuleBasedUserListInfo] the created resource
            def self.rule_based_user_list_info
              require "google/ads/google_ads/v8/common/user_lists_pb"
              res = Google::Ads::GoogleAds::V8::Common::RuleBasedUserListInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of logical_user_list_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::LogicalUserListInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::LogicalUserListInfo] the created resource
            def self.logical_user_list_info
              require "google/ads/google_ads/v8/common/user_lists_pb"
              res = Google::Ads::GoogleAds::V8::Common::LogicalUserListInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of user_list_logical_rule_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::UserListLogicalRuleInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::UserListLogicalRuleInfo] the created resource
            def self.user_list_logical_rule_info
              require "google/ads/google_ads/v8/common/user_lists_pb"
              res = Google::Ads::GoogleAds::V8::Common::UserListLogicalRuleInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of logical_user_list_operand_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::LogicalUserListOperandInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::LogicalUserListOperandInfo] the created resource
            def self.logical_user_list_operand_info
              require "google/ads/google_ads/v8/common/user_lists_pb"
              res = Google::Ads::GoogleAds::V8::Common::LogicalUserListOperandInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of basic_user_list_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::BasicUserListInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::BasicUserListInfo] the created resource
            def self.basic_user_list_info
              require "google/ads/google_ads/v8/common/user_lists_pb"
              res = Google::Ads::GoogleAds::V8::Common::BasicUserListInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of user_list_action_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::UserListActionInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::UserListActionInfo] the created resource
            def self.user_list_action_info
              require "google/ads/google_ads/v8/common/user_lists_pb"
              res = Google::Ads::GoogleAds::V8::Common::UserListActionInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of user_list, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::UserList] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::UserList] the created resource
            def self.user_list
              require "google/ads/google_ads/v8/resources/user_list_pb"
              res = Google::Ads::GoogleAds::V8::Resources::UserList.new
              yield res if block_given?
              res
            end

            # Returns a new instance of conversion_value_rule, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::ConversionValueRule] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::ConversionValueRule] the created resource
            def self.conversion_value_rule
              require "google/ads/google_ads/v8/resources/conversion_value_rule_pb"
              res = Google::Ads::GoogleAds::V8::Resources::ConversionValueRule.new
              yield res if block_given?
              res
            end

            # Returns a new instance of value_rule_action, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::ConversionValueRule::ValueRuleAction] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::ConversionValueRule::ValueRuleAction] the created resource
            def self.value_rule_action
              require "google/ads/google_ads/v8/resources/conversion_value_rule_pb"
              res = Google::Ads::GoogleAds::V8::Resources::ConversionValueRule::ValueRuleAction.new
              yield res if block_given?
              res
            end

            # Returns a new instance of value_rule_geo_location_condition, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::ConversionValueRule::ValueRuleGeoLocationCondition] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::ConversionValueRule::ValueRuleGeoLocationCondition] the created resource
            def self.value_rule_geo_location_condition
              require "google/ads/google_ads/v8/resources/conversion_value_rule_pb"
              res = Google::Ads::GoogleAds::V8::Resources::ConversionValueRule::ValueRuleGeoLocationCondition.new
              yield res if block_given?
              res
            end

            # Returns a new instance of value_rule_device_condition, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::ConversionValueRule::ValueRuleDeviceCondition] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::ConversionValueRule::ValueRuleDeviceCondition] the created resource
            def self.value_rule_device_condition
              require "google/ads/google_ads/v8/resources/conversion_value_rule_pb"
              res = Google::Ads::GoogleAds::V8::Resources::ConversionValueRule::ValueRuleDeviceCondition.new
              yield res if block_given?
              res
            end

            # Returns a new instance of value_rule_audience_condition, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::ConversionValueRule::ValueRuleAudienceCondition] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::ConversionValueRule::ValueRuleAudienceCondition] the created resource
            def self.value_rule_audience_condition
              require "google/ads/google_ads/v8/resources/conversion_value_rule_pb"
              res = Google::Ads::GoogleAds::V8::Resources::ConversionValueRule::ValueRuleAudienceCondition.new
              yield res if block_given?
              res
            end

            # Returns a new instance of explorer_auto_optimizer_setting, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ExplorerAutoOptimizerSetting] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ExplorerAutoOptimizerSetting] the created resource
            def self.explorer_auto_optimizer_setting
              require "google/ads/google_ads/v8/common/explorer_auto_optimizer_setting_pb"
              res = Google::Ads::GoogleAds::V8::Common::ExplorerAutoOptimizerSetting.new
              yield res if block_given?
              res
            end

            # Returns a new instance of targeting_setting, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::TargetingSetting] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::TargetingSetting] the created resource
            def self.targeting_setting
              require "google/ads/google_ads/v8/common/targeting_setting_pb"
              res = Google::Ads::GoogleAds::V8::Common::TargetingSetting.new
              yield res if block_given?
              res
            end

            # Returns a new instance of target_restriction, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::TargetRestriction] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::TargetRestriction] the created resource
            def self.target_restriction
              require "google/ads/google_ads/v8/common/targeting_setting_pb"
              res = Google::Ads::GoogleAds::V8::Common::TargetRestriction.new
              yield res if block_given?
              res
            end

            # Returns a new instance of ad_group, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AdGroup] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AdGroup] the created resource
            def self.ad_group
              require "google/ads/google_ads/v8/resources/ad_group_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AdGroup.new
              yield res if block_given?
              res
            end

            # Returns a new instance of ad_group_ad, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AdGroupAd] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AdGroupAd] the created resource
            def self.ad_group_ad
              require "google/ads/google_ads/v8/resources/ad_group_ad_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AdGroupAd.new
              yield res if block_given?
              res
            end

            # Returns a new instance of ad_group_ad_policy_summary, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AdGroupAdPolicySummary] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AdGroupAdPolicySummary] the created resource
            def self.ad_group_ad_policy_summary
              require "google/ads/google_ads/v8/resources/ad_group_ad_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AdGroupAdPolicySummary.new
              yield res if block_given?
              res
            end

            # Returns a new instance of ad_group_asset, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AdGroupAsset] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AdGroupAsset] the created resource
            def self.ad_group_asset
              require "google/ads/google_ads/v8/resources/ad_group_asset_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AdGroupAsset.new
              yield res if block_given?
              res
            end

            # Returns a new instance of ad_group_bid_modifier, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AdGroupBidModifier] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AdGroupBidModifier] the created resource
            def self.ad_group_bid_modifier
              require "google/ads/google_ads/v8/resources/ad_group_bid_modifier_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AdGroupBidModifier.new
              yield res if block_given?
              res
            end

            # Returns a new instance of ad_group_criterion, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AdGroupCriterion] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AdGroupCriterion] the created resource
            def self.ad_group_criterion
              require "google/ads/google_ads/v8/resources/ad_group_criterion_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AdGroupCriterion.new
              yield res if block_given?
              res
            end

            # Returns a new instance of quality_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AdGroupCriterion::QualityInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AdGroupCriterion::QualityInfo] the created resource
            def self.quality_info
              require "google/ads/google_ads/v8/resources/ad_group_criterion_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AdGroupCriterion::QualityInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of position_estimates, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AdGroupCriterion::PositionEstimates] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AdGroupCriterion::PositionEstimates] the created resource
            def self.position_estimates
              require "google/ads/google_ads/v8/resources/ad_group_criterion_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AdGroupCriterion::PositionEstimates.new
              yield res if block_given?
              res
            end

            # Returns a new instance of youtube_video_asset, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::YoutubeVideoAsset] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::YoutubeVideoAsset] the created resource
            def self.youtube_video_asset
              require "google/ads/google_ads/v8/common/asset_types_pb"
              res = Google::Ads::GoogleAds::V8::Common::YoutubeVideoAsset.new
              yield res if block_given?
              res
            end

            # Returns a new instance of media_bundle_asset, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::MediaBundleAsset] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::MediaBundleAsset] the created resource
            def self.media_bundle_asset
              require "google/ads/google_ads/v8/common/asset_types_pb"
              res = Google::Ads::GoogleAds::V8::Common::MediaBundleAsset.new
              yield res if block_given?
              res
            end

            # Returns a new instance of image_asset, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ImageAsset] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ImageAsset] the created resource
            def self.image_asset
              require "google/ads/google_ads/v8/common/asset_types_pb"
              res = Google::Ads::GoogleAds::V8::Common::ImageAsset.new
              yield res if block_given?
              res
            end

            # Returns a new instance of image_dimension, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ImageDimension] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ImageDimension] the created resource
            def self.image_dimension
              require "google/ads/google_ads/v8/common/asset_types_pb"
              res = Google::Ads::GoogleAds::V8::Common::ImageDimension.new
              yield res if block_given?
              res
            end

            # Returns a new instance of text_asset, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::TextAsset] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::TextAsset] the created resource
            def self.text_asset
              require "google/ads/google_ads/v8/common/asset_types_pb"
              res = Google::Ads::GoogleAds::V8::Common::TextAsset.new
              yield res if block_given?
              res
            end

            # Returns a new instance of lead_form_asset, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::LeadFormAsset] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::LeadFormAsset] the created resource
            def self.lead_form_asset
              require "google/ads/google_ads/v8/common/asset_types_pb"
              res = Google::Ads::GoogleAds::V8::Common::LeadFormAsset.new
              yield res if block_given?
              res
            end

            # Returns a new instance of lead_form_field, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::LeadFormField] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::LeadFormField] the created resource
            def self.lead_form_field
              require "google/ads/google_ads/v8/common/asset_types_pb"
              res = Google::Ads::GoogleAds::V8::Common::LeadFormField.new
              yield res if block_given?
              res
            end

            # Returns a new instance of lead_form_single_choice_answers, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::LeadFormSingleChoiceAnswers] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::LeadFormSingleChoiceAnswers] the created resource
            def self.lead_form_single_choice_answers
              require "google/ads/google_ads/v8/common/asset_types_pb"
              res = Google::Ads::GoogleAds::V8::Common::LeadFormSingleChoiceAnswers.new
              yield res if block_given?
              res
            end

            # Returns a new instance of lead_form_delivery_method, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::LeadFormDeliveryMethod] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::LeadFormDeliveryMethod] the created resource
            def self.lead_form_delivery_method
              require "google/ads/google_ads/v8/common/asset_types_pb"
              res = Google::Ads::GoogleAds::V8::Common::LeadFormDeliveryMethod.new
              yield res if block_given?
              res
            end

            # Returns a new instance of webhook_delivery, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::WebhookDelivery] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::WebhookDelivery] the created resource
            def self.webhook_delivery
              require "google/ads/google_ads/v8/common/asset_types_pb"
              res = Google::Ads::GoogleAds::V8::Common::WebhookDelivery.new
              yield res if block_given?
              res
            end

            # Returns a new instance of book_on_google_asset, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::BookOnGoogleAsset] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::BookOnGoogleAsset] the created resource
            def self.book_on_google_asset
              require "google/ads/google_ads/v8/common/asset_types_pb"
              res = Google::Ads::GoogleAds::V8::Common::BookOnGoogleAsset.new
              yield res if block_given?
              res
            end

            # Returns a new instance of promotion_asset, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::PromotionAsset] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::PromotionAsset] the created resource
            def self.promotion_asset
              require "google/ads/google_ads/v8/common/asset_types_pb"
              res = Google::Ads::GoogleAds::V8::Common::PromotionAsset.new
              yield res if block_given?
              res
            end

            # Returns a new instance of callout_asset, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::CalloutAsset] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::CalloutAsset] the created resource
            def self.callout_asset
              require "google/ads/google_ads/v8/common/asset_types_pb"
              res = Google::Ads::GoogleAds::V8::Common::CalloutAsset.new
              yield res if block_given?
              res
            end

            # Returns a new instance of structured_snippet_asset, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::StructuredSnippetAsset] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::StructuredSnippetAsset] the created resource
            def self.structured_snippet_asset
              require "google/ads/google_ads/v8/common/asset_types_pb"
              res = Google::Ads::GoogleAds::V8::Common::StructuredSnippetAsset.new
              yield res if block_given?
              res
            end

            # Returns a new instance of sitelink_asset, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::SitelinkAsset] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::SitelinkAsset] the created resource
            def self.sitelink_asset
              require "google/ads/google_ads/v8/common/asset_types_pb"
              res = Google::Ads::GoogleAds::V8::Common::SitelinkAsset.new
              yield res if block_given?
              res
            end

            # Returns a new instance of asset, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Asset] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Asset] the created resource
            def self.asset
              require "google/ads/google_ads/v8/resources/asset_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Asset.new
              yield res if block_given?
              res
            end

            # Returns a new instance of asset_policy_summary, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AssetPolicySummary] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AssetPolicySummary] the created resource
            def self.asset_policy_summary
              require "google/ads/google_ads/v8/resources/asset_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AssetPolicySummary.new
              yield res if block_given?
              res
            end

            # Returns a new instance of frequency_cap_entry, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::FrequencyCapEntry] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::FrequencyCapEntry] the created resource
            def self.frequency_cap_entry
              require "google/ads/google_ads/v8/common/frequency_cap_pb"
              res = Google::Ads::GoogleAds::V8::Common::FrequencyCapEntry.new
              yield res if block_given?
              res
            end

            # Returns a new instance of frequency_cap_key, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::FrequencyCapKey] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::FrequencyCapKey] the created resource
            def self.frequency_cap_key
              require "google/ads/google_ads/v8/common/frequency_cap_pb"
              res = Google::Ads::GoogleAds::V8::Common::FrequencyCapKey.new
              yield res if block_given?
              res
            end

            # Returns a new instance of real_time_bidding_setting, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::RealTimeBiddingSetting] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::RealTimeBiddingSetting] the created resource
            def self.real_time_bidding_setting
              require "google/ads/google_ads/v8/common/real_time_bidding_setting_pb"
              res = Google::Ads::GoogleAds::V8::Common::RealTimeBiddingSetting.new
              yield res if block_given?
              res
            end

            # Returns a new instance of campaign, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Campaign] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Campaign] the created resource
            def self.campaign
              require "google/ads/google_ads/v8/resources/campaign_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Campaign.new
              yield res if block_given?
              res
            end

            # Returns a new instance of network_settings, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Campaign::NetworkSettings] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Campaign::NetworkSettings] the created resource
            def self.network_settings
              require "google/ads/google_ads/v8/resources/campaign_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Campaign::NetworkSettings.new
              yield res if block_given?
              res
            end

            # Returns a new instance of hotel_setting_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Campaign::HotelSettingInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Campaign::HotelSettingInfo] the created resource
            def self.hotel_setting_info
              require "google/ads/google_ads/v8/resources/campaign_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Campaign::HotelSettingInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of tracking_setting, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Campaign::TrackingSetting] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Campaign::TrackingSetting] the created resource
            def self.tracking_setting
              require "google/ads/google_ads/v8/resources/campaign_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Campaign::TrackingSetting.new
              yield res if block_given?
              res
            end

            # Returns a new instance of dynamic_search_ads_setting, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Campaign::DynamicSearchAdsSetting] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Campaign::DynamicSearchAdsSetting] the created resource
            def self.dynamic_search_ads_setting
              require "google/ads/google_ads/v8/resources/campaign_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Campaign::DynamicSearchAdsSetting.new
              yield res if block_given?
              res
            end

            # Returns a new instance of shopping_setting, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Campaign::ShoppingSetting] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Campaign::ShoppingSetting] the created resource
            def self.shopping_setting
              require "google/ads/google_ads/v8/resources/campaign_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Campaign::ShoppingSetting.new
              yield res if block_given?
              res
            end

            # Returns a new instance of local_campaign_setting, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Campaign::LocalCampaignSetting] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Campaign::LocalCampaignSetting] the created resource
            def self.local_campaign_setting
              require "google/ads/google_ads/v8/resources/campaign_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Campaign::LocalCampaignSetting.new
              yield res if block_given?
              res
            end

            # Returns a new instance of selective_optimization, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Campaign::SelectiveOptimization] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Campaign::SelectiveOptimization] the created resource
            def self.selective_optimization
              require "google/ads/google_ads/v8/resources/campaign_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Campaign::SelectiveOptimization.new
              yield res if block_given?
              res
            end

            # Returns a new instance of geo_target_type_setting, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Campaign::GeoTargetTypeSetting] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Campaign::GeoTargetTypeSetting] the created resource
            def self.geo_target_type_setting
              require "google/ads/google_ads/v8/resources/campaign_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Campaign::GeoTargetTypeSetting.new
              yield res if block_given?
              res
            end

            # Returns a new instance of app_campaign_setting, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Campaign::AppCampaignSetting] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Campaign::AppCampaignSetting] the created resource
            def self.app_campaign_setting
              require "google/ads/google_ads/v8/resources/campaign_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Campaign::AppCampaignSetting.new
              yield res if block_given?
              res
            end

            # Returns a new instance of vanity_pharma, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Campaign::VanityPharma] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Campaign::VanityPharma] the created resource
            def self.vanity_pharma
              require "google/ads/google_ads/v8/resources/campaign_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Campaign::VanityPharma.new
              yield res if block_given?
              res
            end

            # Returns a new instance of optimization_goal_setting, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Campaign::OptimizationGoalSetting] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Campaign::OptimizationGoalSetting] the created resource
            def self.optimization_goal_setting
              require "google/ads/google_ads/v8/resources/campaign_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Campaign::OptimizationGoalSetting.new
              yield res if block_given?
              res
            end

            # Returns a new instance of campaign_asset, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CampaignAsset] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CampaignAsset] the created resource
            def self.campaign_asset
              require "google/ads/google_ads/v8/resources/campaign_asset_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CampaignAsset.new
              yield res if block_given?
              res
            end

            # Returns a new instance of campaign_criterion, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CampaignCriterion] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CampaignCriterion] the created resource
            def self.campaign_criterion
              require "google/ads/google_ads/v8/resources/campaign_criterion_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CampaignCriterion.new
              yield res if block_given?
              res
            end

            # Returns a new instance of change_event, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::ChangeEvent] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::ChangeEvent] the created resource
            def self.change_event
              require "google/ads/google_ads/v8/resources/change_event_pb"
              res = Google::Ads::GoogleAds::V8::Resources::ChangeEvent.new
              yield res if block_given?
              res
            end

            # Returns a new instance of changed_resource, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::ChangeEvent::ChangedResource] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::ChangeEvent::ChangedResource] the created resource
            def self.changed_resource
              require "google/ads/google_ads/v8/resources/change_event_pb"
              res = Google::Ads::GoogleAds::V8::Resources::ChangeEvent::ChangedResource.new
              yield res if block_given?
              res
            end

            # Returns a new instance of custom_audience, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CustomAudience] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CustomAudience] the created resource
            def self.custom_audience
              require "google/ads/google_ads/v8/resources/custom_audience_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CustomAudience.new
              yield res if block_given?
              res
            end

            # Returns a new instance of custom_audience_member, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CustomAudienceMember] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CustomAudienceMember] the created resource
            def self.custom_audience_member
              require "google/ads/google_ads/v8/resources/custom_audience_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CustomAudienceMember.new
              yield res if block_given?
              res
            end

            # Returns a new instance of product_bidding_category_constant, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::ProductBiddingCategoryConstant] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::ProductBiddingCategoryConstant] the created resource
            def self.product_bidding_category_constant
              require "google/ads/google_ads/v8/resources/product_bidding_category_constant_pb"
              res = Google::Ads::GoogleAds::V8::Resources::ProductBiddingCategoryConstant.new
              yield res if block_given?
              res
            end

            # Returns a new instance of merchant_center_link, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::MerchantCenterLink] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::MerchantCenterLink] the created resource
            def self.merchant_center_link
              require "google/ads/google_ads/v8/resources/merchant_center_link_pb"
              res = Google::Ads::GoogleAds::V8::Resources::MerchantCenterLink.new
              yield res if block_given?
              res
            end

            # Returns a new instance of display_keyword_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::DisplayKeywordView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::DisplayKeywordView] the created resource
            def self.display_keyword_view
              require "google/ads/google_ads/v8/resources/display_keyword_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::DisplayKeywordView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of ad_group_extension_setting, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AdGroupExtensionSetting] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AdGroupExtensionSetting] the created resource
            def self.ad_group_extension_setting
              require "google/ads/google_ads/v8/resources/ad_group_extension_setting_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AdGroupExtensionSetting.new
              yield res if block_given?
              res
            end

            # Returns a new instance of ad_group_ad_asset_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AdGroupAdAssetView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AdGroupAdAssetView] the created resource
            def self.ad_group_ad_asset_view
              require "google/ads/google_ads/v8/resources/ad_group_ad_asset_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AdGroupAdAssetView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of ad_group_ad_asset_policy_summary, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AdGroupAdAssetPolicySummary] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AdGroupAdAssetPolicySummary] the created resource
            def self.ad_group_ad_asset_policy_summary
              require "google/ads/google_ads/v8/resources/ad_group_ad_asset_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AdGroupAdAssetPolicySummary.new
              yield res if block_given?
              res
            end

            # Returns a new instance of feed_item_target, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::FeedItemTarget] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::FeedItemTarget] the created resource
            def self.feed_item_target
              require "google/ads/google_ads/v8/resources/feed_item_target_pb"
              res = Google::Ads::GoogleAds::V8::Resources::FeedItemTarget.new
              yield res if block_given?
              res
            end

            # Returns a new instance of app_feed_item, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::AppFeedItem] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::AppFeedItem] the created resource
            def self.app_feed_item
              require "google/ads/google_ads/v8/common/extensions_pb"
              res = Google::Ads::GoogleAds::V8::Common::AppFeedItem.new
              yield res if block_given?
              res
            end

            # Returns a new instance of call_feed_item, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::CallFeedItem] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::CallFeedItem] the created resource
            def self.call_feed_item
              require "google/ads/google_ads/v8/common/extensions_pb"
              res = Google::Ads::GoogleAds::V8::Common::CallFeedItem.new
              yield res if block_given?
              res
            end

            # Returns a new instance of callout_feed_item, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::CalloutFeedItem] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::CalloutFeedItem] the created resource
            def self.callout_feed_item
              require "google/ads/google_ads/v8/common/extensions_pb"
              res = Google::Ads::GoogleAds::V8::Common::CalloutFeedItem.new
              yield res if block_given?
              res
            end

            # Returns a new instance of location_feed_item, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::LocationFeedItem] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::LocationFeedItem] the created resource
            def self.location_feed_item
              require "google/ads/google_ads/v8/common/extensions_pb"
              res = Google::Ads::GoogleAds::V8::Common::LocationFeedItem.new
              yield res if block_given?
              res
            end

            # Returns a new instance of affiliate_location_feed_item, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::AffiliateLocationFeedItem] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::AffiliateLocationFeedItem] the created resource
            def self.affiliate_location_feed_item
              require "google/ads/google_ads/v8/common/extensions_pb"
              res = Google::Ads::GoogleAds::V8::Common::AffiliateLocationFeedItem.new
              yield res if block_given?
              res
            end

            # Returns a new instance of text_message_feed_item, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::TextMessageFeedItem] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::TextMessageFeedItem] the created resource
            def self.text_message_feed_item
              require "google/ads/google_ads/v8/common/extensions_pb"
              res = Google::Ads::GoogleAds::V8::Common::TextMessageFeedItem.new
              yield res if block_given?
              res
            end

            # Returns a new instance of price_feed_item, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::PriceFeedItem] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::PriceFeedItem] the created resource
            def self.price_feed_item
              require "google/ads/google_ads/v8/common/extensions_pb"
              res = Google::Ads::GoogleAds::V8::Common::PriceFeedItem.new
              yield res if block_given?
              res
            end

            # Returns a new instance of price_offer, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::PriceOffer] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::PriceOffer] the created resource
            def self.price_offer
              require "google/ads/google_ads/v8/common/extensions_pb"
              res = Google::Ads::GoogleAds::V8::Common::PriceOffer.new
              yield res if block_given?
              res
            end

            # Returns a new instance of promotion_feed_item, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::PromotionFeedItem] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::PromotionFeedItem] the created resource
            def self.promotion_feed_item
              require "google/ads/google_ads/v8/common/extensions_pb"
              res = Google::Ads::GoogleAds::V8::Common::PromotionFeedItem.new
              yield res if block_given?
              res
            end

            # Returns a new instance of structured_snippet_feed_item, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::StructuredSnippetFeedItem] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::StructuredSnippetFeedItem] the created resource
            def self.structured_snippet_feed_item
              require "google/ads/google_ads/v8/common/extensions_pb"
              res = Google::Ads::GoogleAds::V8::Common::StructuredSnippetFeedItem.new
              yield res if block_given?
              res
            end

            # Returns a new instance of sitelink_feed_item, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::SitelinkFeedItem] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::SitelinkFeedItem] the created resource
            def self.sitelink_feed_item
              require "google/ads/google_ads/v8/common/extensions_pb"
              res = Google::Ads::GoogleAds::V8::Common::SitelinkFeedItem.new
              yield res if block_given?
              res
            end

            # Returns a new instance of hotel_callout_feed_item, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::HotelCalloutFeedItem] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::HotelCalloutFeedItem] the created resource
            def self.hotel_callout_feed_item
              require "google/ads/google_ads/v8/common/extensions_pb"
              res = Google::Ads::GoogleAds::V8::Common::HotelCalloutFeedItem.new
              yield res if block_given?
              res
            end

            # Returns a new instance of image_feed_item, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ImageFeedItem] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ImageFeedItem] the created resource
            def self.image_feed_item
              require "google/ads/google_ads/v8/common/extensions_pb"
              res = Google::Ads::GoogleAds::V8::Common::ImageFeedItem.new
              yield res if block_given?
              res
            end

            # Returns a new instance of extension_feed_item, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::ExtensionFeedItem] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::ExtensionFeedItem] the created resource
            def self.extension_feed_item
              require "google/ads/google_ads/v8/resources/extension_feed_item_pb"
              res = Google::Ads::GoogleAds::V8::Resources::ExtensionFeedItem.new
              yield res if block_given?
              res
            end

            # Returns a new instance of accessible_bidding_strategy, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AccessibleBiddingStrategy] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AccessibleBiddingStrategy] the created resource
            def self.accessible_bidding_strategy
              require "google/ads/google_ads/v8/resources/accessible_bidding_strategy_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AccessibleBiddingStrategy.new
              yield res if block_given?
              res
            end

            # Returns a new instance of accessible_bidding_strategy_maximize_conversion_value, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AccessibleBiddingStrategy::MaximizeConversionValue] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AccessibleBiddingStrategy::MaximizeConversionValue] the created resource
            def self.accessible_bidding_strategy_maximize_conversion_value
              require "google/ads/google_ads/v8/resources/accessible_bidding_strategy_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AccessibleBiddingStrategy::MaximizeConversionValue.new
              yield res if block_given?
              res
            end

            # Returns a new instance of accessible_bidding_strategy_maximize_conversions, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AccessibleBiddingStrategy::MaximizeConversions] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AccessibleBiddingStrategy::MaximizeConversions] the created resource
            def self.accessible_bidding_strategy_maximize_conversions
              require "google/ads/google_ads/v8/resources/accessible_bidding_strategy_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AccessibleBiddingStrategy::MaximizeConversions.new
              yield res if block_given?
              res
            end

            # Returns a new instance of accessible_bidding_strategy_target_roas, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AccessibleBiddingStrategy::TargetRoas] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AccessibleBiddingStrategy::TargetRoas] the created resource
            def self.accessible_bidding_strategy_target_roas
              require "google/ads/google_ads/v8/resources/accessible_bidding_strategy_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AccessibleBiddingStrategy::TargetRoas.new
              yield res if block_given?
              res
            end

            # Returns a new instance of accessible_bidding_strategy_target_cpa, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AccessibleBiddingStrategy::TargetCpa] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AccessibleBiddingStrategy::TargetCpa] the created resource
            def self.accessible_bidding_strategy_target_cpa
              require "google/ads/google_ads/v8/resources/accessible_bidding_strategy_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AccessibleBiddingStrategy::TargetCpa.new
              yield res if block_given?
              res
            end

            # Returns a new instance of accessible_bidding_strategy_target_spend, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AccessibleBiddingStrategy::TargetSpend] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AccessibleBiddingStrategy::TargetSpend] the created resource
            def self.accessible_bidding_strategy_target_spend
              require "google/ads/google_ads/v8/resources/accessible_bidding_strategy_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AccessibleBiddingStrategy::TargetSpend.new
              yield res if block_given?
              res
            end

            # Returns a new instance of accessible_bidding_strategy_target_impression_share, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AccessibleBiddingStrategy::TargetImpressionShare] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AccessibleBiddingStrategy::TargetImpressionShare] the created resource
            def self.accessible_bidding_strategy_target_impression_share
              require "google/ads/google_ads/v8/resources/accessible_bidding_strategy_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AccessibleBiddingStrategy::TargetImpressionShare.new
              yield res if block_given?
              res
            end

            # Returns a new instance of ad_group_ad_label, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AdGroupAdLabel] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AdGroupAdLabel] the created resource
            def self.ad_group_ad_label
              require "google/ads/google_ads/v8/resources/ad_group_ad_label_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AdGroupAdLabel.new
              yield res if block_given?
              res
            end

            # Returns a new instance of offline_user_address_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::OfflineUserAddressInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::OfflineUserAddressInfo] the created resource
            def self.offline_user_address_info
              require "google/ads/google_ads/v8/common/offline_user_data_pb"
              res = Google::Ads::GoogleAds::V8::Common::OfflineUserAddressInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of user_identifier, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::UserIdentifier] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::UserIdentifier] the created resource
            def self.user_identifier
              require "google/ads/google_ads/v8/common/offline_user_data_pb"
              res = Google::Ads::GoogleAds::V8::Common::UserIdentifier.new
              yield res if block_given?
              res
            end

            # Returns a new instance of transaction_attribute, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::TransactionAttribute] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::TransactionAttribute] the created resource
            def self.transaction_attribute
              require "google/ads/google_ads/v8/common/offline_user_data_pb"
              res = Google::Ads::GoogleAds::V8::Common::TransactionAttribute.new
              yield res if block_given?
              res
            end

            # Returns a new instance of store_attribute, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::StoreAttribute] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::StoreAttribute] the created resource
            def self.store_attribute
              require "google/ads/google_ads/v8/common/offline_user_data_pb"
              res = Google::Ads::GoogleAds::V8::Common::StoreAttribute.new
              yield res if block_given?
              res
            end

            # Returns a new instance of item_attribute, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ItemAttribute] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ItemAttribute] the created resource
            def self.item_attribute
              require "google/ads/google_ads/v8/common/offline_user_data_pb"
              res = Google::Ads::GoogleAds::V8::Common::ItemAttribute.new
              yield res if block_given?
              res
            end

            # Returns a new instance of user_data, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::UserData] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::UserData] the created resource
            def self.user_data
              require "google/ads/google_ads/v8/common/offline_user_data_pb"
              res = Google::Ads::GoogleAds::V8::Common::UserData.new
              yield res if block_given?
              res
            end

            # Returns a new instance of user_attribute, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::UserAttribute] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::UserAttribute] the created resource
            def self.user_attribute
              require "google/ads/google_ads/v8/common/offline_user_data_pb"
              res = Google::Ads::GoogleAds::V8::Common::UserAttribute.new
              yield res if block_given?
              res
            end

            # Returns a new instance of customer_match_user_list_metadata, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::CustomerMatchUserListMetadata] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::CustomerMatchUserListMetadata] the created resource
            def self.customer_match_user_list_metadata
              require "google/ads/google_ads/v8/common/offline_user_data_pb"
              res = Google::Ads::GoogleAds::V8::Common::CustomerMatchUserListMetadata.new
              yield res if block_given?
              res
            end

            # Returns a new instance of store_sales_metadata, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::StoreSalesMetadata] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::StoreSalesMetadata] the created resource
            def self.store_sales_metadata
              require "google/ads/google_ads/v8/common/offline_user_data_pb"
              res = Google::Ads::GoogleAds::V8::Common::StoreSalesMetadata.new
              yield res if block_given?
              res
            end

            # Returns a new instance of store_sales_third_party_metadata, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::StoreSalesThirdPartyMetadata] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::StoreSalesThirdPartyMetadata] the created resource
            def self.store_sales_third_party_metadata
              require "google/ads/google_ads/v8/common/offline_user_data_pb"
              res = Google::Ads::GoogleAds::V8::Common::StoreSalesThirdPartyMetadata.new
              yield res if block_given?
              res
            end

            # Returns a new instance of offline_user_data_job, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::OfflineUserDataJob] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::OfflineUserDataJob] the created resource
            def self.offline_user_data_job
              require "google/ads/google_ads/v8/resources/offline_user_data_job_pb"
              res = Google::Ads::GoogleAds::V8::Resources::OfflineUserDataJob.new
              yield res if block_given?
              res
            end

            # Returns a new instance of ad_group_criterion_simulation, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AdGroupCriterionSimulation] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AdGroupCriterionSimulation] the created resource
            def self.ad_group_criterion_simulation
              require "google/ads/google_ads/v8/resources/ad_group_criterion_simulation_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AdGroupCriterionSimulation.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_theme_constant, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::KeywordThemeConstant] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::KeywordThemeConstant] the created resource
            def self.keyword_theme_constant
              require "google/ads/google_ads/v8/resources/keyword_theme_constant_pb"
              res = Google::Ads::GoogleAds::V8::Resources::KeywordThemeConstant.new
              yield res if block_given?
              res
            end

            # Returns a new instance of campaign_draft, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CampaignDraft] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CampaignDraft] the created resource
            def self.campaign_draft
              require "google/ads/google_ads/v8/resources/campaign_draft_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CampaignDraft.new
              yield res if block_given?
              res
            end

            # Returns a new instance of parental_status_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::ParentalStatusView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::ParentalStatusView] the created resource
            def self.parental_status_view
              require "google/ads/google_ads/v8/resources/parental_status_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::ParentalStatusView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of account_link, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AccountLink] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AccountLink] the created resource
            def self.account_link
              require "google/ads/google_ads/v8/resources/account_link_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AccountLink.new
              yield res if block_given?
              res
            end

            # Returns a new instance of third_party_app_analytics_link_identifier, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::ThirdPartyAppAnalyticsLinkIdentifier] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::ThirdPartyAppAnalyticsLinkIdentifier] the created resource
            def self.third_party_app_analytics_link_identifier
              require "google/ads/google_ads/v8/resources/account_link_pb"
              res = Google::Ads::GoogleAds::V8::Resources::ThirdPartyAppAnalyticsLinkIdentifier.new
              yield res if block_given?
              res
            end

            # Returns a new instance of data_partner_link_identifier, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::DataPartnerLinkIdentifier] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::DataPartnerLinkIdentifier] the created resource
            def self.data_partner_link_identifier
              require "google/ads/google_ads/v8/resources/account_link_pb"
              res = Google::Ads::GoogleAds::V8::Resources::DataPartnerLinkIdentifier.new
              yield res if block_given?
              res
            end

            # Returns a new instance of google_ads_link_identifier, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::GoogleAdsLinkIdentifier] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::GoogleAdsLinkIdentifier] the created resource
            def self.google_ads_link_identifier
              require "google/ads/google_ads/v8/resources/account_link_pb"
              res = Google::Ads::GoogleAds::V8::Resources::GoogleAdsLinkIdentifier.new
              yield res if block_given?
              res
            end

            # Returns a new instance of video, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Video] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Video] the created resource
            def self.video
              require "google/ads/google_ads/v8/resources/video_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Video.new
              yield res if block_given?
              res
            end

            # Returns a new instance of media_file, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::MediaFile] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::MediaFile] the created resource
            def self.media_file
              require "google/ads/google_ads/v8/resources/media_file_pb"
              res = Google::Ads::GoogleAds::V8::Resources::MediaFile.new
              yield res if block_given?
              res
            end

            # Returns a new instance of media_image, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::MediaImage] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::MediaImage] the created resource
            def self.media_image
              require "google/ads/google_ads/v8/resources/media_file_pb"
              res = Google::Ads::GoogleAds::V8::Resources::MediaImage.new
              yield res if block_given?
              res
            end

            # Returns a new instance of media_bundle, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::MediaBundle] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::MediaBundle] the created resource
            def self.media_bundle
              require "google/ads/google_ads/v8/resources/media_file_pb"
              res = Google::Ads::GoogleAds::V8::Resources::MediaBundle.new
              yield res if block_given?
              res
            end

            # Returns a new instance of media_audio, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::MediaAudio] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::MediaAudio] the created resource
            def self.media_audio
              require "google/ads/google_ads/v8/resources/media_file_pb"
              res = Google::Ads::GoogleAds::V8::Resources::MediaAudio.new
              yield res if block_given?
              res
            end

            # Returns a new instance of media_video, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::MediaVideo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::MediaVideo] the created resource
            def self.media_video
              require "google/ads/google_ads/v8/resources/media_file_pb"
              res = Google::Ads::GoogleAds::V8::Resources::MediaVideo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of distance_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::DistanceView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::DistanceView] the created resource
            def self.distance_view
              require "google/ads/google_ads/v8/resources/distance_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::DistanceView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of detailed_demographic, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::DetailedDemographic] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::DetailedDemographic] the created resource
            def self.detailed_demographic
              require "google/ads/google_ads/v8/resources/detailed_demographic_pb"
              res = Google::Ads::GoogleAds::V8::Resources::DetailedDemographic.new
              yield res if block_given?
              res
            end

            # Returns a new instance of campaign_experiment, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CampaignExperiment] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CampaignExperiment] the created resource
            def self.campaign_experiment
              require "google/ads/google_ads/v8/resources/campaign_experiment_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CampaignExperiment.new
              yield res if block_given?
              res
            end

            # Returns a new instance of customer_negative_criterion, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CustomerNegativeCriterion] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CustomerNegativeCriterion] the created resource
            def self.customer_negative_criterion
              require "google/ads/google_ads/v8/resources/customer_negative_criterion_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CustomerNegativeCriterion.new
              yield res if block_given?
              res
            end

            # Returns a new instance of bidding_strategy_simulation, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::BiddingStrategySimulation] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::BiddingStrategySimulation] the created resource
            def self.bidding_strategy_simulation
              require "google/ads/google_ads/v8/resources/bidding_strategy_simulation_pb"
              res = Google::Ads::GoogleAds::V8::Resources::BiddingStrategySimulation.new
              yield res if block_given?
              res
            end

            # Returns a new instance of conversion_value_rule_set, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::ConversionValueRuleSet] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::ConversionValueRuleSet] the created resource
            def self.conversion_value_rule_set
              require "google/ads/google_ads/v8/resources/conversion_value_rule_set_pb"
              res = Google::Ads::GoogleAds::V8::Resources::ConversionValueRuleSet.new
              yield res if block_given?
              res
            end

            # Returns a new instance of dynamic_location_set_filter, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::DynamicLocationSetFilter] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::DynamicLocationSetFilter] the created resource
            def self.dynamic_location_set_filter
              require "google/ads/google_ads/v8/common/feed_item_set_filter_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::DynamicLocationSetFilter.new
              yield res if block_given?
              res
            end

            # Returns a new instance of business_name_filter, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::BusinessNameFilter] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::BusinessNameFilter] the created resource
            def self.business_name_filter
              require "google/ads/google_ads/v8/common/feed_item_set_filter_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::BusinessNameFilter.new
              yield res if block_given?
              res
            end

            # Returns a new instance of dynamic_affiliate_location_set_filter, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::DynamicAffiliateLocationSetFilter] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::DynamicAffiliateLocationSetFilter] the created resource
            def self.dynamic_affiliate_location_set_filter
              require "google/ads/google_ads/v8/common/feed_item_set_filter_type_infos_pb"
              res = Google::Ads::GoogleAds::V8::Common::DynamicAffiliateLocationSetFilter.new
              yield res if block_given?
              res
            end

            # Returns a new instance of feed_item_set, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::FeedItemSet] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::FeedItemSet] the created resource
            def self.feed_item_set
              require "google/ads/google_ads/v8/resources/feed_item_set_pb"
              res = Google::Ads::GoogleAds::V8::Resources::FeedItemSet.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_plan_ad_group, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::KeywordPlanAdGroup] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::KeywordPlanAdGroup] the created resource
            def self.keyword_plan_ad_group
              require "google/ads/google_ads/v8/resources/keyword_plan_ad_group_pb"
              res = Google::Ads::GoogleAds::V8::Resources::KeywordPlanAdGroup.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_plan_campaign, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::KeywordPlanCampaign] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::KeywordPlanCampaign] the created resource
            def self.keyword_plan_campaign
              require "google/ads/google_ads/v8/resources/keyword_plan_campaign_pb"
              res = Google::Ads::GoogleAds::V8::Resources::KeywordPlanCampaign.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_plan_geo_target, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::KeywordPlanGeoTarget] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::KeywordPlanGeoTarget] the created resource
            def self.keyword_plan_geo_target
              require "google/ads/google_ads/v8/resources/keyword_plan_campaign_pb"
              res = Google::Ads::GoogleAds::V8::Resources::KeywordPlanGeoTarget.new
              yield res if block_given?
              res
            end

            # Returns a new instance of user_interest, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::UserInterest] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::UserInterest] the created resource
            def self.user_interest
              require "google/ads/google_ads/v8/resources/user_interest_pb"
              res = Google::Ads::GoogleAds::V8::Resources::UserInterest.new
              yield res if block_given?
              res
            end

            # Returns a new instance of customer_client_link, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CustomerClientLink] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CustomerClientLink] the created resource
            def self.customer_client_link
              require "google/ads/google_ads/v8/resources/customer_client_link_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CustomerClientLink.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::KeywordView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::KeywordView] the created resource
            def self.keyword_view
              require "google/ads/google_ads/v8/resources/keyword_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::KeywordView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of geographic_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::GeographicView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::GeographicView] the created resource
            def self.geographic_view
              require "google/ads/google_ads/v8/resources/geographic_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::GeographicView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of feed_placeholder_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::FeedPlaceholderView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::FeedPlaceholderView] the created resource
            def self.feed_placeholder_view
              require "google/ads/google_ads/v8/resources/feed_placeholder_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::FeedPlaceholderView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of customer_label, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CustomerLabel] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CustomerLabel] the created resource
            def self.customer_label
              require "google/ads/google_ads/v8/resources/customer_label_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CustomerLabel.new
              yield res if block_given?
              res
            end

            # Returns a new instance of paid_organic_search_term_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::PaidOrganicSearchTermView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::PaidOrganicSearchTermView] the created resource
            def self.paid_organic_search_term_view
              require "google/ads/google_ads/v8/resources/paid_organic_search_term_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::PaidOrganicSearchTermView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of gender_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::GenderView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::GenderView] the created resource
            def self.gender_view
              require "google/ads/google_ads/v8/resources/gender_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::GenderView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of campaign_criterion_simulation, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CampaignCriterionSimulation] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CampaignCriterionSimulation] the created resource
            def self.campaign_criterion_simulation
              require "google/ads/google_ads/v8/resources/campaign_criterion_simulation_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CampaignCriterionSimulation.new
              yield res if block_given?
              res
            end

            # Returns a new instance of recommendation, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Recommendation] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Recommendation] the created resource
            def self.recommendation
              require "google/ads/google_ads/v8/resources/recommendation_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Recommendation.new
              yield res if block_given?
              res
            end

            # Returns a new instance of recommendation_impact, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Recommendation::RecommendationImpact] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Recommendation::RecommendationImpact] the created resource
            def self.recommendation_impact
              require "google/ads/google_ads/v8/resources/recommendation_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Recommendation::RecommendationImpact.new
              yield res if block_given?
              res
            end

            # Returns a new instance of recommendation_metrics, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Recommendation::RecommendationMetrics] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Recommendation::RecommendationMetrics] the created resource
            def self.recommendation_metrics
              require "google/ads/google_ads/v8/resources/recommendation_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Recommendation::RecommendationMetrics.new
              yield res if block_given?
              res
            end

            # Returns a new instance of campaign_budget_recommendation, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Recommendation::CampaignBudgetRecommendation] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Recommendation::CampaignBudgetRecommendation] the created resource
            def self.campaign_budget_recommendation
              require "google/ads/google_ads/v8/resources/recommendation_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Recommendation::CampaignBudgetRecommendation.new
              yield res if block_given?
              res
            end

            # Returns a new instance of campaign_budget_recommendation_option, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Recommendation::CampaignBudgetRecommendation::CampaignBudgetRecommendationOption] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Recommendation::CampaignBudgetRecommendation::CampaignBudgetRecommendationOption] the created resource
            def self.campaign_budget_recommendation_option
              require "google/ads/google_ads/v8/resources/recommendation_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Recommendation::CampaignBudgetRecommendation::CampaignBudgetRecommendationOption.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_recommendation, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Recommendation::KeywordRecommendation] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Recommendation::KeywordRecommendation] the created resource
            def self.keyword_recommendation
              require "google/ads/google_ads/v8/resources/recommendation_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Recommendation::KeywordRecommendation.new
              yield res if block_given?
              res
            end

            # Returns a new instance of move_unused_budget_recommendation, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Recommendation::MoveUnusedBudgetRecommendation] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Recommendation::MoveUnusedBudgetRecommendation] the created resource
            def self.move_unused_budget_recommendation
              require "google/ads/google_ads/v8/resources/recommendation_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Recommendation::MoveUnusedBudgetRecommendation.new
              yield res if block_given?
              res
            end

            # Returns a new instance of text_ad_recommendation, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Recommendation::TextAdRecommendation] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Recommendation::TextAdRecommendation] the created resource
            def self.text_ad_recommendation
              require "google/ads/google_ads/v8/resources/recommendation_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Recommendation::TextAdRecommendation.new
              yield res if block_given?
              res
            end

            # Returns a new instance of target_cpa_opt_in_recommendation, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Recommendation::TargetCpaOptInRecommendation] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Recommendation::TargetCpaOptInRecommendation] the created resource
            def self.target_cpa_opt_in_recommendation
              require "google/ads/google_ads/v8/resources/recommendation_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Recommendation::TargetCpaOptInRecommendation.new
              yield res if block_given?
              res
            end

            # Returns a new instance of target_cpa_opt_in_recommendation_option, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Recommendation::TargetCpaOptInRecommendation::TargetCpaOptInRecommendationOption] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Recommendation::TargetCpaOptInRecommendation::TargetCpaOptInRecommendationOption] the created resource
            def self.target_cpa_opt_in_recommendation_option
              require "google/ads/google_ads/v8/resources/recommendation_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Recommendation::TargetCpaOptInRecommendation::TargetCpaOptInRecommendationOption.new
              yield res if block_given?
              res
            end

            # Returns a new instance of maximize_conversions_opt_in_recommendation, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Recommendation::MaximizeConversionsOptInRecommendation] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Recommendation::MaximizeConversionsOptInRecommendation] the created resource
            def self.maximize_conversions_opt_in_recommendation
              require "google/ads/google_ads/v8/resources/recommendation_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Recommendation::MaximizeConversionsOptInRecommendation.new
              yield res if block_given?
              res
            end

            # Returns a new instance of enhanced_cpc_opt_in_recommendation, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Recommendation::EnhancedCpcOptInRecommendation] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Recommendation::EnhancedCpcOptInRecommendation] the created resource
            def self.enhanced_cpc_opt_in_recommendation
              require "google/ads/google_ads/v8/resources/recommendation_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Recommendation::EnhancedCpcOptInRecommendation.new
              yield res if block_given?
              res
            end

            # Returns a new instance of search_partners_opt_in_recommendation, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Recommendation::SearchPartnersOptInRecommendation] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Recommendation::SearchPartnersOptInRecommendation] the created resource
            def self.search_partners_opt_in_recommendation
              require "google/ads/google_ads/v8/resources/recommendation_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Recommendation::SearchPartnersOptInRecommendation.new
              yield res if block_given?
              res
            end

            # Returns a new instance of optimize_ad_rotation_recommendation, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Recommendation::OptimizeAdRotationRecommendation] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Recommendation::OptimizeAdRotationRecommendation] the created resource
            def self.optimize_ad_rotation_recommendation
              require "google/ads/google_ads/v8/resources/recommendation_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Recommendation::OptimizeAdRotationRecommendation.new
              yield res if block_given?
              res
            end

            # Returns a new instance of callout_extension_recommendation, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Recommendation::CalloutExtensionRecommendation] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Recommendation::CalloutExtensionRecommendation] the created resource
            def self.callout_extension_recommendation
              require "google/ads/google_ads/v8/resources/recommendation_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Recommendation::CalloutExtensionRecommendation.new
              yield res if block_given?
              res
            end

            # Returns a new instance of maximize_clicks_opt_in_recommendation, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Recommendation::MaximizeClicksOptInRecommendation] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Recommendation::MaximizeClicksOptInRecommendation] the created resource
            def self.maximize_clicks_opt_in_recommendation
              require "google/ads/google_ads/v8/resources/recommendation_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Recommendation::MaximizeClicksOptInRecommendation.new
              yield res if block_given?
              res
            end

            # Returns a new instance of sitelink_extension_recommendation, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Recommendation::SitelinkExtensionRecommendation] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Recommendation::SitelinkExtensionRecommendation] the created resource
            def self.sitelink_extension_recommendation
              require "google/ads/google_ads/v8/resources/recommendation_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Recommendation::SitelinkExtensionRecommendation.new
              yield res if block_given?
              res
            end

            # Returns a new instance of call_extension_recommendation, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Recommendation::CallExtensionRecommendation] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Recommendation::CallExtensionRecommendation] the created resource
            def self.call_extension_recommendation
              require "google/ads/google_ads/v8/resources/recommendation_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Recommendation::CallExtensionRecommendation.new
              yield res if block_given?
              res
            end

            # Returns a new instance of target_roas_opt_in_recommendation, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Recommendation::TargetRoasOptInRecommendation] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Recommendation::TargetRoasOptInRecommendation] the created resource
            def self.target_roas_opt_in_recommendation
              require "google/ads/google_ads/v8/resources/recommendation_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Recommendation::TargetRoasOptInRecommendation.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_match_type_recommendation, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Recommendation::KeywordMatchTypeRecommendation] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Recommendation::KeywordMatchTypeRecommendation] the created resource
            def self.keyword_match_type_recommendation
              require "google/ads/google_ads/v8/resources/recommendation_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Recommendation::KeywordMatchTypeRecommendation.new
              yield res if block_given?
              res
            end

            # Returns a new instance of responsive_search_ad_recommendation, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Recommendation::ResponsiveSearchAdRecommendation] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Recommendation::ResponsiveSearchAdRecommendation] the created resource
            def self.responsive_search_ad_recommendation
              require "google/ads/google_ads/v8/resources/recommendation_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Recommendation::ResponsiveSearchAdRecommendation.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_plan_ad_group_keyword, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::KeywordPlanAdGroupKeyword] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::KeywordPlanAdGroupKeyword] the created resource
            def self.keyword_plan_ad_group_keyword
              require "google/ads/google_ads/v8/resources/keyword_plan_ad_group_keyword_pb"
              res = Google::Ads::GoogleAds::V8::Resources::KeywordPlanAdGroupKeyword.new
              yield res if block_given?
              res
            end

            # Returns a new instance of shared_set, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::SharedSet] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::SharedSet] the created resource
            def self.shared_set
              require "google/ads/google_ads/v8/resources/shared_set_pb"
              res = Google::Ads::GoogleAds::V8::Resources::SharedSet.new
              yield res if block_given?
              res
            end

            # Returns a new instance of feed_item_set_link, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::FeedItemSetLink] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::FeedItemSetLink] the created resource
            def self.feed_item_set_link
              require "google/ads/google_ads/v8/resources/feed_item_set_link_pb"
              res = Google::Ads::GoogleAds::V8::Resources::FeedItemSetLink.new
              yield res if block_given?
              res
            end

            # Returns a new instance of shopping_performance_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::ShoppingPerformanceView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::ShoppingPerformanceView] the created resource
            def self.shopping_performance_view
              require "google/ads/google_ads/v8/resources/shopping_performance_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::ShoppingPerformanceView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of tag_snippet, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::TagSnippet] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::TagSnippet] the created resource
            def self.tag_snippet
              require "google/ads/google_ads/v8/common/tag_snippet_pb"
              res = Google::Ads::GoogleAds::V8::Common::TagSnippet.new
              yield res if block_given?
              res
            end

            # Returns a new instance of remarketing_action, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::RemarketingAction] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::RemarketingAction] the created resource
            def self.remarketing_action
              require "google/ads/google_ads/v8/resources/remarketing_action_pb"
              res = Google::Ads::GoogleAds::V8::Resources::RemarketingAction.new
              yield res if block_given?
              res
            end

            # Returns a new instance of text_label, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::TextLabel] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::TextLabel] the created resource
            def self.text_label
              require "google/ads/google_ads/v8/common/text_label_pb"
              res = Google::Ads::GoogleAds::V8::Common::TextLabel.new
              yield res if block_given?
              res
            end

            # Returns a new instance of label, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::Label] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::Label] the created resource
            def self.label
              require "google/ads/google_ads/v8/resources/label_pb"
              res = Google::Ads::GoogleAds::V8::Resources::Label.new
              yield res if block_given?
              res
            end

            # Returns a new instance of hotel_group_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::HotelGroupView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::HotelGroupView] the created resource
            def self.hotel_group_view
              require "google/ads/google_ads/v8/resources/hotel_group_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::HotelGroupView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of group_placement_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::GroupPlacementView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::GroupPlacementView] the created resource
            def self.group_placement_view
              require "google/ads/google_ads/v8/resources/group_placement_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::GroupPlacementView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of topic_constant, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::TopicConstant] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::TopicConstant] the created resource
            def self.topic_constant
              require "google/ads/google_ads/v8/resources/topic_constant_pb"
              res = Google::Ads::GoogleAds::V8::Resources::TopicConstant.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_plan_campaign_keyword, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::KeywordPlanCampaignKeyword] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::KeywordPlanCampaignKeyword] the created resource
            def self.keyword_plan_campaign_keyword
              require "google/ads/google_ads/v8/resources/keyword_plan_campaign_keyword_pb"
              res = Google::Ads::GoogleAds::V8::Resources::KeywordPlanCampaignKeyword.new
              yield res if block_given?
              res
            end

            # Returns a new instance of third_party_app_analytics_link, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::ThirdPartyAppAnalyticsLink] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::ThirdPartyAppAnalyticsLink] the created resource
            def self.third_party_app_analytics_link
              require "google/ads/google_ads/v8/resources/third_party_app_analytics_link_pb"
              res = Google::Ads::GoogleAds::V8::Resources::ThirdPartyAppAnalyticsLink.new
              yield res if block_given?
              res
            end

            # Returns a new instance of location_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::LocationView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::LocationView] the created resource
            def self.location_view
              require "google/ads/google_ads/v8/resources/location_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::LocationView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of language_constant, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::LanguageConstant] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::LanguageConstant] the created resource
            def self.language_constant
              require "google/ads/google_ads/v8/resources/language_constant_pb"
              res = Google::Ads::GoogleAds::V8::Resources::LanguageConstant.new
              yield res if block_given?
              res
            end

            # Returns a new instance of combined_audience, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CombinedAudience] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CombinedAudience] the created resource
            def self.combined_audience
              require "google/ads/google_ads/v8/resources/combined_audience_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CombinedAudience.new
              yield res if block_given?
              res
            end

            # Returns a new instance of conversion_custom_variable, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::ConversionCustomVariable] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::ConversionCustomVariable] the created resource
            def self.conversion_custom_variable
              require "google/ads/google_ads/v8/resources/conversion_custom_variable_pb"
              res = Google::Ads::GoogleAds::V8::Resources::ConversionCustomVariable.new
              yield res if block_given?
              res
            end

            # Returns a new instance of batch_job, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::BatchJob] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::BatchJob] the created resource
            def self.batch_job
              require "google/ads/google_ads/v8/resources/batch_job_pb"
              res = Google::Ads::GoogleAds::V8::Resources::BatchJob.new
              yield res if block_given?
              res
            end

            # Returns a new instance of batch_job_metadata, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::BatchJob::BatchJobMetadata] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::BatchJob::BatchJobMetadata] the created resource
            def self.batch_job_metadata
              require "google/ads/google_ads/v8/resources/batch_job_pb"
              res = Google::Ads::GoogleAds::V8::Resources::BatchJob::BatchJobMetadata.new
              yield res if block_given?
              res
            end

            # Returns a new instance of dynamic_search_ads_search_term_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::DynamicSearchAdsSearchTermView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::DynamicSearchAdsSearchTermView] the created resource
            def self.dynamic_search_ads_search_term_view
              require "google/ads/google_ads/v8/resources/dynamic_search_ads_search_term_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::DynamicSearchAdsSearchTermView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of custom_interest, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CustomInterest] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CustomInterest] the created resource
            def self.custom_interest
              require "google/ads/google_ads/v8/resources/custom_interest_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CustomInterest.new
              yield res if block_given?
              res
            end

            # Returns a new instance of custom_interest_member, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CustomInterestMember] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CustomInterestMember] the created resource
            def self.custom_interest_member
              require "google/ads/google_ads/v8/resources/custom_interest_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CustomInterestMember.new
              yield res if block_given?
              res
            end

            # Returns a new instance of expanded_landing_page_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::ExpandedLandingPageView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::ExpandedLandingPageView] the created resource
            def self.expanded_landing_page_view
              require "google/ads/google_ads/v8/resources/expanded_landing_page_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::ExpandedLandingPageView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of change_status, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::ChangeStatus] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::ChangeStatus] the created resource
            def self.change_status
              require "google/ads/google_ads/v8/resources/change_status_pb"
              res = Google::Ads::GoogleAds::V8::Resources::ChangeStatus.new
              yield res if block_given?
              res
            end

            # Returns a new instance of search_term_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::SearchTermView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::SearchTermView] the created resource
            def self.search_term_view
              require "google/ads/google_ads/v8/resources/search_term_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::SearchTermView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of customer_user_access_invitation, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CustomerUserAccessInvitation] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CustomerUserAccessInvitation] the created resource
            def self.customer_user_access_invitation
              require "google/ads/google_ads/v8/resources/customer_user_access_invitation_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CustomerUserAccessInvitation.new
              yield res if block_given?
              res
            end

            # Returns a new instance of user_location_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::UserLocationView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::UserLocationView] the created resource
            def self.user_location_view
              require "google/ads/google_ads/v8/resources/user_location_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::UserLocationView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of google_ads_field, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::GoogleAdsField] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::GoogleAdsField] the created resource
            def self.google_ads_field
              require "google/ads/google_ads/v8/resources/google_ads_field_pb"
              res = Google::Ads::GoogleAds::V8::Resources::GoogleAdsField.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mobile_app_category_constant, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::MobileAppCategoryConstant] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::MobileAppCategoryConstant] the created resource
            def self.mobile_app_category_constant
              require "google/ads/google_ads/v8/resources/mobile_app_category_constant_pb"
              res = Google::Ads::GoogleAds::V8::Resources::MobileAppCategoryConstant.new
              yield res if block_given?
              res
            end

            # Returns a new instance of ad_group_criterion_label, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AdGroupCriterionLabel] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AdGroupCriterionLabel] the created resource
            def self.ad_group_criterion_label
              require "google/ads/google_ads/v8/resources/ad_group_criterion_label_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AdGroupCriterionLabel.new
              yield res if block_given?
              res
            end

            # Returns a new instance of smart_campaign_search_term_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::SmartCampaignSearchTermView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::SmartCampaignSearchTermView] the created resource
            def self.smart_campaign_search_term_view
              require "google/ads/google_ads/v8/resources/smart_campaign_search_term_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::SmartCampaignSearchTermView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of campaign_simulation, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CampaignSimulation] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CampaignSimulation] the created resource
            def self.campaign_simulation
              require "google/ads/google_ads/v8/resources/campaign_simulation_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CampaignSimulation.new
              yield res if block_given?
              res
            end

            # Returns a new instance of landing_page_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::LandingPageView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::LandingPageView] the created resource
            def self.landing_page_view
              require "google/ads/google_ads/v8/resources/landing_page_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::LandingPageView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of account_budget, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AccountBudget] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AccountBudget] the created resource
            def self.account_budget
              require "google/ads/google_ads/v8/resources/account_budget_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AccountBudget.new
              yield res if block_given?
              res
            end

            # Returns a new instance of pending_account_budget_proposal, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AccountBudget::PendingAccountBudgetProposal] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AccountBudget::PendingAccountBudgetProposal] the created resource
            def self.pending_account_budget_proposal
              require "google/ads/google_ads/v8/resources/account_budget_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AccountBudget::PendingAccountBudgetProposal.new
              yield res if block_given?
              res
            end

            # Returns a new instance of customer_user_access, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::CustomerUserAccess] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::CustomerUserAccess] the created resource
            def self.customer_user_access
              require "google/ads/google_ads/v8/resources/customer_user_access_pb"
              res = Google::Ads::GoogleAds::V8::Resources::CustomerUserAccess.new
              yield res if block_given?
              res
            end

            # Returns a new instance of asset_field_type_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AssetFieldTypeView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AssetFieldTypeView] the created resource
            def self.asset_field_type_view
              require "google/ads/google_ads/v8/resources/asset_field_type_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AssetFieldTypeView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of ad_schedule_view, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AdScheduleView] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AdScheduleView] the created resource
            def self.ad_schedule_view
              require "google/ads/google_ads/v8/resources/ad_schedule_view_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AdScheduleView.new
              yield res if block_given?
              res
            end

            # Returns a new instance of operating_system_version_constant, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::OperatingSystemVersionConstant] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::OperatingSystemVersionConstant] the created resource
            def self.operating_system_version_constant
              require "google/ads/google_ads/v8/resources/operating_system_version_constant_pb"
              res = Google::Ads::GoogleAds::V8::Resources::OperatingSystemVersionConstant.new
              yield res if block_given?
              res
            end

            # Returns a new instance of conversion_action, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::ConversionAction] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::ConversionAction] the created resource
            def self.conversion_action
              require "google/ads/google_ads/v8/resources/conversion_action_pb"
              res = Google::Ads::GoogleAds::V8::Resources::ConversionAction.new
              yield res if block_given?
              res
            end

            # Returns a new instance of attribution_model_settings, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::ConversionAction::AttributionModelSettings] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::ConversionAction::AttributionModelSettings] the created resource
            def self.attribution_model_settings
              require "google/ads/google_ads/v8/resources/conversion_action_pb"
              res = Google::Ads::GoogleAds::V8::Resources::ConversionAction::AttributionModelSettings.new
              yield res if block_given?
              res
            end

            # Returns a new instance of value_settings, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::ConversionAction::ValueSettings] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::ConversionAction::ValueSettings] the created resource
            def self.value_settings
              require "google/ads/google_ads/v8/resources/conversion_action_pb"
              res = Google::Ads::GoogleAds::V8::Resources::ConversionAction::ValueSettings.new
              yield res if block_given?
              res
            end

            # Returns a new instance of third_party_app_analytics_settings, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::ConversionAction::ThirdPartyAppAnalyticsSettings] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::ConversionAction::ThirdPartyAppAnalyticsSettings] the created resource
            def self.third_party_app_analytics_settings
              require "google/ads/google_ads/v8/resources/conversion_action_pb"
              res = Google::Ads::GoogleAds::V8::Resources::ConversionAction::ThirdPartyAppAnalyticsSettings.new
              yield res if block_given?
              res
            end

            # Returns a new instance of firebase_settings, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::ConversionAction::FirebaseSettings] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::ConversionAction::FirebaseSettings] the created resource
            def self.firebase_settings
              require "google/ads/google_ads/v8/resources/conversion_action_pb"
              res = Google::Ads::GoogleAds::V8::Resources::ConversionAction::FirebaseSettings.new
              yield res if block_given?
              res
            end

            # Returns a new instance of account_budget_proposal, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::AccountBudgetProposal] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::AccountBudgetProposal] the created resource
            def self.account_budget_proposal
              require "google/ads/google_ads/v8/resources/account_budget_proposal_pb"
              res = Google::Ads::GoogleAds::V8::Resources::AccountBudgetProposal.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_plan, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::KeywordPlan] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::KeywordPlan] the created resource
            def self.keyword_plan
              require "google/ads/google_ads/v8/resources/keyword_plan_pb"
              res = Google::Ads::GoogleAds::V8::Resources::KeywordPlan.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_plan_forecast_period, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Resources::KeywordPlanForecastPeriod] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Resources::KeywordPlanForecastPeriod] the created resource
            def self.keyword_plan_forecast_period
              require "google/ads/google_ads/v8/resources/keyword_plan_pb"
              res = Google::Ads::GoogleAds::V8::Resources::KeywordPlanForecastPeriod.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_bidding_data_exclusions_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateBiddingDataExclusionsResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateBiddingDataExclusionsResult] the created resource
            def self.mutate_bidding_data_exclusions_result
              require "google/ads/google_ads/v8/services/bidding_data_exclusion_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateBiddingDataExclusionsResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_campaign_criterion_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateCampaignCriterionResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateCampaignCriterionResult] the created resource
            def self.mutate_campaign_criterion_result
              require "google/ads/google_ads/v8/services/campaign_criterion_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateCampaignCriterionResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of metrics, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::Metrics] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::Metrics] the created resource
            def self.metrics
              require "google/ads/google_ads/v8/common/metrics_pb"
              res = Google::Ads::GoogleAds::V8::Common::Metrics.new
              yield res if block_given?
              res
            end

            # Returns a new instance of segments, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::Segments] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::Segments] the created resource
            def self.segments
              require "google/ads/google_ads/v8/common/segments_pb"
              res = Google::Ads::GoogleAds::V8::Common::Segments.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::Keyword] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::Keyword] the created resource
            def self.keyword
              require "google/ads/google_ads/v8/common/segments_pb"
              res = Google::Ads::GoogleAds::V8::Common::Keyword.new
              yield res if block_given?
              res
            end

            # Returns a new instance of budget_campaign_association_status, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::BudgetCampaignAssociationStatus] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::BudgetCampaignAssociationStatus] the created resource
            def self.budget_campaign_association_status
              require "google/ads/google_ads/v8/common/segments_pb"
              res = Google::Ads::GoogleAds::V8::Common::BudgetCampaignAssociationStatus.new
              yield res if block_given?
              res
            end

            # Returns a new instance of asset_interaction_target, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::AssetInteractionTarget] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::AssetInteractionTarget] the created resource
            def self.asset_interaction_target
              require "google/ads/google_ads/v8/common/segments_pb"
              res = Google::Ads::GoogleAds::V8::Common::AssetInteractionTarget.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_ad_group_ad_label_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateAdGroupAdLabelResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateAdGroupAdLabelResult] the created resource
            def self.mutate_ad_group_ad_label_result
              require "google/ads/google_ads/v8/services/ad_group_ad_label_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateAdGroupAdLabelResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_ad_group_ad_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateAdGroupAdResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateAdGroupAdResult] the created resource
            def self.mutate_ad_group_ad_result
              require "google/ads/google_ads/v8/services/ad_group_ad_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateAdGroupAdResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_ad_group_asset_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateAdGroupAssetResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateAdGroupAssetResult] the created resource
            def self.mutate_ad_group_asset_result
              require "google/ads/google_ads/v8/services/ad_group_asset_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateAdGroupAssetResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_ad_group_bid_modifier_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateAdGroupBidModifierResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateAdGroupBidModifierResult] the created resource
            def self.mutate_ad_group_bid_modifier_result
              require "google/ads/google_ads/v8/services/ad_group_bid_modifier_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateAdGroupBidModifierResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_ad_group_criterion_label_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateAdGroupCriterionLabelResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateAdGroupCriterionLabelResult] the created resource
            def self.mutate_ad_group_criterion_label_result
              require "google/ads/google_ads/v8/services/ad_group_criterion_label_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateAdGroupCriterionLabelResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_ad_group_criterion_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateAdGroupCriterionResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateAdGroupCriterionResult] the created resource
            def self.mutate_ad_group_criterion_result
              require "google/ads/google_ads/v8/services/ad_group_criterion_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateAdGroupCriterionResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_ad_group_extension_setting_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateAdGroupExtensionSettingResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateAdGroupExtensionSettingResult] the created resource
            def self.mutate_ad_group_extension_setting_result
              require "google/ads/google_ads/v8/services/ad_group_extension_setting_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateAdGroupExtensionSettingResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_ad_group_feed_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateAdGroupFeedResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateAdGroupFeedResult] the created resource
            def self.mutate_ad_group_feed_result
              require "google/ads/google_ads/v8/services/ad_group_feed_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateAdGroupFeedResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_ad_group_label_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateAdGroupLabelResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateAdGroupLabelResult] the created resource
            def self.mutate_ad_group_label_result
              require "google/ads/google_ads/v8/services/ad_group_label_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateAdGroupLabelResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_ad_group_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateAdGroupResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateAdGroupResult] the created resource
            def self.mutate_ad_group_result
              require "google/ads/google_ads/v8/services/ad_group_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateAdGroupResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_ad_parameter_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateAdParameterResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateAdParameterResult] the created resource
            def self.mutate_ad_parameter_result
              require "google/ads/google_ads/v8/services/ad_parameter_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateAdParameterResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_ad_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateAdResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateAdResult] the created resource
            def self.mutate_ad_result
              require "google/ads/google_ads/v8/services/ad_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateAdResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_asset_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateAssetResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateAssetResult] the created resource
            def self.mutate_asset_result
              require "google/ads/google_ads/v8/services/asset_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateAssetResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_bidding_seasonality_adjustments_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateBiddingSeasonalityAdjustmentsResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateBiddingSeasonalityAdjustmentsResult] the created resource
            def self.mutate_bidding_seasonality_adjustments_result
              require "google/ads/google_ads/v8/services/bidding_seasonality_adjustment_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateBiddingSeasonalityAdjustmentsResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_bidding_strategy_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateBiddingStrategyResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateBiddingStrategyResult] the created resource
            def self.mutate_bidding_strategy_result
              require "google/ads/google_ads/v8/services/bidding_strategy_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateBiddingStrategyResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_campaign_asset_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateCampaignAssetResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateCampaignAssetResult] the created resource
            def self.mutate_campaign_asset_result
              require "google/ads/google_ads/v8/services/campaign_asset_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateCampaignAssetResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_campaign_bid_modifier_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateCampaignBidModifierResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateCampaignBidModifierResult] the created resource
            def self.mutate_campaign_bid_modifier_result
              require "google/ads/google_ads/v8/services/campaign_bid_modifier_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateCampaignBidModifierResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_campaign_budget_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateCampaignBudgetResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateCampaignBudgetResult] the created resource
            def self.mutate_campaign_budget_result
              require "google/ads/google_ads/v8/services/campaign_budget_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateCampaignBudgetResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_campaign_draft_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateCampaignDraftResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateCampaignDraftResult] the created resource
            def self.mutate_campaign_draft_result
              require "google/ads/google_ads/v8/services/campaign_draft_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateCampaignDraftResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_campaign_experiment_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateCampaignExperimentResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateCampaignExperimentResult] the created resource
            def self.mutate_campaign_experiment_result
              require "google/ads/google_ads/v8/services/campaign_experiment_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateCampaignExperimentResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of create_campaign_experiment_metadata, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::CreateCampaignExperimentMetadata] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::CreateCampaignExperimentMetadata] the created resource
            def self.create_campaign_experiment_metadata
              require "google/ads/google_ads/v8/services/campaign_experiment_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::CreateCampaignExperimentMetadata.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_campaign_extension_setting_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateCampaignExtensionSettingResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateCampaignExtensionSettingResult] the created resource
            def self.mutate_campaign_extension_setting_result
              require "google/ads/google_ads/v8/services/campaign_extension_setting_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateCampaignExtensionSettingResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_campaign_feed_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateCampaignFeedResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateCampaignFeedResult] the created resource
            def self.mutate_campaign_feed_result
              require "google/ads/google_ads/v8/services/campaign_feed_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateCampaignFeedResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_campaign_label_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateCampaignLabelResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateCampaignLabelResult] the created resource
            def self.mutate_campaign_label_result
              require "google/ads/google_ads/v8/services/campaign_label_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateCampaignLabelResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_campaign_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateCampaignResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateCampaignResult] the created resource
            def self.mutate_campaign_result
              require "google/ads/google_ads/v8/services/campaign_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateCampaignResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_campaign_shared_set_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateCampaignSharedSetResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateCampaignSharedSetResult] the created resource
            def self.mutate_campaign_shared_set_result
              require "google/ads/google_ads/v8/services/campaign_shared_set_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateCampaignSharedSetResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_conversion_action_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateConversionActionResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateConversionActionResult] the created resource
            def self.mutate_conversion_action_result
              require "google/ads/google_ads/v8/services/conversion_action_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateConversionActionResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_conversion_custom_variable_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateConversionCustomVariableResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateConversionCustomVariableResult] the created resource
            def self.mutate_conversion_custom_variable_result
              require "google/ads/google_ads/v8/services/conversion_custom_variable_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateConversionCustomVariableResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_conversion_value_rule_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateConversionValueRuleResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateConversionValueRuleResult] the created resource
            def self.mutate_conversion_value_rule_result
              require "google/ads/google_ads/v8/services/conversion_value_rule_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateConversionValueRuleResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_conversion_value_rule_set_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateConversionValueRuleSetResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateConversionValueRuleSetResult] the created resource
            def self.mutate_conversion_value_rule_set_result
              require "google/ads/google_ads/v8/services/conversion_value_rule_set_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateConversionValueRuleSetResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_customer_asset_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateCustomerAssetResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateCustomerAssetResult] the created resource
            def self.mutate_customer_asset_result
              require "google/ads/google_ads/v8/services/customer_asset_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateCustomerAssetResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_customer_extension_setting_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateCustomerExtensionSettingResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateCustomerExtensionSettingResult] the created resource
            def self.mutate_customer_extension_setting_result
              require "google/ads/google_ads/v8/services/customer_extension_setting_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateCustomerExtensionSettingResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_customer_feed_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateCustomerFeedResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateCustomerFeedResult] the created resource
            def self.mutate_customer_feed_result
              require "google/ads/google_ads/v8/services/customer_feed_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateCustomerFeedResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_customer_label_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateCustomerLabelResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateCustomerLabelResult] the created resource
            def self.mutate_customer_label_result
              require "google/ads/google_ads/v8/services/customer_label_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateCustomerLabelResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_customer_negative_criteria_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateCustomerNegativeCriteriaResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateCustomerNegativeCriteriaResult] the created resource
            def self.mutate_customer_negative_criteria_result
              require "google/ads/google_ads/v8/services/customer_negative_criterion_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateCustomerNegativeCriteriaResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_customer_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateCustomerResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateCustomerResult] the created resource
            def self.mutate_customer_result
              require "google/ads/google_ads/v8/services/customer_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateCustomerResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_extension_feed_item_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateExtensionFeedItemResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateExtensionFeedItemResult] the created resource
            def self.mutate_extension_feed_item_result
              require "google/ads/google_ads/v8/services/extension_feed_item_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateExtensionFeedItemResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_feed_item_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateFeedItemResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateFeedItemResult] the created resource
            def self.mutate_feed_item_result
              require "google/ads/google_ads/v8/services/feed_item_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateFeedItemResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_feed_item_set_link_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateFeedItemSetLinkResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateFeedItemSetLinkResult] the created resource
            def self.mutate_feed_item_set_link_result
              require "google/ads/google_ads/v8/services/feed_item_set_link_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateFeedItemSetLinkResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_feed_item_set_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateFeedItemSetResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateFeedItemSetResult] the created resource
            def self.mutate_feed_item_set_result
              require "google/ads/google_ads/v8/services/feed_item_set_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateFeedItemSetResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_feed_item_target_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateFeedItemTargetResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateFeedItemTargetResult] the created resource
            def self.mutate_feed_item_target_result
              require "google/ads/google_ads/v8/services/feed_item_target_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateFeedItemTargetResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_feed_mapping_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateFeedMappingResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateFeedMappingResult] the created resource
            def self.mutate_feed_mapping_result
              require "google/ads/google_ads/v8/services/feed_mapping_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateFeedMappingResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_feed_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateFeedResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateFeedResult] the created resource
            def self.mutate_feed_result
              require "google/ads/google_ads/v8/services/feed_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateFeedResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_keyword_plan_ad_group_keyword_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateKeywordPlanAdGroupKeywordResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateKeywordPlanAdGroupKeywordResult] the created resource
            def self.mutate_keyword_plan_ad_group_keyword_result
              require "google/ads/google_ads/v8/services/keyword_plan_ad_group_keyword_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateKeywordPlanAdGroupKeywordResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_keyword_plan_ad_group_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateKeywordPlanAdGroupResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateKeywordPlanAdGroupResult] the created resource
            def self.mutate_keyword_plan_ad_group_result
              require "google/ads/google_ads/v8/services/keyword_plan_ad_group_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateKeywordPlanAdGroupResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_keyword_plan_campaign_keyword_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateKeywordPlanCampaignKeywordResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateKeywordPlanCampaignKeywordResult] the created resource
            def self.mutate_keyword_plan_campaign_keyword_result
              require "google/ads/google_ads/v8/services/keyword_plan_campaign_keyword_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateKeywordPlanCampaignKeywordResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_keyword_plan_campaign_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateKeywordPlanCampaignResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateKeywordPlanCampaignResult] the created resource
            def self.mutate_keyword_plan_campaign_result
              require "google/ads/google_ads/v8/services/keyword_plan_campaign_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateKeywordPlanCampaignResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_plan_historical_metrics, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::KeywordPlanHistoricalMetrics] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::KeywordPlanHistoricalMetrics] the created resource
            def self.keyword_plan_historical_metrics
              require "google/ads/google_ads/v8/common/keyword_plan_common_pb"
              res = Google::Ads::GoogleAds::V8::Common::KeywordPlanHistoricalMetrics.new
              yield res if block_given?
              res
            end

            # Returns a new instance of historical_metrics_options, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::HistoricalMetricsOptions] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::HistoricalMetricsOptions] the created resource
            def self.historical_metrics_options
              require "google/ads/google_ads/v8/common/keyword_plan_common_pb"
              res = Google::Ads::GoogleAds::V8::Common::HistoricalMetricsOptions.new
              yield res if block_given?
              res
            end

            # Returns a new instance of monthly_search_volume, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::MonthlySearchVolume] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::MonthlySearchVolume] the created resource
            def self.monthly_search_volume
              require "google/ads/google_ads/v8/common/keyword_plan_common_pb"
              res = Google::Ads::GoogleAds::V8::Common::MonthlySearchVolume.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_plan_aggregate_metrics, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::KeywordPlanAggregateMetrics] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::KeywordPlanAggregateMetrics] the created resource
            def self.keyword_plan_aggregate_metrics
              require "google/ads/google_ads/v8/common/keyword_plan_common_pb"
              res = Google::Ads::GoogleAds::V8::Common::KeywordPlanAggregateMetrics.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_plan_aggregate_metric_results, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::KeywordPlanAggregateMetricResults] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::KeywordPlanAggregateMetricResults] the created resource
            def self.keyword_plan_aggregate_metric_results
              require "google/ads/google_ads/v8/common/keyword_plan_common_pb"
              res = Google::Ads::GoogleAds::V8::Common::KeywordPlanAggregateMetricResults.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_plan_device_searches, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::KeywordPlanDeviceSearches] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::KeywordPlanDeviceSearches] the created resource
            def self.keyword_plan_device_searches
              require "google/ads/google_ads/v8/common/keyword_plan_common_pb"
              res = Google::Ads::GoogleAds::V8::Common::KeywordPlanDeviceSearches.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_annotations, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::KeywordAnnotations] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::KeywordAnnotations] the created resource
            def self.keyword_annotations
              require "google/ads/google_ads/v8/common/keyword_plan_common_pb"
              res = Google::Ads::GoogleAds::V8::Common::KeywordAnnotations.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_concept, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::KeywordConcept] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::KeywordConcept] the created resource
            def self.keyword_concept
              require "google/ads/google_ads/v8/common/keyword_plan_common_pb"
              res = Google::Ads::GoogleAds::V8::Common::KeywordConcept.new
              yield res if block_given?
              res
            end

            # Returns a new instance of concept_group, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::ConceptGroup] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::ConceptGroup] the created resource
            def self.concept_group
              require "google/ads/google_ads/v8/common/keyword_plan_common_pb"
              res = Google::Ads::GoogleAds::V8::Common::ConceptGroup.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_keyword_plans_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateKeywordPlansResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateKeywordPlansResult] the created resource
            def self.mutate_keyword_plans_result
              require "google/ads/google_ads/v8/services/keyword_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateKeywordPlansResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_plan_campaign_forecast, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::KeywordPlanCampaignForecast] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::KeywordPlanCampaignForecast] the created resource
            def self.keyword_plan_campaign_forecast
              require "google/ads/google_ads/v8/services/keyword_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::KeywordPlanCampaignForecast.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_plan_ad_group_forecast, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::KeywordPlanAdGroupForecast] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::KeywordPlanAdGroupForecast] the created resource
            def self.keyword_plan_ad_group_forecast
              require "google/ads/google_ads/v8/services/keyword_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::KeywordPlanAdGroupForecast.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_plan_keyword_forecast, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::KeywordPlanKeywordForecast] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::KeywordPlanKeywordForecast] the created resource
            def self.keyword_plan_keyword_forecast
              require "google/ads/google_ads/v8/services/keyword_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::KeywordPlanKeywordForecast.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_plan_campaign_forecast_curve, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::KeywordPlanCampaignForecastCurve] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::KeywordPlanCampaignForecastCurve] the created resource
            def self.keyword_plan_campaign_forecast_curve
              require "google/ads/google_ads/v8/services/keyword_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::KeywordPlanCampaignForecastCurve.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_plan_max_cpc_bid_forecast_curve, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::KeywordPlanMaxCpcBidForecastCurve] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::KeywordPlanMaxCpcBidForecastCurve] the created resource
            def self.keyword_plan_max_cpc_bid_forecast_curve
              require "google/ads/google_ads/v8/services/keyword_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::KeywordPlanMaxCpcBidForecastCurve.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_plan_max_cpc_bid_forecast, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::KeywordPlanMaxCpcBidForecast] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::KeywordPlanMaxCpcBidForecast] the created resource
            def self.keyword_plan_max_cpc_bid_forecast
              require "google/ads/google_ads/v8/services/keyword_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::KeywordPlanMaxCpcBidForecast.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_plan_weekly_time_series_forecast, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::KeywordPlanWeeklyTimeSeriesForecast] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::KeywordPlanWeeklyTimeSeriesForecast] the created resource
            def self.keyword_plan_weekly_time_series_forecast
              require "google/ads/google_ads/v8/services/keyword_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::KeywordPlanWeeklyTimeSeriesForecast.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_plan_weekly_forecast, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::KeywordPlanWeeklyForecast] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::KeywordPlanWeeklyForecast] the created resource
            def self.keyword_plan_weekly_forecast
              require "google/ads/google_ads/v8/services/keyword_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::KeywordPlanWeeklyForecast.new
              yield res if block_given?
              res
            end

            # Returns a new instance of forecast_metrics, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::ForecastMetrics] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::ForecastMetrics] the created resource
            def self.forecast_metrics
              require "google/ads/google_ads/v8/services/keyword_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::ForecastMetrics.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_plan_keyword_historical_metrics, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::KeywordPlanKeywordHistoricalMetrics] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::KeywordPlanKeywordHistoricalMetrics] the created resource
            def self.keyword_plan_keyword_historical_metrics
              require "google/ads/google_ads/v8/services/keyword_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::KeywordPlanKeywordHistoricalMetrics.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_label_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateLabelResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateLabelResult] the created resource
            def self.mutate_label_result
              require "google/ads/google_ads/v8/services/label_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateLabelResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_media_file_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateMediaFileResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateMediaFileResult] the created resource
            def self.mutate_media_file_result
              require "google/ads/google_ads/v8/services/media_file_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateMediaFileResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_remarketing_action_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateRemarketingActionResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateRemarketingActionResult] the created resource
            def self.mutate_remarketing_action_result
              require "google/ads/google_ads/v8/services/remarketing_action_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateRemarketingActionResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_shared_criterion_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateSharedCriterionResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateSharedCriterionResult] the created resource
            def self.mutate_shared_criterion_result
              require "google/ads/google_ads/v8/services/shared_criterion_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateSharedCriterionResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_shared_set_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateSharedSetResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateSharedSetResult] the created resource
            def self.mutate_shared_set_result
              require "google/ads/google_ads/v8/services/shared_set_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateSharedSetResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_smart_campaign_setting_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateSmartCampaignSettingResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateSmartCampaignSettingResult] the created resource
            def self.mutate_smart_campaign_setting_result
              require "google/ads/google_ads/v8/services/smart_campaign_setting_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateSmartCampaignSettingResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_user_list_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateUserListResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateUserListResult] the created resource
            def self.mutate_user_list_result
              require "google/ads/google_ads/v8/services/user_list_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateUserListResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of google_ads_row, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::GoogleAdsRow] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::GoogleAdsRow] the created resource
            def self.google_ads_row
              require "google/ads/google_ads/v8/services/google_ads_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::GoogleAdsRow.new
              yield res if block_given?
              res
            end

            # Returns a new instance of location_names, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::SuggestGeoTargetConstantsRequest::LocationNames] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::SuggestGeoTargetConstantsRequest::LocationNames] the created resource
            def self.location_names
              require "google/ads/google_ads/v8/services/geo_target_constant_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::SuggestGeoTargetConstantsRequest::LocationNames.new
              yield res if block_given?
              res
            end

            # Returns a new instance of geo_targets, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::SuggestGeoTargetConstantsRequest::GeoTargets] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::SuggestGeoTargetConstantsRequest::GeoTargets] the created resource
            def self.geo_targets
              require "google/ads/google_ads/v8/services/geo_target_constant_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::SuggestGeoTargetConstantsRequest::GeoTargets.new
              yield res if block_given?
              res
            end

            # Returns a new instance of geo_target_constant_suggestion, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::GeoTargetConstantSuggestion] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::GeoTargetConstantSuggestion] the created resource
            def self.geo_target_constant_suggestion
              require "google/ads/google_ads/v8/services/geo_target_constant_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::GeoTargetConstantSuggestion.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_batch_job_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateBatchJobResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateBatchJobResult] the created resource
            def self.mutate_batch_job_result
              require "google/ads/google_ads/v8/services/batch_job_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateBatchJobResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of batch_job_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::BatchJobResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::BatchJobResult] the created resource
            def self.batch_job_result
              require "google/ads/google_ads/v8/services/batch_job_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::BatchJobResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_account_budget_proposal_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateAccountBudgetProposalResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateAccountBudgetProposalResult] the created resource
            def self.mutate_account_budget_proposal_result
              require "google/ads/google_ads/v8/services/account_budget_proposal_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateAccountBudgetProposalResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_billing_setup_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateBillingSetupResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateBillingSetupResult] the created resource
            def self.mutate_billing_setup_result
              require "google/ads/google_ads/v8/services/billing_setup_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateBillingSetupResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of click_conversion, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::ClickConversion] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::ClickConversion] the created resource
            def self.click_conversion
              require "google/ads/google_ads/v8/services/conversion_upload_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::ClickConversion.new
              yield res if block_given?
              res
            end

            # Returns a new instance of call_conversion, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::CallConversion] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::CallConversion] the created resource
            def self.call_conversion
              require "google/ads/google_ads/v8/services/conversion_upload_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::CallConversion.new
              yield res if block_given?
              res
            end

            # Returns a new instance of external_attribution_data, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::ExternalAttributionData] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::ExternalAttributionData] the created resource
            def self.external_attribution_data
              require "google/ads/google_ads/v8/services/conversion_upload_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::ExternalAttributionData.new
              yield res if block_given?
              res
            end

            # Returns a new instance of click_conversion_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::ClickConversionResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::ClickConversionResult] the created resource
            def self.click_conversion_result
              require "google/ads/google_ads/v8/services/conversion_upload_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::ClickConversionResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of call_conversion_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::CallConversionResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::CallConversionResult] the created resource
            def self.call_conversion_result
              require "google/ads/google_ads/v8/services/conversion_upload_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::CallConversionResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of custom_variable, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::CustomVariable] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::CustomVariable] the created resource
            def self.custom_variable
              require "google/ads/google_ads/v8/services/conversion_upload_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::CustomVariable.new
              yield res if block_given?
              res
            end

            # Returns a new instance of cart_data, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::CartData] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::CartData] the created resource
            def self.cart_data
              require "google/ads/google_ads/v8/services/conversion_upload_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::CartData.new
              yield res if block_given?
              res
            end

            # Returns a new instance of item, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::CartData::Item] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::CartData::Item] the created resource
            def self.item
              require "google/ads/google_ads/v8/services/conversion_upload_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::CartData::Item.new
              yield res if block_given?
              res
            end

            # Returns a new instance of plannable_location, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::PlannableLocation] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::PlannableLocation] the created resource
            def self.plannable_location
              require "google/ads/google_ads/v8/services/reach_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::PlannableLocation.new
              yield res if block_given?
              res
            end

            # Returns a new instance of product_metadata, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::ProductMetadata] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::ProductMetadata] the created resource
            def self.product_metadata
              require "google/ads/google_ads/v8/services/reach_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::ProductMetadata.new
              yield res if block_given?
              res
            end

            # Returns a new instance of plannable_targeting, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::PlannableTargeting] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::PlannableTargeting] the created resource
            def self.plannable_targeting
              require "google/ads/google_ads/v8/services/reach_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::PlannableTargeting.new
              yield res if block_given?
              res
            end

            # Returns a new instance of preferences, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::Preferences] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::Preferences] the created resource
            def self.preferences
              require "google/ads/google_ads/v8/services/reach_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::Preferences.new
              yield res if block_given?
              res
            end

            # Returns a new instance of product_allocation, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::ProductAllocation] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::ProductAllocation] the created resource
            def self.product_allocation
              require "google/ads/google_ads/v8/services/reach_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::ProductAllocation.new
              yield res if block_given?
              res
            end

            # Returns a new instance of effective_frequency_limit, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::EffectiveFrequencyLimit] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::EffectiveFrequencyLimit] the created resource
            def self.effective_frequency_limit
              require "google/ads/google_ads/v8/services/reach_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::EffectiveFrequencyLimit.new
              yield res if block_given?
              res
            end

            # Returns a new instance of frequency_cap, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::FrequencyCap] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::FrequencyCap] the created resource
            def self.frequency_cap
              require "google/ads/google_ads/v8/services/reach_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::FrequencyCap.new
              yield res if block_given?
              res
            end

            # Returns a new instance of targeting, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::Targeting] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::Targeting] the created resource
            def self.targeting
              require "google/ads/google_ads/v8/services/reach_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::Targeting.new
              yield res if block_given?
              res
            end

            # Returns a new instance of campaign_duration, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::CampaignDuration] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::CampaignDuration] the created resource
            def self.campaign_duration
              require "google/ads/google_ads/v8/services/reach_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::CampaignDuration.new
              yield res if block_given?
              res
            end

            # Returns a new instance of planned_product, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::PlannedProduct] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::PlannedProduct] the created resource
            def self.planned_product
              require "google/ads/google_ads/v8/services/reach_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::PlannedProduct.new
              yield res if block_given?
              res
            end

            # Returns a new instance of reach_curve, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::ReachCurve] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::ReachCurve] the created resource
            def self.reach_curve
              require "google/ads/google_ads/v8/services/reach_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::ReachCurve.new
              yield res if block_given?
              res
            end

            # Returns a new instance of reach_forecast, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::ReachForecast] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::ReachForecast] the created resource
            def self.reach_forecast
              require "google/ads/google_ads/v8/services/reach_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::ReachForecast.new
              yield res if block_given?
              res
            end

            # Returns a new instance of forecast, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::Forecast] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::Forecast] the created resource
            def self.forecast
              require "google/ads/google_ads/v8/services/reach_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::Forecast.new
              yield res if block_given?
              res
            end

            # Returns a new instance of planned_product_reach_forecast, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::PlannedProductReachForecast] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::PlannedProductReachForecast] the created resource
            def self.planned_product_reach_forecast
              require "google/ads/google_ads/v8/services/reach_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::PlannedProductReachForecast.new
              yield res if block_given?
              res
            end

            # Returns a new instance of planned_product_forecast, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::PlannedProductForecast] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::PlannedProductForecast] the created resource
            def self.planned_product_forecast
              require "google/ads/google_ads/v8/services/reach_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::PlannedProductForecast.new
              yield res if block_given?
              res
            end

            # Returns a new instance of on_target_audience_metrics, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::OnTargetAudienceMetrics] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::OnTargetAudienceMetrics] the created resource
            def self.on_target_audience_metrics
              require "google/ads/google_ads/v8/services/reach_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::OnTargetAudienceMetrics.new
              yield res if block_given?
              res
            end

            # Returns a new instance of effective_frequency_breakdown, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::EffectiveFrequencyBreakdown] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::EffectiveFrequencyBreakdown] the created resource
            def self.effective_frequency_breakdown
              require "google/ads/google_ads/v8/services/reach_plan_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::EffectiveFrequencyBreakdown.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_customer_user_access_invitation_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateCustomerUserAccessInvitationResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateCustomerUserAccessInvitationResult] the created resource
            def self.mutate_customer_user_access_invitation_result
              require "google/ads/google_ads/v8/services/customer_user_access_invitation_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateCustomerUserAccessInvitationResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_customer_client_link_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateCustomerClientLinkResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateCustomerClientLinkResult] the created resource
            def self.mutate_customer_client_link_result
              require "google/ads/google_ads/v8/services/customer_client_link_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateCustomerClientLinkResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_account_link_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateAccountLinkResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateAccountLinkResult] the created resource
            def self.mutate_account_link_result
              require "google/ads/google_ads/v8/services/account_link_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateAccountLinkResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_and_url_seed, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::KeywordAndUrlSeed] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::KeywordAndUrlSeed] the created resource
            def self.keyword_and_url_seed
              require "google/ads/google_ads/v8/services/keyword_plan_idea_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::KeywordAndUrlSeed.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_seed, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::KeywordSeed] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::KeywordSeed] the created resource
            def self.keyword_seed
              require "google/ads/google_ads/v8/services/keyword_plan_idea_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::KeywordSeed.new
              yield res if block_given?
              res
            end

            # Returns a new instance of site_seed, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::SiteSeed] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::SiteSeed] the created resource
            def self.site_seed
              require "google/ads/google_ads/v8/services/keyword_plan_idea_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::SiteSeed.new
              yield res if block_given?
              res
            end

            # Returns a new instance of url_seed, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::UrlSeed] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::UrlSeed] the created resource
            def self.url_seed
              require "google/ads/google_ads/v8/services/keyword_plan_idea_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::UrlSeed.new
              yield res if block_given?
              res
            end

            # Returns a new instance of generate_keyword_idea_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::GenerateKeywordIdeaResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::GenerateKeywordIdeaResult] the created resource
            def self.generate_keyword_idea_result
              require "google/ads/google_ads/v8/services/keyword_plan_idea_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::GenerateKeywordIdeaResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_customer_manager_link_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateCustomerManagerLinkResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateCustomerManagerLinkResult] the created resource
            def self.mutate_customer_manager_link_result
              require "google/ads/google_ads/v8/services/customer_manager_link_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateCustomerManagerLinkResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_customer_user_access_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateCustomerUserAccessResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateCustomerUserAccessResult] the created resource
            def self.mutate_customer_user_access_result
              require "google/ads/google_ads/v8/services/customer_user_access_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateCustomerUserAccessResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of conversion_adjustment, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::ConversionAdjustment] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::ConversionAdjustment] the created resource
            def self.conversion_adjustment
              require "google/ads/google_ads/v8/services/conversion_adjustment_upload_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::ConversionAdjustment.new
              yield res if block_given?
              res
            end

            # Returns a new instance of restatement_value, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::RestatementValue] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::RestatementValue] the created resource
            def self.restatement_value
              require "google/ads/google_ads/v8/services/conversion_adjustment_upload_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::RestatementValue.new
              yield res if block_given?
              res
            end

            # Returns a new instance of gclid_date_time_pair, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::GclidDateTimePair] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::GclidDateTimePair] the created resource
            def self.gclid_date_time_pair
              require "google/ads/google_ads/v8/services/conversion_adjustment_upload_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::GclidDateTimePair.new
              yield res if block_given?
              res
            end

            # Returns a new instance of conversion_adjustment_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::ConversionAdjustmentResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::ConversionAdjustmentResult] the created resource
            def self.conversion_adjustment_result
              require "google/ads/google_ads/v8/services/conversion_adjustment_upload_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::ConversionAdjustmentResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_merchant_center_link_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateMerchantCenterLinkResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateMerchantCenterLinkResult] the created resource
            def self.mutate_merchant_center_link_result
              require "google/ads/google_ads/v8/services/merchant_center_link_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateMerchantCenterLinkResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_custom_audience_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateCustomAudienceResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateCustomAudienceResult] the created resource
            def self.mutate_custom_audience_result
              require "google/ads/google_ads/v8/services/custom_audience_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateCustomAudienceResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of smart_campaign_suggestion_info, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::SmartCampaignSuggestionInfo] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::SmartCampaignSuggestionInfo] the created resource
            def self.smart_campaign_suggestion_info
              require "google/ads/google_ads/v8/services/smart_campaign_suggest_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::SmartCampaignSuggestionInfo.new
              yield res if block_given?
              res
            end

            # Returns a new instance of location_list, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::SmartCampaignSuggestionInfo::LocationList] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::SmartCampaignSuggestionInfo::LocationList] the created resource
            def self.location_list
              require "google/ads/google_ads/v8/services/smart_campaign_suggest_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::SmartCampaignSuggestionInfo::LocationList.new
              yield res if block_given?
              res
            end

            # Returns a new instance of business_context, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::SmartCampaignSuggestionInfo::BusinessContext] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::SmartCampaignSuggestionInfo::BusinessContext] the created resource
            def self.business_context
              require "google/ads/google_ads/v8/services/smart_campaign_suggest_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::SmartCampaignSuggestionInfo::BusinessContext.new
              yield res if block_given?
              res
            end

            # Returns a new instance of suggest_smart_campaign_budget_options_response_metrics, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::SuggestSmartCampaignBudgetOptionsResponse::Metrics] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::SuggestSmartCampaignBudgetOptionsResponse::Metrics] the created resource
            def self.suggest_smart_campaign_budget_options_response_metrics
              require "google/ads/google_ads/v8/services/smart_campaign_suggest_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::SuggestSmartCampaignBudgetOptionsResponse::Metrics.new
              yield res if block_given?
              res
            end

            # Returns a new instance of budget_option, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::SuggestSmartCampaignBudgetOptionsResponse::BudgetOption] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::SuggestSmartCampaignBudgetOptionsResponse::BudgetOption] the created resource
            def self.budget_option
              require "google/ads/google_ads/v8/services/smart_campaign_suggest_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::SuggestSmartCampaignBudgetOptionsResponse::BudgetOption.new
              yield res if block_given?
              res
            end

            # Returns a new instance of mutate_custom_interest_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::MutateCustomInterestResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::MutateCustomInterestResult] the created resource
            def self.mutate_custom_interest_result
              require "google/ads/google_ads/v8/services/custom_interest_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::MutateCustomInterestResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of campaign_budget_parameters, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::CampaignBudgetParameters] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::CampaignBudgetParameters] the created resource
            def self.campaign_budget_parameters
              require "google/ads/google_ads/v8/services/recommendation_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::CampaignBudgetParameters.new
              yield res if block_given?
              res
            end

            # Returns a new instance of text_ad_parameters, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::TextAdParameters] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::TextAdParameters] the created resource
            def self.text_ad_parameters
              require "google/ads/google_ads/v8/services/recommendation_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::TextAdParameters.new
              yield res if block_given?
              res
            end

            # Returns a new instance of keyword_parameters, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::KeywordParameters] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::KeywordParameters] the created resource
            def self.keyword_parameters
              require "google/ads/google_ads/v8/services/recommendation_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::KeywordParameters.new
              yield res if block_given?
              res
            end

            # Returns a new instance of target_cpa_opt_in_parameters, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::TargetCpaOptInParameters] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::TargetCpaOptInParameters] the created resource
            def self.target_cpa_opt_in_parameters
              require "google/ads/google_ads/v8/services/recommendation_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::TargetCpaOptInParameters.new
              yield res if block_given?
              res
            end

            # Returns a new instance of target_roas_opt_in_parameters, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::TargetRoasOptInParameters] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::TargetRoasOptInParameters] the created resource
            def self.target_roas_opt_in_parameters
              require "google/ads/google_ads/v8/services/recommendation_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::TargetRoasOptInParameters.new
              yield res if block_given?
              res
            end

            # Returns a new instance of callout_extension_parameters, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::CalloutExtensionParameters] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::CalloutExtensionParameters] the created resource
            def self.callout_extension_parameters
              require "google/ads/google_ads/v8/services/recommendation_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::CalloutExtensionParameters.new
              yield res if block_given?
              res
            end

            # Returns a new instance of call_extension_parameters, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::CallExtensionParameters] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::CallExtensionParameters] the created resource
            def self.call_extension_parameters
              require "google/ads/google_ads/v8/services/recommendation_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::CallExtensionParameters.new
              yield res if block_given?
              res
            end

            # Returns a new instance of sitelink_extension_parameters, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::SitelinkExtensionParameters] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::SitelinkExtensionParameters] the created resource
            def self.sitelink_extension_parameters
              require "google/ads/google_ads/v8/services/recommendation_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::SitelinkExtensionParameters.new
              yield res if block_given?
              res
            end

            # Returns a new instance of move_unused_budget_parameters, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::MoveUnusedBudgetParameters] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::MoveUnusedBudgetParameters] the created resource
            def self.move_unused_budget_parameters
              require "google/ads/google_ads/v8/services/recommendation_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::MoveUnusedBudgetParameters.new
              yield res if block_given?
              res
            end

            # Returns a new instance of responsive_search_ad_parameters, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::ResponsiveSearchAdParameters] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::ResponsiveSearchAdParameters] the created resource
            def self.responsive_search_ad_parameters
              require "google/ads/google_ads/v8/services/recommendation_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::ApplyRecommendationOperation::ResponsiveSearchAdParameters.new
              yield res if block_given?
              res
            end

            # Returns a new instance of apply_recommendation_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::ApplyRecommendationResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::ApplyRecommendationResult] the created resource
            def self.apply_recommendation_result
              require "google/ads/google_ads/v8/services/recommendation_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::ApplyRecommendationResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of dismiss_recommendation_result, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Services::DismissRecommendationResponse::DismissRecommendationResult] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Services::DismissRecommendationResponse::DismissRecommendationResult] the created resource
            def self.dismiss_recommendation_result
              require "google/ads/google_ads/v8/services/recommendation_service_pb"
              res = Google::Ads::GoogleAds::V8::Services::DismissRecommendationResponse::DismissRecommendationResult.new
              yield res if block_given?
              res
            end

            # Returns a new instance of value, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Common::Value] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Common::Value] the created resource
            def self.value
              require "google/ads/google_ads/v8/common/value_pb"
              res = Google::Ads::GoogleAds::V8::Common::Value.new
              yield res if block_given?
              res
            end

            # Returns a new instance of google_ads_failure, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Errors::GoogleAdsFailure] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Errors::GoogleAdsFailure] the created resource
            def self.google_ads_failure
              require "google/ads/google_ads/v8/errors/errors_pb"
              res = Google::Ads::GoogleAds::V8::Errors::GoogleAdsFailure.new
              yield res if block_given?
              res
            end

            # Returns a new instance of google_ads_error, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Errors::GoogleAdsError] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Errors::GoogleAdsError] the created resource
            def self.google_ads_error
              require "google/ads/google_ads/v8/errors/errors_pb"
              res = Google::Ads::GoogleAds::V8::Errors::GoogleAdsError.new
              yield res if block_given?
              res
            end

            # Returns a new instance of error_code, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Errors::ErrorCode] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Errors::ErrorCode] the created resource
            def self.error_code
              require "google/ads/google_ads/v8/errors/errors_pb"
              res = Google::Ads::GoogleAds::V8::Errors::ErrorCode.new
              yield res if block_given?
              res
            end

            # Returns a new instance of error_location, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Errors::ErrorLocation] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Errors::ErrorLocation] the created resource
            def self.error_location
              require "google/ads/google_ads/v8/errors/errors_pb"
              res = Google::Ads::GoogleAds::V8::Errors::ErrorLocation.new
              yield res if block_given?
              res
            end

            # Returns a new instance of field_path_element, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Errors::ErrorLocation::FieldPathElement] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Errors::ErrorLocation::FieldPathElement] the created resource
            def self.field_path_element
              require "google/ads/google_ads/v8/errors/errors_pb"
              res = Google::Ads::GoogleAds::V8::Errors::ErrorLocation::FieldPathElement.new
              yield res if block_given?
              res
            end

            # Returns a new instance of error_details, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Errors::ErrorDetails] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Errors::ErrorDetails] the created resource
            def self.error_details
              require "google/ads/google_ads/v8/errors/errors_pb"
              res = Google::Ads::GoogleAds::V8::Errors::ErrorDetails.new
              yield res if block_given?
              res
            end

            # Returns a new instance of policy_violation_details, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Errors::PolicyViolationDetails] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Errors::PolicyViolationDetails] the created resource
            def self.policy_violation_details
              require "google/ads/google_ads/v8/errors/errors_pb"
              res = Google::Ads::GoogleAds::V8::Errors::PolicyViolationDetails.new
              yield res if block_given?
              res
            end

            # Returns a new instance of policy_finding_details, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Errors::PolicyFindingDetails] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Errors::PolicyFindingDetails] the created resource
            def self.policy_finding_details
              require "google/ads/google_ads/v8/errors/errors_pb"
              res = Google::Ads::GoogleAds::V8::Errors::PolicyFindingDetails.new
              yield res if block_given?
              res
            end

            # Returns a new instance of quota_error_details, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Errors::QuotaErrorDetails] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Errors::QuotaErrorDetails] the created resource
            def self.quota_error_details
              require "google/ads/google_ads/v8/errors/errors_pb"
              res = Google::Ads::GoogleAds::V8::Errors::QuotaErrorDetails.new
              yield res if block_given?
              res
            end

            # Returns a new instance of resource_count_details, optionally
            # yielding it to a passed block so that attributes can be set on it.
            #
            # @yield [Google::Ads::GoogleAds::V8::Errors::ResourceCountDetails] the new instance that will be returned so attributes
            #  can be set
            # @return [Google::Ads::GoogleAds::V8::Errors::ResourceCountDetails] the created resource
            def self.resource_count_details
              require "google/ads/google_ads/v8/errors/errors_pb"
              res = Google::Ads::GoogleAds::V8::Errors::ResourceCountDetails.new
              yield res if block_given?
              res
            end
          end
        end
      end
    end
  end
end
